/* A Bison parser, made by GNU Bison 3.7.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30704

/* Bison version string.  */
#define YYBISON_VERSION "3.7.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cppyyparse
#define yylex           cppyylex
#define yyerror         cppyyerror
#define yydebug         cppyydebug
#define yynerrs         cppyynerrs

/* First part of user prologue.  */
#line 7 "dtool/src/cppparser/cppBison.yxx"


#include "cppBisonDefs.h"
#include "cppParser.h"
#include "cppClosureType.h"
#include "cppExpression.h"
#include "cppSimpleType.h"
#include "cppExtensionType.h"
#include "cppStructType.h"
#include "cppEnumType.h"
#include "cppFunctionType.h"
#include "cppTBDType.h"
#include "cppMakeProperty.h"
#include "cppMakeSeq.h"
#include "cppParameterList.h"
#include "cppInstance.h"
#include "cppClassTemplateParameter.h"
#include "cppTemplateParameterList.h"
#include "cppInstanceIdentifier.h"
#include "cppTypedefType.h"
#include "cppTypeDeclaration.h"
#include "cppVisibility.h"
#include "cppIdentifier.h"
#include "cppScope.h"
#include "cppTemplateScope.h"
#include "cppNamespace.h"
#include "cppUsing.h"

using std::stringstream;
using std::string;

////////////////////////////////////////////////////////////////////
// Defining the interface to the parser.
////////////////////////////////////////////////////////////////////

CPPScope *current_scope = nullptr;
CPPScope *global_scope = nullptr;
CPPPreprocessor *current_lexer = nullptr;

static CPPStructType *current_struct = nullptr;
static CPPEnumType *current_enum = nullptr;
static int current_storage_class = 0;
static CPPType *current_type = nullptr;
static CPPExpression *current_expr = nullptr;
static int publish_nest_level = 0;
static CPPVisibility publish_previous;
static YYLTYPE publish_loc;

static std::vector<CPPScope *> last_scopes;
static std::vector<int> last_storage_classes;
static std::vector<CPPStructType *> last_structs;

int yyparse();

#define YYERROR_VERBOSE

static void
yyerror(const string &msg) {
  current_lexer->error(msg, current_lexer->_last_token_loc);
}

static void
yyerror(YYLTYPE *loc, const string &msg) {
  current_lexer->error(msg, *loc);
}

static void
yyerror(const string &msg, YYLTYPE &loc) {
  current_lexer->error(msg, loc);
}

static void
yywarning(const string &msg, YYLTYPE &loc) {
  current_lexer->warning(msg, loc);
}

static int
yylex(YYSTYPE *lval, YYLTYPE *lloc) {
  CPPToken token = current_lexer->get_next_token();
  *lval = token._lval;
  *lloc = token._lloc;
  return token._token;
}

void
parse_cpp(CPPParser *cp) {
  CPPScope *old_scope = current_scope;
  CPPScope *old_global_scope = global_scope;
  CPPPreprocessor *old_lexer = current_lexer;

  current_scope = cp;
  global_scope = cp;
  current_lexer = cp;
  publish_nest_level = 0;
  yyparse();

  if (publish_nest_level != 0) {
    yyerror("Unclosed __begin_publish", publish_loc);
    publish_nest_level = 0;
  }

  current_scope = old_scope;
  global_scope = old_global_scope;
  current_lexer = old_lexer;

}

CPPExpression *
parse_const_expr(CPPPreprocessor *pp, CPPScope *new_current_scope,
                 CPPScope *new_global_scope) {
  CPPScope *old_scope = current_scope;
  CPPScope *old_global_scope = global_scope;
  CPPPreprocessor *old_lexer = current_lexer;
  CPPExpression *old_expr = current_expr;

  current_scope = new_current_scope;
  global_scope = new_global_scope;
  current_expr = nullptr;
  current_lexer = pp;
  yyparse();

  CPPExpression *result = current_expr;

  current_scope = old_scope;
  global_scope = old_global_scope;
  current_lexer = old_lexer;
  current_expr = old_expr;

  return result;
}

CPPType *
parse_type(CPPPreprocessor *pp, CPPScope *new_current_scope,
           CPPScope *new_global_scope) {
  CPPScope *old_scope = current_scope;
  CPPScope *old_global_scope = global_scope;
  CPPPreprocessor *old_lexer = current_lexer;
  CPPType *old_type = current_type;

  current_scope = new_current_scope;
  global_scope = new_global_scope;
  current_type = nullptr;
  current_lexer = pp;
  yyparse();

  CPPType *result = current_type;

  current_scope = old_scope;
  global_scope = old_global_scope;
  current_lexer = old_lexer;
  current_type = old_type;

  return result;
}

static void
push_scope(CPPScope *new_scope) {
  last_scopes.push_back(current_scope);
  if (new_scope != nullptr) {
    current_scope = new_scope;
  }
}

static void
pop_scope() {
  assert(!last_scopes.empty());
  current_scope = last_scopes.back();
  last_scopes.pop_back();
}

static void
push_storage_class(int new_storage_class) {
  last_storage_classes.push_back(current_storage_class);
  current_storage_class = new_storage_class;
}

static void
pop_storage_class() {
  assert(!last_storage_classes.empty());
  current_storage_class = last_storage_classes.back();
  last_storage_classes.pop_back();
}

static void
push_struct(CPPStructType *new_struct) {
  last_structs.push_back(current_struct);
  current_struct = new_struct;
}

static void
pop_struct() {
  assert(!last_structs.empty());
  current_struct = last_structs.back();
  last_structs.pop_back();
}


#line 274 "built/tmp/cppBison.yxx.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "cppBison.yxx.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_REAL = 3,                       /* REAL  */
  YYSYMBOL_INTEGER = 4,                    /* INTEGER  */
  YYSYMBOL_CHAR_TOK = 5,                   /* CHAR_TOK  */
  YYSYMBOL_SIMPLE_STRING = 6,              /* SIMPLE_STRING  */
  YYSYMBOL_SIMPLE_IDENTIFIER = 7,          /* SIMPLE_IDENTIFIER  */
  YYSYMBOL_STRING_LITERAL = 8,             /* STRING_LITERAL  */
  YYSYMBOL_CUSTOM_LITERAL = 9,             /* CUSTOM_LITERAL  */
  YYSYMBOL_IDENTIFIER = 10,                /* IDENTIFIER  */
  YYSYMBOL_TYPENAME_IDENTIFIER = 11,       /* TYPENAME_IDENTIFIER  */
  YYSYMBOL_TYPEPACK_IDENTIFIER = 12,       /* TYPEPACK_IDENTIFIER  */
  YYSYMBOL_SCOPING = 13,                   /* SCOPING  */
  YYSYMBOL_TYPEDEFNAME = 14,               /* TYPEDEFNAME  */
  YYSYMBOL_ELLIPSIS = 15,                  /* ELLIPSIS  */
  YYSYMBOL_OROR = 16,                      /* OROR  */
  YYSYMBOL_ANDAND = 17,                    /* ANDAND  */
  YYSYMBOL_EQCOMPARE = 18,                 /* EQCOMPARE  */
  YYSYMBOL_NECOMPARE = 19,                 /* NECOMPARE  */
  YYSYMBOL_LECOMPARE = 20,                 /* LECOMPARE  */
  YYSYMBOL_GECOMPARE = 21,                 /* GECOMPARE  */
  YYSYMBOL_LSHIFT = 22,                    /* LSHIFT  */
  YYSYMBOL_RSHIFT = 23,                    /* RSHIFT  */
  YYSYMBOL_POINTSAT_STAR = 24,             /* POINTSAT_STAR  */
  YYSYMBOL_DOT_STAR = 25,                  /* DOT_STAR  */
  YYSYMBOL_UNARY = 26,                     /* UNARY  */
  YYSYMBOL_UNARY_NOT = 27,                 /* UNARY_NOT  */
  YYSYMBOL_UNARY_NEGATE = 28,              /* UNARY_NEGATE  */
  YYSYMBOL_UNARY_MINUS = 29,               /* UNARY_MINUS  */
  YYSYMBOL_UNARY_PLUS = 30,                /* UNARY_PLUS  */
  YYSYMBOL_UNARY_STAR = 31,                /* UNARY_STAR  */
  YYSYMBOL_UNARY_REF = 32,                 /* UNARY_REF  */
  YYSYMBOL_POINTSAT = 33,                  /* POINTSAT  */
  YYSYMBOL_SCOPE = 34,                     /* SCOPE  */
  YYSYMBOL_PLUSPLUS = 35,                  /* PLUSPLUS  */
  YYSYMBOL_MINUSMINUS = 36,                /* MINUSMINUS  */
  YYSYMBOL_TIMESEQUAL = 37,                /* TIMESEQUAL  */
  YYSYMBOL_DIVIDEEQUAL = 38,               /* DIVIDEEQUAL  */
  YYSYMBOL_MODEQUAL = 39,                  /* MODEQUAL  */
  YYSYMBOL_PLUSEQUAL = 40,                 /* PLUSEQUAL  */
  YYSYMBOL_MINUSEQUAL = 41,                /* MINUSEQUAL  */
  YYSYMBOL_OREQUAL = 42,                   /* OREQUAL  */
  YYSYMBOL_ANDEQUAL = 43,                  /* ANDEQUAL  */
  YYSYMBOL_XOREQUAL = 44,                  /* XOREQUAL  */
  YYSYMBOL_LSHIFTEQUAL = 45,               /* LSHIFTEQUAL  */
  YYSYMBOL_RSHIFTEQUAL = 46,               /* RSHIFTEQUAL  */
  YYSYMBOL_ATTR_LEFT = 47,                 /* ATTR_LEFT  */
  YYSYMBOL_ATTR_RIGHT = 48,                /* ATTR_RIGHT  */
  YYSYMBOL_KW_ALIGNAS = 49,                /* KW_ALIGNAS  */
  YYSYMBOL_KW_ALIGNOF = 50,                /* KW_ALIGNOF  */
  YYSYMBOL_KW_AUTO = 51,                   /* KW_AUTO  */
  YYSYMBOL_KW_BEGIN_PUBLISH = 52,          /* KW_BEGIN_PUBLISH  */
  YYSYMBOL_KW_BLOCKING = 53,               /* KW_BLOCKING  */
  YYSYMBOL_KW_BOOL = 54,                   /* KW_BOOL  */
  YYSYMBOL_KW_CATCH = 55,                  /* KW_CATCH  */
  YYSYMBOL_KW_CHAR = 56,                   /* KW_CHAR  */
  YYSYMBOL_KW_CHAR16_T = 57,               /* KW_CHAR16_T  */
  YYSYMBOL_KW_CHAR32_T = 58,               /* KW_CHAR32_T  */
  YYSYMBOL_KW_CLASS = 59,                  /* KW_CLASS  */
  YYSYMBOL_KW_CONST = 60,                  /* KW_CONST  */
  YYSYMBOL_KW_CONSTEXPR = 61,              /* KW_CONSTEXPR  */
  YYSYMBOL_KW_CONST_CAST = 62,             /* KW_CONST_CAST  */
  YYSYMBOL_KW_DECLTYPE = 63,               /* KW_DECLTYPE  */
  YYSYMBOL_KW_DEFAULT = 64,                /* KW_DEFAULT  */
  YYSYMBOL_KW_DELETE = 65,                 /* KW_DELETE  */
  YYSYMBOL_KW_DOUBLE = 66,                 /* KW_DOUBLE  */
  YYSYMBOL_KW_DYNAMIC_CAST = 67,           /* KW_DYNAMIC_CAST  */
  YYSYMBOL_KW_ELSE = 68,                   /* KW_ELSE  */
  YYSYMBOL_KW_END_PUBLISH = 69,            /* KW_END_PUBLISH  */
  YYSYMBOL_KW_ENUM = 70,                   /* KW_ENUM  */
  YYSYMBOL_KW_EXTENSION = 71,              /* KW_EXTENSION  */
  YYSYMBOL_KW_EXTERN = 72,                 /* KW_EXTERN  */
  YYSYMBOL_KW_EXPLICIT = 73,               /* KW_EXPLICIT  */
  YYSYMBOL_KW_PUBLISHED = 74,              /* KW_PUBLISHED  */
  YYSYMBOL_KW_FALSE = 75,                  /* KW_FALSE  */
  YYSYMBOL_KW_FINAL = 76,                  /* KW_FINAL  */
  YYSYMBOL_KW_FLOAT = 77,                  /* KW_FLOAT  */
  YYSYMBOL_KW_FRIEND = 78,                 /* KW_FRIEND  */
  YYSYMBOL_KW_FOR = 79,                    /* KW_FOR  */
  YYSYMBOL_KW_GOTO = 80,                   /* KW_GOTO  */
  YYSYMBOL_KW_HAS_VIRTUAL_DESTRUCTOR = 81, /* KW_HAS_VIRTUAL_DESTRUCTOR  */
  YYSYMBOL_KW_IF = 82,                     /* KW_IF  */
  YYSYMBOL_KW_INLINE = 83,                 /* KW_INLINE  */
  YYSYMBOL_KW_INT = 84,                    /* KW_INT  */
  YYSYMBOL_KW_IS_ABSTRACT = 85,            /* KW_IS_ABSTRACT  */
  YYSYMBOL_KW_IS_BASE_OF = 86,             /* KW_IS_BASE_OF  */
  YYSYMBOL_KW_IS_CLASS = 87,               /* KW_IS_CLASS  */
  YYSYMBOL_KW_IS_CONSTRUCTIBLE = 88,       /* KW_IS_CONSTRUCTIBLE  */
  YYSYMBOL_KW_IS_CONVERTIBLE_TO = 89,      /* KW_IS_CONVERTIBLE_TO  */
  YYSYMBOL_KW_IS_DESTRUCTIBLE = 90,        /* KW_IS_DESTRUCTIBLE  */
  YYSYMBOL_KW_IS_EMPTY = 91,               /* KW_IS_EMPTY  */
  YYSYMBOL_KW_IS_ENUM = 92,                /* KW_IS_ENUM  */
  YYSYMBOL_KW_IS_FINAL = 93,               /* KW_IS_FINAL  */
  YYSYMBOL_KW_IS_FUNDAMENTAL = 94,         /* KW_IS_FUNDAMENTAL  */
  YYSYMBOL_KW_IS_POD = 95,                 /* KW_IS_POD  */
  YYSYMBOL_KW_IS_POLYMORPHIC = 96,         /* KW_IS_POLYMORPHIC  */
  YYSYMBOL_KW_IS_STANDARD_LAYOUT = 97,     /* KW_IS_STANDARD_LAYOUT  */
  YYSYMBOL_KW_IS_TRIVIAL = 98,             /* KW_IS_TRIVIAL  */
  YYSYMBOL_KW_IS_UNION = 99,               /* KW_IS_UNION  */
  YYSYMBOL_KW_LONG = 100,                  /* KW_LONG  */
  YYSYMBOL_KW_MAKE_MAP_KEYS_SEQ = 101,     /* KW_MAKE_MAP_KEYS_SEQ  */
  YYSYMBOL_KW_MAKE_MAP_PROPERTY = 102,     /* KW_MAKE_MAP_PROPERTY  */
  YYSYMBOL_KW_MAKE_PROPERTY = 103,         /* KW_MAKE_PROPERTY  */
  YYSYMBOL_KW_MAKE_PROPERTY2 = 104,        /* KW_MAKE_PROPERTY2  */
  YYSYMBOL_KW_MAKE_SEQ = 105,              /* KW_MAKE_SEQ  */
  YYSYMBOL_KW_MAKE_SEQ_PROPERTY = 106,     /* KW_MAKE_SEQ_PROPERTY  */
  YYSYMBOL_KW_MUTABLE = 107,               /* KW_MUTABLE  */
  YYSYMBOL_KW_NAMESPACE = 108,             /* KW_NAMESPACE  */
  YYSYMBOL_KW_NEW = 109,                   /* KW_NEW  */
  YYSYMBOL_KW_NOEXCEPT = 110,              /* KW_NOEXCEPT  */
  YYSYMBOL_KW_NULLPTR = 111,               /* KW_NULLPTR  */
  YYSYMBOL_KW_OPERATOR = 112,              /* KW_OPERATOR  */
  YYSYMBOL_KW_OVERRIDE = 113,              /* KW_OVERRIDE  */
  YYSYMBOL_KW_PRIVATE = 114,               /* KW_PRIVATE  */
  YYSYMBOL_KW_PROTECTED = 115,             /* KW_PROTECTED  */
  YYSYMBOL_KW_PUBLIC = 116,                /* KW_PUBLIC  */
  YYSYMBOL_KW_REGISTER = 117,              /* KW_REGISTER  */
  YYSYMBOL_KW_REINTERPRET_CAST = 118,      /* KW_REINTERPRET_CAST  */
  YYSYMBOL_KW_RETURN = 119,                /* KW_RETURN  */
  YYSYMBOL_KW_SHORT = 120,                 /* KW_SHORT  */
  YYSYMBOL_KW_SIGNED = 121,                /* KW_SIGNED  */
  YYSYMBOL_KW_SIZEOF = 122,                /* KW_SIZEOF  */
  YYSYMBOL_KW_STATIC = 123,                /* KW_STATIC  */
  YYSYMBOL_KW_STATIC_ASSERT = 124,         /* KW_STATIC_ASSERT  */
  YYSYMBOL_KW_STATIC_CAST = 125,           /* KW_STATIC_CAST  */
  YYSYMBOL_KW_STRUCT = 126,                /* KW_STRUCT  */
  YYSYMBOL_KW_TEMPLATE = 127,              /* KW_TEMPLATE  */
  YYSYMBOL_KW_THREAD_LOCAL = 128,          /* KW_THREAD_LOCAL  */
  YYSYMBOL_KW_THROW = 129,                 /* KW_THROW  */
  YYSYMBOL_KW_TRUE = 130,                  /* KW_TRUE  */
  YYSYMBOL_KW_TRY = 131,                   /* KW_TRY  */
  YYSYMBOL_KW_TYPEDEF = 132,               /* KW_TYPEDEF  */
  YYSYMBOL_KW_TYPEID = 133,                /* KW_TYPEID  */
  YYSYMBOL_KW_TYPENAME = 134,              /* KW_TYPENAME  */
  YYSYMBOL_KW_UNDERLYING_TYPE = 135,       /* KW_UNDERLYING_TYPE  */
  YYSYMBOL_KW_UNION = 136,                 /* KW_UNION  */
  YYSYMBOL_KW_UNSIGNED = 137,              /* KW_UNSIGNED  */
  YYSYMBOL_KW_USING = 138,                 /* KW_USING  */
  YYSYMBOL_KW_VIRTUAL = 139,               /* KW_VIRTUAL  */
  YYSYMBOL_KW_VOID = 140,                  /* KW_VOID  */
  YYSYMBOL_KW_VOLATILE = 141,              /* KW_VOLATILE  */
  YYSYMBOL_KW_WCHAR_T = 142,               /* KW_WCHAR_T  */
  YYSYMBOL_KW_WHILE = 143,                 /* KW_WHILE  */
  YYSYMBOL_START_CPP = 144,                /* START_CPP  */
  YYSYMBOL_START_CONST_EXPR = 145,         /* START_CONST_EXPR  */
  YYSYMBOL_START_TYPE = 146,               /* START_TYPE  */
  YYSYMBOL_147_ = 147,                     /* '{'  */
  YYSYMBOL_148_ = 148,                     /* ','  */
  YYSYMBOL_149_ = 149,                     /* ';'  */
  YYSYMBOL_150_ = 150,                     /* ':'  */
  YYSYMBOL_151_ = 151,                     /* '='  */
  YYSYMBOL_152_ = 152,                     /* '?'  */
  YYSYMBOL_153_ = 153,                     /* '|'  */
  YYSYMBOL_154_ = 154,                     /* '^'  */
  YYSYMBOL_155_ = 155,                     /* '&'  */
  YYSYMBOL_156_ = 156,                     /* '<'  */
  YYSYMBOL_157_ = 157,                     /* '>'  */
  YYSYMBOL_158_ = 158,                     /* '+'  */
  YYSYMBOL_159_ = 159,                     /* '-'  */
  YYSYMBOL_160_ = 160,                     /* '*'  */
  YYSYMBOL_161_ = 161,                     /* '/'  */
  YYSYMBOL_162_ = 162,                     /* '%'  */
  YYSYMBOL_163_ = 163,                     /* '~'  */
  YYSYMBOL_164_ = 164,                     /* '.'  */
  YYSYMBOL_165_ = 165,                     /* '('  */
  YYSYMBOL_166_ = 166,                     /* '['  */
  YYSYMBOL_167_ = 167,                     /* ')'  */
  YYSYMBOL_168_ = 168,                     /* '}'  */
  YYSYMBOL_169_ = 169,                     /* '!'  */
  YYSYMBOL_170_ = 170,                     /* ']'  */
  YYSYMBOL_YYACCEPT = 171,                 /* $accept  */
  YYSYMBOL_grammar = 172,                  /* grammar  */
  YYSYMBOL_cpp = 173,                      /* cpp  */
  YYSYMBOL_constructor_inits = 174,        /* constructor_inits  */
  YYSYMBOL_constructor_init = 175,         /* constructor_init  */
  YYSYMBOL_extern_c = 176,                 /* extern_c  */
  YYSYMBOL_177_1 = 177,                    /* $@1  */
  YYSYMBOL_declaration = 178,              /* declaration  */
  YYSYMBOL_friend_declaration = 179,       /* friend_declaration  */
  YYSYMBOL_180_2 = 180,                    /* $@2  */
  YYSYMBOL_storage_class = 181,            /* storage_class  */
  YYSYMBOL_attribute_specifiers = 182,     /* attribute_specifiers  */
  YYSYMBOL_attribute_specifier = 183,      /* attribute_specifier  */
  YYSYMBOL_type_like_declaration = 184,    /* type_like_declaration  */
  YYSYMBOL_185_3 = 185,                    /* $@3  */
  YYSYMBOL_186_4 = 186,                    /* $@4  */
  YYSYMBOL_multiple_instance_identifiers = 187, /* multiple_instance_identifiers  */
  YYSYMBOL_typedef_declaration = 188,      /* typedef_declaration  */
  YYSYMBOL_189_5 = 189,                    /* $@5  */
  YYSYMBOL_typedef_instance_identifiers = 190, /* typedef_instance_identifiers  */
  YYSYMBOL_constructor_prototype = 191,    /* constructor_prototype  */
  YYSYMBOL_192_6 = 192,                    /* $@6  */
  YYSYMBOL_193_7 = 193,                    /* $@7  */
  YYSYMBOL_194_8 = 194,                    /* $@8  */
  YYSYMBOL_function_prototype = 195,       /* function_prototype  */
  YYSYMBOL_196_9 = 196,                    /* $@9  */
  YYSYMBOL_197_10 = 197,                   /* $@10  */
  YYSYMBOL_198_11 = 198,                   /* $@11  */
  YYSYMBOL_199_12 = 199,                   /* $@12  */
  YYSYMBOL_200_13 = 200,                   /* $@13  */
  YYSYMBOL_function_post = 201,            /* function_post  */
  YYSYMBOL_function_operator = 202,        /* function_operator  */
  YYSYMBOL_more_template_declaration = 203, /* more_template_declaration  */
  YYSYMBOL_template_declaration = 204,     /* template_declaration  */
  YYSYMBOL_205_14 = 205,                   /* $@14  */
  YYSYMBOL_template_formal_parameters = 206, /* template_formal_parameters  */
  YYSYMBOL_template_nonempty_formal_parameters = 207, /* template_nonempty_formal_parameters  */
  YYSYMBOL_typename_keyword = 208,         /* typename_keyword  */
  YYSYMBOL_template_formal_parameter = 209, /* template_formal_parameter  */
  YYSYMBOL_template_formal_parameter_type = 210, /* template_formal_parameter_type  */
  YYSYMBOL_instance_identifier = 211,      /* instance_identifier  */
  YYSYMBOL_212_15 = 212,                   /* $@15  */
  YYSYMBOL_instance_identifier_and_maybe_trailing_return_type = 213, /* instance_identifier_and_maybe_trailing_return_type  */
  YYSYMBOL_maybe_trailing_return_type = 214, /* maybe_trailing_return_type  */
  YYSYMBOL_maybe_comma_identifier = 215,   /* maybe_comma_identifier  */
  YYSYMBOL_function_parameter_list = 216,  /* function_parameter_list  */
  YYSYMBOL_function_parameters = 217,      /* function_parameters  */
  YYSYMBOL_formal_parameter_list = 218,    /* formal_parameter_list  */
  YYSYMBOL_formal_parameters = 219,        /* formal_parameters  */
  YYSYMBOL_template_parameter_maybe_initialize = 220, /* template_parameter_maybe_initialize  */
  YYSYMBOL_maybe_initialize = 221,         /* maybe_initialize  */
  YYSYMBOL_maybe_initialize_or_constructor_body = 222, /* maybe_initialize_or_constructor_body  */
  YYSYMBOL_maybe_initialize_or_function_body = 223, /* maybe_initialize_or_function_body  */
  YYSYMBOL_structure_init = 224,           /* structure_init  */
  YYSYMBOL_structure_init_body = 225,      /* structure_init_body  */
  YYSYMBOL_function_parameter = 226,       /* function_parameter  */
  YYSYMBOL_formal_parameter = 227,         /* formal_parameter  */
  YYSYMBOL_not_paren_formal_parameter_identifier = 228, /* not_paren_formal_parameter_identifier  */
  YYSYMBOL_formal_parameter_identifier = 229, /* formal_parameter_identifier  */
  YYSYMBOL_parameter_pack_identifier = 230, /* parameter_pack_identifier  */
  YYSYMBOL_not_paren_empty_instance_identifier = 231, /* not_paren_empty_instance_identifier  */
  YYSYMBOL_empty_instance_identifier = 232, /* empty_instance_identifier  */
  YYSYMBOL_type = 233,                     /* type  */
  YYSYMBOL_type_pack = 234,                /* type_pack  */
  YYSYMBOL_type_decl = 235,                /* type_decl  */
  YYSYMBOL_predefined_type = 236,          /* predefined_type  */
  YYSYMBOL_var_type_decl = 237,            /* var_type_decl  */
  YYSYMBOL_full_type = 238,                /* full_type  */
  YYSYMBOL_struct_attributes = 239,        /* struct_attributes  */
  YYSYMBOL_anonymous_struct = 240,         /* anonymous_struct  */
  YYSYMBOL_241_16 = 241,                   /* $@16  */
  YYSYMBOL_named_struct = 242,             /* named_struct  */
  YYSYMBOL_243_17 = 243,                   /* $@17  */
  YYSYMBOL_maybe_final = 244,              /* maybe_final  */
  YYSYMBOL_maybe_class_derivation = 245,   /* maybe_class_derivation  */
  YYSYMBOL_class_derivation = 246,         /* class_derivation  */
  YYSYMBOL_base_specification = 247,       /* base_specification  */
  YYSYMBOL_enum = 248,                     /* enum  */
  YYSYMBOL_enum_decl = 249,                /* enum_decl  */
  YYSYMBOL_enum_element_type = 250,        /* enum_element_type  */
  YYSYMBOL_enum_body_trailing_comma = 251, /* enum_body_trailing_comma  */
  YYSYMBOL_enum_body = 252,                /* enum_body  */
  YYSYMBOL_enum_keyword = 253,             /* enum_keyword  */
  YYSYMBOL_struct_keyword = 254,           /* struct_keyword  */
  YYSYMBOL_namespace_declaration = 255,    /* namespace_declaration  */
  YYSYMBOL_256_18 = 256,                   /* $@18  */
  YYSYMBOL_257_19 = 257,                   /* $@19  */
  YYSYMBOL_using_declaration = 258,        /* using_declaration  */
  YYSYMBOL_simple_type = 259,              /* simple_type  */
  YYSYMBOL_simple_int_type = 260,          /* simple_int_type  */
  YYSYMBOL_simple_float_type = 261,        /* simple_float_type  */
  YYSYMBOL_simple_void_type = 262,         /* simple_void_type  */
  YYSYMBOL_code = 263,                     /* code  */
  YYSYMBOL_264_20 = 264,                   /* $@20  */
  YYSYMBOL_code_block = 265,               /* code_block  */
  YYSYMBOL_element = 266,                  /* element  */
  YYSYMBOL_optional_const_expr = 267,      /* optional_const_expr  */
  YYSYMBOL_optional_const_expr_comma = 268, /* optional_const_expr_comma  */
  YYSYMBOL_const_expr_comma = 269,         /* const_expr_comma  */
  YYSYMBOL_no_angle_bracket_const_expr = 270, /* no_angle_bracket_const_expr  */
  YYSYMBOL_const_expr = 271,               /* const_expr  */
  YYSYMBOL_const_operand = 272,            /* const_operand  */
  YYSYMBOL_formal_const_expr = 273,        /* formal_const_expr  */
  YYSYMBOL_formal_const_operand = 274,     /* formal_const_operand  */
  YYSYMBOL_capture_list = 275,             /* capture_list  */
  YYSYMBOL_capture = 276,                  /* capture  */
  YYSYMBOL_class_derivation_name = 277,    /* class_derivation_name  */
  YYSYMBOL_name = 278,                     /* name  */
  YYSYMBOL_name_no_final = 279,            /* name_no_final  */
  YYSYMBOL_string_literal = 280,           /* string_literal  */
  YYSYMBOL_empty = 281                     /* empty  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  104
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   7455

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  171
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  111
/* YYNRULES -- Number of rules.  */
#define YYNRULES  765
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1574

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   401


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   169,     2,     2,     2,   162,   155,     2,
     165,   167,   160,   158,   148,   159,   164,   161,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   150,   149,
     156,   151,   157,   152,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   166,     2,   170,   154,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   147,   153,   168,   163,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   452,   452,   453,   457,   464,   465,   466,   470,   471,
     475,   479,   483,   496,   495,   507,   508,   509,   510,   511,
     512,   513,   526,   535,   539,   547,   551,   555,   576,   603,
     624,   653,   689,   732,   744,   765,   801,   835,   857,   893,
     915,   926,   940,   939,   954,   958,   963,   967,   978,   982,
     986,   990,   994,   998,  1002,  1006,  1010,  1014,  1018,  1022,
    1027,  1031,  1038,  1039,  1043,  1044,  1045,  1050,  1049,  1065,
    1075,  1074,  1091,  1099,  1107,  1118,  1134,  1133,  1148,  1163,
    1172,  1187,  1186,  1226,  1225,  1253,  1252,  1289,  1288,  1319,
    1318,  1337,  1336,  1357,  1356,  1388,  1387,  1413,  1426,  1430,
    1434,  1438,  1451,  1455,  1459,  1463,  1467,  1472,  1477,  1481,
    1485,  1489,  1496,  1500,  1504,  1508,  1512,  1516,  1520,  1524,
    1528,  1532,  1536,  1540,  1544,  1548,  1552,  1556,  1560,  1564,
    1568,  1572,  1576,  1580,  1584,  1588,  1592,  1596,  1600,  1604,
    1608,  1612,  1616,  1620,  1624,  1628,  1632,  1636,  1640,  1644,
    1648,  1655,  1656,  1657,  1661,  1663,  1662,  1670,  1671,  1675,
    1676,  1680,  1686,  1695,  1696,  1700,  1704,  1708,  1712,  1718,
    1724,  1730,  1737,  1742,  1751,  1755,  1760,  1768,  1780,  1784,
    1798,  1813,  1818,  1823,  1828,  1833,  1838,  1843,  1848,  1854,
    1853,  1884,  1894,  1904,  1908,  1912,  1921,  1925,  1933,  1937,
    1942,  1946,  1951,  1959,  1964,  1972,  1976,  1981,  1985,  1990,
    1998,  2003,  2011,  2015,  2022,  2026,  2033,  2037,  2041,  2045,
    2049,  2056,  2060,  2064,  2068,  2072,  2076,  2083,  2084,  2085,
    2089,  2092,  2093,  2094,  2098,  2103,  2109,  2115,  2120,  2126,
    2132,  2136,  2147,  2151,  2161,  2165,  2169,  2174,  2179,  2184,
    2189,  2194,  2199,  2207,  2211,  2215,  2220,  2225,  2230,  2235,
    2240,  2245,  2250,  2256,  2264,  2269,  2274,  2279,  2284,  2289,
    2294,  2299,  2304,  2309,  2315,  2323,  2327,  2332,  2337,  2342,
    2347,  2352,  2357,  2362,  2367,  2375,  2379,  2384,  2389,  2394,
    2399,  2404,  2409,  2414,  2419,  2424,  2430,  2437,  2444,  2454,
    2458,  2466,  2470,  2474,  2478,  2482,  2498,  2514,  2523,  2527,
    2537,  2544,  2555,  2559,  2567,  2571,  2575,  2579,  2583,  2599,
    2615,  2633,  2642,  2646,  2656,  2663,  2667,  2675,  2679,  2695,
    2711,  2720,  2730,  2737,  2741,  2749,  2753,  2758,  2762,  2770,
    2771,  2772,  2773,  2778,  2777,  2802,  2801,  2831,  2832,  2839,
    2840,  2844,  2845,  2849,  2853,  2857,  2861,  2865,  2869,  2873,
    2877,  2881,  2885,  2892,  2900,  2904,  2908,  2913,  2921,  2925,
    2932,  2933,  2938,  2945,  2946,  2951,  2959,  2963,  2967,  2974,
    2978,  2982,  2990,  2989,  3012,  3011,  3034,  3035,  3039,  3045,
    3052,  3061,  3062,  3063,  3067,  3071,  3075,  3079,  3083,  3087,
    3092,  3097,  3102,  3107,  3111,  3116,  3125,  3130,  3138,  3142,
    3146,  3154,  3164,  3164,  3174,  3175,  3179,  3180,  3181,  3182,
    3183,  3184,  3185,  3186,  3187,  3188,  3189,  3190,  3190,  3190,
    3191,  3191,  3191,  3191,  3192,  3192,  3192,  3192,  3192,  3193,
    3193,  3193,  3194,  3194,  3194,  3194,  3194,  3195,  3195,  3195,
    3195,  3195,  3196,  3196,  3197,  3197,  3197,  3197,  3197,  3198,
    3198,  3198,  3198,  3198,  3199,  3199,  3199,  3199,  3200,  3200,
    3200,  3200,  3200,  3201,  3201,  3201,  3201,  3201,  3202,  3202,
    3202,  3202,  3202,  3202,  3203,  3203,  3203,  3203,  3203,  3204,
    3204,  3204,  3204,  3205,  3205,  3205,  3205,  3206,  3206,  3206,
    3206,  3206,  3207,  3207,  3207,  3207,  3208,  3208,  3208,  3208,
    3208,  3209,  3209,  3209,  3209,  3210,  3210,  3210,  3210,  3210,
    3211,  3211,  3214,  3214,  3214,  3214,  3214,  3214,  3214,  3214,
    3214,  3214,  3214,  3215,  3215,  3215,  3215,  3215,  3215,  3215,
    3215,  3215,  3215,  3216,  3216,  3220,  3224,  3231,  3235,  3242,
    3246,  3253,  3257,  3261,  3265,  3269,  3273,  3277,  3281,  3285,
    3289,  3293,  3297,  3301,  3305,  3309,  3313,  3317,  3321,  3325,
    3329,  3333,  3337,  3341,  3345,  3349,  3353,  3357,  3361,  3365,
    3369,  3373,  3377,  3381,  3385,  3389,  3393,  3397,  3401,  3405,
    3413,  3417,  3421,  3425,  3429,  3433,  3437,  3447,  3457,  3463,
    3469,  3475,  3481,  3487,  3493,  3500,  3507,  3514,  3521,  3527,
    3533,  3537,  3541,  3545,  3549,  3553,  3557,  3568,  3579,  3583,
    3587,  3591,  3595,  3599,  3603,  3607,  3611,  3615,  3619,  3623,
    3627,  3631,  3635,  3639,  3643,  3647,  3651,  3655,  3659,  3663,
    3667,  3671,  3675,  3679,  3683,  3687,  3691,  3695,  3699,  3706,
    3710,  3714,  3718,  3722,  3726,  3730,  3734,  3738,  3744,  3750,
    3754,  3760,  3767,  3771,  3775,  3779,  3783,  3787,  3791,  3795,
    3799,  3803,  3807,  3811,  3815,  3819,  3823,  3827,  3831,  3845,
    3849,  3853,  3857,  3861,  3865,  3869,  3873,  3877,  3881,  3885,
    3889,  3893,  3904,  3915,  3919,  3923,  3927,  3931,  3935,  3939,
    3943,  3947,  3951,  3955,  3959,  3963,  3967,  3971,  3975,  3979,
    3983,  3987,  3991,  3995,  3999,  4003,  4007,  4011,  4015,  4019,
    4023,  4027,  4031,  4038,  4042,  4046,  4050,  4054,  4058,  4062,
    4066,  4070,  4076,  4082,  4090,  4094,  4098,  4102,  4109,  4119,
    4125,  4131,  4141,  4153,  4161,  4165,  4195,  4199,  4203,  4207,
    4211,  4215,  4221,  4225,  4229,  4233,  4237,  4248,  4252,  4256,
    4260,  4268,  4272,  4276,  4282,  4293
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "REAL", "INTEGER",
  "CHAR_TOK", "SIMPLE_STRING", "SIMPLE_IDENTIFIER", "STRING_LITERAL",
  "CUSTOM_LITERAL", "IDENTIFIER", "TYPENAME_IDENTIFIER",
  "TYPEPACK_IDENTIFIER", "SCOPING", "TYPEDEFNAME", "ELLIPSIS", "OROR",
  "ANDAND", "EQCOMPARE", "NECOMPARE", "LECOMPARE", "GECOMPARE", "LSHIFT",
  "RSHIFT", "POINTSAT_STAR", "DOT_STAR", "UNARY", "UNARY_NOT",
  "UNARY_NEGATE", "UNARY_MINUS", "UNARY_PLUS", "UNARY_STAR", "UNARY_REF",
  "POINTSAT", "SCOPE", "PLUSPLUS", "MINUSMINUS", "TIMESEQUAL",
  "DIVIDEEQUAL", "MODEQUAL", "PLUSEQUAL", "MINUSEQUAL", "OREQUAL",
  "ANDEQUAL", "XOREQUAL", "LSHIFTEQUAL", "RSHIFTEQUAL", "ATTR_LEFT",
  "ATTR_RIGHT", "KW_ALIGNAS", "KW_ALIGNOF", "KW_AUTO", "KW_BEGIN_PUBLISH",
  "KW_BLOCKING", "KW_BOOL", "KW_CATCH", "KW_CHAR", "KW_CHAR16_T",
  "KW_CHAR32_T", "KW_CLASS", "KW_CONST", "KW_CONSTEXPR", "KW_CONST_CAST",
  "KW_DECLTYPE", "KW_DEFAULT", "KW_DELETE", "KW_DOUBLE", "KW_DYNAMIC_CAST",
  "KW_ELSE", "KW_END_PUBLISH", "KW_ENUM", "KW_EXTENSION", "KW_EXTERN",
  "KW_EXPLICIT", "KW_PUBLISHED", "KW_FALSE", "KW_FINAL", "KW_FLOAT",
  "KW_FRIEND", "KW_FOR", "KW_GOTO", "KW_HAS_VIRTUAL_DESTRUCTOR", "KW_IF",
  "KW_INLINE", "KW_INT", "KW_IS_ABSTRACT", "KW_IS_BASE_OF", "KW_IS_CLASS",
  "KW_IS_CONSTRUCTIBLE", "KW_IS_CONVERTIBLE_TO", "KW_IS_DESTRUCTIBLE",
  "KW_IS_EMPTY", "KW_IS_ENUM", "KW_IS_FINAL", "KW_IS_FUNDAMENTAL",
  "KW_IS_POD", "KW_IS_POLYMORPHIC", "KW_IS_STANDARD_LAYOUT",
  "KW_IS_TRIVIAL", "KW_IS_UNION", "KW_LONG", "KW_MAKE_MAP_KEYS_SEQ",
  "KW_MAKE_MAP_PROPERTY", "KW_MAKE_PROPERTY", "KW_MAKE_PROPERTY2",
  "KW_MAKE_SEQ", "KW_MAKE_SEQ_PROPERTY", "KW_MUTABLE", "KW_NAMESPACE",
  "KW_NEW", "KW_NOEXCEPT", "KW_NULLPTR", "KW_OPERATOR", "KW_OVERRIDE",
  "KW_PRIVATE", "KW_PROTECTED", "KW_PUBLIC", "KW_REGISTER",
  "KW_REINTERPRET_CAST", "KW_RETURN", "KW_SHORT", "KW_SIGNED", "KW_SIZEOF",
  "KW_STATIC", "KW_STATIC_ASSERT", "KW_STATIC_CAST", "KW_STRUCT",
  "KW_TEMPLATE", "KW_THREAD_LOCAL", "KW_THROW", "KW_TRUE", "KW_TRY",
  "KW_TYPEDEF", "KW_TYPEID", "KW_TYPENAME", "KW_UNDERLYING_TYPE",
  "KW_UNION", "KW_UNSIGNED", "KW_USING", "KW_VIRTUAL", "KW_VOID",
  "KW_VOLATILE", "KW_WCHAR_T", "KW_WHILE", "START_CPP", "START_CONST_EXPR",
  "START_TYPE", "'{'", "','", "';'", "':'", "'='", "'?'", "'|'", "'^'",
  "'&'", "'<'", "'>'", "'+'", "'-'", "'*'", "'/'", "'%'", "'~'", "'.'",
  "'('", "'['", "')'", "'}'", "'!'", "']'", "$accept", "grammar", "cpp",
  "constructor_inits", "constructor_init", "extern_c", "$@1",
  "declaration", "friend_declaration", "$@2", "storage_class",
  "attribute_specifiers", "attribute_specifier", "type_like_declaration",
  "$@3", "$@4", "multiple_instance_identifiers", "typedef_declaration",
  "$@5", "typedef_instance_identifiers", "constructor_prototype", "$@6",
  "$@7", "$@8", "function_prototype", "$@9", "$@10", "$@11", "$@12",
  "$@13", "function_post", "function_operator",
  "more_template_declaration", "template_declaration", "$@14",
  "template_formal_parameters", "template_nonempty_formal_parameters",
  "typename_keyword", "template_formal_parameter",
  "template_formal_parameter_type", "instance_identifier", "$@15",
  "instance_identifier_and_maybe_trailing_return_type",
  "maybe_trailing_return_type", "maybe_comma_identifier",
  "function_parameter_list", "function_parameters",
  "formal_parameter_list", "formal_parameters",
  "template_parameter_maybe_initialize", "maybe_initialize",
  "maybe_initialize_or_constructor_body",
  "maybe_initialize_or_function_body", "structure_init",
  "structure_init_body", "function_parameter", "formal_parameter",
  "not_paren_formal_parameter_identifier", "formal_parameter_identifier",
  "parameter_pack_identifier", "not_paren_empty_instance_identifier",
  "empty_instance_identifier", "type", "type_pack", "type_decl",
  "predefined_type", "var_type_decl", "full_type", "struct_attributes",
  "anonymous_struct", "$@16", "named_struct", "$@17", "maybe_final",
  "maybe_class_derivation", "class_derivation", "base_specification",
  "enum", "enum_decl", "enum_element_type", "enum_body_trailing_comma",
  "enum_body", "enum_keyword", "struct_keyword", "namespace_declaration",
  "$@18", "$@19", "using_declaration", "simple_type", "simple_int_type",
  "simple_float_type", "simple_void_type", "code", "$@20", "code_block",
  "element", "optional_const_expr", "optional_const_expr_comma",
  "const_expr_comma", "no_angle_bracket_const_expr", "const_expr",
  "const_operand", "formal_const_expr", "formal_const_operand",
  "capture_list", "capture", "class_derivation_name", "name",
  "name_no_final", "string_literal", "empty", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   123,    44,    59,
      58,    61,    63,   124,    94,    38,    60,    62,    43,    45,
      42,    47,    37,   126,    46,    40,    91,    41,   125,    33,
      93
};
#endif

#define YYPACT_NINF (-930)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-761)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     199,  -930,  3781,  6132,    47,  5432,  -930,  -930,  -930,  -930,
    -930,  -930,  -930,  -930,  -102,   -97,   -86,   -79,   -73,   -57,
      -7,   -47,     2,  -930,  -930,    -2,     7,    25,    36,    74,
     100,   103,   109,   118,   131,   140,   156,   176,   189,   197,
     206,   216,   222,   226,  6383,  -930,  -930,    28,   235,   239,
    2701,   250,  -930,   247,   270,   272,  3781,  3781,  3781,  3781,
    3781,  2372,  1705,  3781,  5269,  -930,   224,  -930,  -930,  -930,
    -930,  -930,  -930,  -930,  -930,  6243,   275,  -930,   -19,  -930,
    -930,  4712,  1168,  1168,  -930,  7033,   292,  -930,  1168,  -930,
    -930,   187,   187,  -930,  -930,  -930,  -930,   314,    48,  -930,
    -930,  -930,  -930,  -930,  -930,  6083,   300,  -930,  7314,  7314,
    7314,  -930,  7314,  5779,  7314,   320,  -930,  7299,   307,   328,
     330,   332,   334,   341,  7314,  4160,   365,   371,   382,  7314,
    7314,   379,  7106,  7314,  7314,  5386,  7314,  7314,  -930,  -930,
    -930,  -930,  4851,  -930,  -930,  -930,  -930,  -930,  3781,  3781,
    6132,  3781,  3781,  3781,  3781,  6132,  3781,  6132,  3781,  6132,
    3781,  6132,  6132,  6132,  6132,  6132,  6132,  6132,  6132,  6132,
    6132,  6132,  6132,  6132,  6132,  6132,  3781,  -930,  -930,   380,
    7033,   402,   405,  7033,  -930,  -930,  6132,  3781,  3781,   406,
    2372,    56,  6132,  2372,  3781,  3781,    56,    56,    56,    56,
      56,  -102,   -86,   -79,   -73,   -57,   -47,    -2,    25,  1462,
    5571,  6995,  7050,   272,   249,   -98,  5269,  -930,  -930,  -930,
    -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  7033,
    7033,  -114,   421,  -930,  -930,    56,  3781,  3781,  3781,  3781,
    3781,  3781,  3781,  3781,  3781,  3781,  3781,  3781,  3781,  3781,
    3781,  3781,  3781,  3781,  3781,  3781,  7033,  2836,  3781,  -930,
    -930,   187,   187,  2971,  -930,  -930,  -930,  1168,  -930,  -930,
    -930,  -930,  6132,  -930,   414,   938,   298,   187,   187,   298,
     298,  5546,   319,  -930,   409,  -930,  -930,  -930,  -930,  -930,
    -930,  1401,   426,  3885,  -930,  7033,   529,   430,   415,  2560,
    5806,  7314,  -930,  -930,  -930,  -930,  7314,  -930,  -930,  -930,
    -930,  7199,  5722,  -930,  7033,  7033,  7033,  7033,  7033,  7033,
    -930,  -930,   432,  -930,  -930,  -930,  -930,  -930,  3781,  -930,
    4943,  -930,   425,  -930,  5030,  -930,  7033,   214,  -930,  -930,
     256,   419,  -930,   420,  6272,  7033,   433,  -930,  7033,  -930,
     208,   437,  -930,  -930,  -930,  -930,  2895,  -930,  -930,   422,
     434,  -930,   435,   436,   440,   441,   444,   446,   443,   449,
     461,   459,   460,   464,   472,   453,   474,   -96,   480,   476,
     477,   481,   482,   483,   484,   485,   486,   488,   489,   491,
    3781,  -930,  6132,  3781,  -930,  6231,   490,   494,   495,  7033,
     497,   508,   499,  4555,   501,   509,  3781,  3781,  -930,   582,
    -930,   313,   510,  3781,  -930,  -930,  1767,  5599,  2015,  2015,
     905,   905,   705,   705,  -930,  3128,  1547,  2133,  5631,   905,
     905,   281,   281,    56,    56,    56,  -930,  -930,   -83,  2391,
    -930,  -930,   511,  4711,   512,   298,   514,   517,  7033,   298,
     298,   298,   298,   298,   515,  -930,   319,  -930,   319,  -930,
     515,   515,  -930,   298,  6083,  6156,  6045,   298,   298,   518,
       8,  -930,   934,   273,  -930,  3781,  7033,   522,  -930,  -930,
    -930,  -930,  1401,    -6,    -4,    17,  6083,   526,    18,  -930,
    -930,  -930,   549,  7314,  6083,  3916,  -102,   536,  5099,  -930,
    -930,  -930,   557,   558,   560,   562,   565,   572,   573,  6515,
    -930,  4210,  5882,   237,   540,   208,  -930,  -930,   585,  -930,
    6132,  -930,    31,  3106,  6470,  1096,  -930,  6132,  -930,   574,
     229,  -930,  -930,  1748,  -930,  -930,   760,  -930,   590,  3885,
    -930,  -930,  -930,  -930,  -930,  -930,  -930,   578,  -930,   581,
    -930,  -930,  -930,  -930,  6132,  -930,  6132,  -930,  6132,  -930,
    -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,
    5157,   586,   587,  -930,   583,  -930,  -930,   591,  4056,   584,
    -930,  -930,  -930,  -930,    56,  5269,  -930,  7033,   421,  5913,
    4642,  -930,  5269,  3781,  -930,  -930,  -930,  -930,  -930,   515,
     298,  -930,   515,   515,   515,   515,   515,  3781,   -71,   709,
    6243,   934,   273,  -930,   253,   293,  -930,  -930,  6014,   600,
     934,   934,   934,   934,   934,   934,    19,  -930,  -930,   606,
    7033,   273,   273,   273,   273,   273,   273,   107,   598,  5269,
    -930,    30,  -930,   622,   727,  2560,  -930,   704,  6083,  -930,
    -930,  -930,  -930,  -930,  -930,  -930,  -930,   616,   626,   628,
    -930,  -930,  6383,  -930,  -930,   630,  4629,   631,  -930,   623,
    3781,  3781,  3781,  3781,  2372,  3781,   624,    12,  -930,  -930,
    5366,  -930,   224,  -930,  7314,  7314,  6588,  -930,   779,   780,
     783,   786,   787,   790,  -930,  -930,   342,   653,  -930,  -930,
    -930,  -930,  4912,  -930,   648,   659,  7022,  -930,  1178,  -930,
    -930,     9,  -930,   760,  -930,   660,  5913,   643,   651,   760,
    5913,   647,  5178,  1096,   655,  1096,  1096,  1096,  1096,  1096,
     209,  -930,  -930,   649,  6661,  -930,  -930,  -930,  7033,   417,
    -930,   654,  -930,   670,   672,  3241,  3398,   663,   760,   760,
    4783,   760,   760,   760,   760,  -930,    91,   266,  -930,  1401,
    -930,  3781,  3781,   657,   658,   662,  -930,  -930,  -930,  3781,
    -930,  3781,  -930,   667,  -930,  6359,  6083,  -930,  -930,  -930,
    -930,  -930,  -930,   661,  -930,  -930,   683,  -930,  5269,   515,
     668,   675,  6045,   934,   273,    19,   107,   676,   677,  4642,
    -930,  -930,   934,   671,   671,   671,   671,   671,   325,  3781,
    -930,   273,  -930,   678,   678,   678,   678,   678,   335,  3781,
    -930,   679,  -930,  3781,  -930,   680,  5196,  6734,  -930,   698,
    -930,  -930,  6132,  6132,  6132,   684,  6132,   685,  2372,    98,
    6132,  2372,    56,    56,    56,    56,   687,   -63,    56,  -930,
    -930,  4191,  3781,  3781,  3781,  3781,  3781,  3781,  3781,  3781,
    3781,  3781,  3781,  3781,  3781,  3781,  3781,  3781,  3781,  3781,
    3781,  3781,  7033,  3376,  3781,  -930,  -930,  -930,  -930,   707,
     -42,   708,   710,   712,   713,  6807,    43,  -930,  1178,  7272,
    5882,  7033,   723,   715,  1178,  1178,  1178,  1178,  1178,  1178,
     116,   678,  -930,   266,  -930,   711,   714,   760,    77,   716,
    -930,  -930,   353,  1096,   718,   718,   718,   718,   718,  -930,
    3781,  -930,  -930,  5913,   721,   378,  -930,   -90,   732,   733,
    -930,  2203,  -930,  -930,  -930,  3241,   722,   728,  5269,  -930,
    -930,   760,   377,   377,   876,  -930,  -930,  -930,  -930,  -930,
    -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,
    -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,
    -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,
    -930,   724,   730,  -930,  -930,   377,   377,   377,   265,  3781,
    -930,  3781,  -930,  1748,   756,  -930,   622,   -38,   -29,  -930,
    -930,  -930,   -22,     6,  -930,  6383,   187,   859,   519,  -930,
    -930,  5913,  -930,    19,   107,  -930,  -930,  5913,  5913,  -930,
     671,   744,   741,   678,   748,   751,  3668,  -930,  -930,  -930,
    4275,   771,   775,  -930,   759,   772,   773,  3781,   778,  7033,
     765,   782,   769,  5214,  3781,  -930,  -930,  -930,  1767,  5599,
    2015,  2015,   905,   905,   705,   705,  -930,  5251,  1547,  2133,
    5631,   905,   905,   281,   281,    56,    56,    56,  -930,  -930,
      44,  2719,  6880,   930,   931,   794,   942,   804,  -930,   943,
     944,   951,  -930,   816,   116,   678,  -930,  -930,  -930,  -930,
    -930,  -930,  6132,  1178,  4432,  -930,  -930,   825,  -930,  -930,
    -930,   289,   809,  -930,  -930,   718,  5913,   805,   811,  -930,
    -930,  7033,  3781,  3781,  -930,  -930,  -930,  -930,  -930,  -930,
    -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,
    -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,
    -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,
    -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,
    -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,
    -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,
    -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,
    -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,
    -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,
    -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,
    -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,
    -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,  -930,
    -930,  -930,  -930,  -930,  -930,  -930,   819,  -930,  3511,   377,
    -930,  -930,  -930,  -930,  5269,  3916,   814,  3398,   760,  -930,
    -930,  -930,  -930,  4642,   187,  -930,  -930,  -930,     4,   827,
     812,  -930,  -930,   826,   829,  5913,  -930,  5913,  -930,  -930,
    5796,  5873,  6458,  7033,   362,  -930,  -930,   983,  -930,  4275,
    -930,   836,   839,   840,   841,   844,  4056,   843,  -930,  -930,
      56,  3781,  -930,  -930,  -930,   851,    51,  -930,   871,   872,
      66,   853,    81,  -930,  -930,  -930,   857,   874,   884,   885,
    4332,   886,  4432,  4432,  4432,  4432,  4432,  2372,  4432,  4864,
    -930,   760,  4998,  5913,   863,  -930,  4998,  5913,   862,  -930,
    -930,   875,  -930,   878,   877,  1946,  -930,  3241,  5269,   881,
    -930,  -930,   902,  -930,   883,  -930,  -930,  -930,  -930,  -930,
     889,   890,  4659,  -930,  4659,  -930,  4659,  -930,  -930,  4659,
    4659,  4659,  -930,  6953,  -930,  3781,  3781,  -930,  3781,  -930,
    3781,  5269,   909,  1050,   913,  1062,  -930,  1063,   925,   927,
    1067,   929,  6132,  6132,  6132,  6132,   914,  2372,   129,  6132,
     129,   129,   129,   129,   129,   915,    86,   129,  4432,  4432,
    4432,  4432,  4432,  4432,  4432,  4432,  4432,  4432,  4432,  4432,
    4432,  4432,  4432,  4432,  4432,  4432,  7033,  3646,  3781,  -930,
     917,  -930,  5913,   918,  -930,  4998,  -930,  -930,  1065,  -930,
     919,  -930,  -930,  -930,  4642,  4642,  4642,  -930,  -930,  -930,
    -930,  -930,  -930,  -930,  -930,  -930,    87,    92,   141,   150,
    -930,   933,  -930,   921,   945,  -930,  -930,   162,  -930,   923,
     939,   940,   946,  7033,   924,   953,  4432,  -930,  5424,  5615,
     571,   571,   966,   966,   873,   873,  -930,  1261,  5656,  1613,
     375,   798,   798,   129,   129,   129,  -930,  -930,   168,  3935,
    -930,  5913,   928,  -930,  4998,  -930,  -930,  4998,   932,  -930,
    -930,  -930,  4998,  4998,  -930,  -930,  -930,  -930,  1076,   947,
     952,  1105,  1106,   969,  -930,   955,   956,   957,   967,  4532,
     958,   129,  4432,  -930,  -930,  4998,   968,  -930,  4998,  -930,
    -930,   987,  -930,   970,   170,  -930,  3781,  3781,  3781,  -930,
    3781,  4864,  -930,  4642,  -930,   990,  1131,   993,   171,   179,
     182,   184,  4642,  -930,  -930,   976,  -930,  -930,  -930,  -930,
    -930,  -930,   995,  -930
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,   765,     0,     0,     0,   765,     5,   653,   649,   652,
     761,   762,   655,   656,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   651,   657,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   659,   658,     0,     0,     0,
       0,     0,   650,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   765,     0,     3,   590,   654,   300,   311,   310,
     394,   395,   397,   398,   379,     0,     0,   409,   376,   408,
     403,   400,   399,   402,   380,     0,     0,   381,   401,   411,
     396,   765,   765,     4,   302,   303,   304,     0,   365,   765,
     299,   391,   392,   393,     1,     0,     0,    21,   765,   765,
     765,    22,   765,   765,   765,     0,    42,   765,     0,     0,
       0,     0,     0,     0,   765,     0,     0,     0,     0,   765,
     765,     0,   765,   765,   765,     0,   765,   765,     6,    17,
       7,    19,     0,    15,    16,    18,    73,    44,   765,   765,
       0,   765,   765,   765,   765,     0,   765,     0,   765,     0,
     765,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   765,   326,   332,     0,
       0,     0,   614,     0,   765,   325,     0,   765,   765,     0,
       0,   611,     0,     0,   765,   765,   623,   621,   620,   622,
     619,   300,   394,   395,   397,   398,   409,   408,   403,   400,
     399,   402,   401,   396,     0,     0,   549,   746,   747,   748,
     756,   749,   752,   750,   754,   753,   751,   755,   735,   736,
       0,     0,   765,   741,   734,   618,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   763,
     764,   765,   765,     0,   377,   378,   410,   400,   405,   404,
     407,   301,     0,   406,     0,   286,   765,   765,   765,   765,
     765,   765,     0,   335,   285,   337,   765,   757,   758,   759,
     760,     0,   367,     0,   339,     0,     0,    62,    64,     0,
     765,   765,    56,    45,    55,    57,   765,    46,   154,    51,
      23,   765,     0,    49,     0,     0,     0,     0,     0,     0,
      54,   765,     0,    26,    25,    24,    52,    48,     0,   158,
       0,   157,     0,    58,     0,    20,     0,     0,    50,    53,
     334,   313,   324,     0,     0,     0,     0,    13,     0,    70,
       0,   333,    67,   315,   316,   317,   365,   765,   312,     0,
     548,   547,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   327,     0,   765,   329,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   648,   739,
     742,     0,   765,     0,   737,   214,   632,   633,   634,   635,
     636,   637,   640,   641,   647,     0,   629,   630,   631,   638,
     639,   627,   628,   624,   625,   626,   646,   645,     0,     0,
     336,   338,     0,     0,     0,   765,   287,     0,   276,   765,
     765,   765,   765,   765,   292,   275,     0,   288,     0,   289,
     291,   290,   199,   765,     0,     0,     0,   765,   765,     0,
     200,   203,   765,     0,   198,   765,   373,     0,   370,   369,
     364,   368,     0,   746,   747,   748,     0,     0,   750,   343,
     305,   345,     0,   765,     0,   765,   313,     0,     0,    47,
      43,   765,     0,     0,     0,     0,     0,     0,     0,   765,
     382,     0,   765,   334,   313,     0,   333,    76,     0,   388,
       0,    81,    85,     0,     0,   765,   314,     0,   765,     0,
       0,   412,   221,     0,    72,    69,     0,   320,   367,     0,
     597,   596,   613,   603,   599,   601,   602,     0,   609,     0,
     608,   662,   598,   663,     0,   665,     0,   666,     0,   669,
     670,   671,   672,   673,   674,   675,   676,   677,   678,   605,
       0,     0,     0,   328,     0,   604,   607,     0,   610,     0,
     616,   617,   606,   600,   591,   550,   740,     0,   765,   765,
     765,    98,   215,     0,   644,   643,   308,   307,   309,   293,
     765,   277,   282,   278,   279,   281,   280,   765,     0,     0,
       0,   765,     0,   240,     0,     0,   765,   202,     0,     0,
     765,   765,   765,   765,   765,   765,   765,   254,   253,     0,
     264,     0,     0,     0,     0,     0,     0,   765,     0,   546,
     545,   374,   363,   306,     0,     0,   765,   765,     0,    59,
      63,   727,   723,   726,   729,   730,   206,     0,     0,     0,
     725,   731,     0,   733,   732,     0,     0,     0,   724,     0,
       0,     0,     0,     0,     0,     0,     0,   207,   242,   210,
     243,   679,   728,   205,   765,   765,   765,   384,     0,     0,
       0,     0,     0,     0,   386,   765,     0,     0,   175,   176,
     177,   163,     0,   164,     0,   160,   165,   161,   765,   174,
     159,     0,    78,     0,   390,     0,   765,     0,     0,     0,
     765,     0,     0,   765,     0,   765,   765,   765,   765,   765,
       0,   245,   244,     0,   765,    87,   412,   216,     0,     0,
      71,     0,   765,     0,     0,   765,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    68,   765,   765,   178,     0,
     318,     0,     0,     0,     0,     0,   330,   331,   615,     0,
     612,     0,   738,     0,   105,     0,     0,    99,   107,   102,
     106,   101,   103,     0,   100,   104,     0,   193,   642,   283,
       0,     0,     0,   765,     0,   765,   765,     0,     0,   765,
     201,   204,   765,   259,   255,   256,   258,   257,     0,   765,
     234,     0,   265,   270,   266,   267,   269,   268,     0,   765,
     237,   294,   371,     0,   340,     0,     0,   765,   348,   765,
     347,    66,     0,     0,     0,   689,     0,     0,     0,   686,
       0,     0,   697,   696,   695,   694,     0,     0,   693,    65,
     209,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    61,    60,   387,   765,     0,
       0,   765,     0,     0,     0,   765,     0,    41,   765,   765,
       0,   168,   166,     0,   765,   765,   765,   765,   765,   765,
     765,   172,    77,   765,   389,     0,     0,     0,     0,     0,
     322,   321,     0,   765,   250,   246,   247,   249,   248,    93,
     765,   323,    14,   765,     0,     0,     8,     0,     0,     0,
     222,   413,   414,   224,   225,   765,     0,   228,   230,   227,
     223,     0,   185,   181,     0,   122,   123,   124,   125,   126,
     127,   130,   131,   146,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   150,   149,   133,   132,
     119,   121,   120,   128,   129,   117,   118,   114,   115,   116,
     113,     0,     0,   112,   179,   182,   184,   183,     0,     0,
     189,   765,   191,     0,     0,    74,   319,     0,     0,   664,
     667,   668,     0,     0,   765,     0,   765,     0,     0,   412,
     284,   765,   241,   765,   765,   235,   238,   765,   765,   295,
     260,   263,     0,   271,   274,     0,   375,   342,   341,   344,
       0,     0,   350,   349,     0,     0,     0,   765,     0,     0,
       0,     0,     0,     0,     0,   722,   208,   211,   706,   707,
     708,   709,   710,   711,   714,   715,   721,     0,   703,   704,
     705,   712,   713,   701,   702,   698,   699,   700,   720,   719,
       0,     0,   765,     0,     0,     0,     0,     0,   196,     0,
       0,     0,   383,     0,   765,   173,   153,   151,   156,   152,
     162,   169,     0,   765,     0,   170,   212,     0,    79,   765,
      83,     0,     0,   765,    95,   251,   765,     0,     0,   217,
     412,     0,   765,   765,   219,   220,   416,   417,   421,   418,
     426,   419,   420,   422,   423,   424,   425,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,   438,   439,
     440,   441,   442,   443,   444,   445,   446,   447,   448,   449,
     450,   451,   452,   453,   454,   455,   456,   457,   458,   459,
     460,   461,   462,   463,   464,   465,   466,   467,   468,   469,
     470,   471,   472,   473,   474,   494,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   488,
     489,   490,   491,   492,   493,   495,   496,   497,   498,   499,
     500,   501,   502,   503,   504,   505,   506,   507,   508,   509,
     510,   511,   512,   513,   514,   515,   516,   517,   518,   519,
     520,   521,   765,   538,   539,   540,   531,   543,   527,   528,
     526,   533,   534,   522,   523,   524,   525,   532,   530,   537,
     535,   541,   536,   529,   542,   415,     0,   226,   229,   186,
     180,   148,   147,   188,   192,   765,     0,   215,     0,   594,
     593,   595,   592,   765,   765,   194,   111,   108,     0,     0,
       0,   236,   239,     0,     0,   765,   261,   765,   272,   372,
     754,     0,   753,     0,     0,   351,   353,   743,   765,     0,
     688,     0,     0,     0,     0,     0,   685,     0,   691,   692,
     680,     0,   718,   717,   385,     0,     0,    33,   197,     0,
       0,     0,     0,    40,   171,   167,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   213,
     551,     0,    82,   765,     0,    89,    86,   765,     0,   252,
     765,     0,     9,     0,     0,     0,   231,   765,   232,     0,
     187,    75,     0,   195,     0,   109,   660,   765,   765,   765,
       0,     0,     0,   356,     0,   355,     0,   354,   744,     0,
       0,     0,   745,   765,   352,     0,     0,   690,     0,   687,
       0,   716,     0,     0,     0,     0,    27,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   558,     0,
     566,   564,   563,   565,   562,     0,     0,   561,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    80,
       0,    91,   765,     0,   765,    88,   218,    12,    10,   544,
       0,   765,   412,   110,   765,   765,   765,   765,   765,   362,
     361,   360,   359,   358,   357,   346,     0,     0,     0,     0,
      36,   765,    34,     0,     0,    37,    39,     0,    29,     0,
       0,     0,     0,     0,     0,     0,     0,   589,   575,   576,
     577,   578,   579,   580,   581,   582,   588,     0,   572,   573,
     574,   570,   571,   567,   568,   569,   587,   586,     0,     0,
     765,   765,     0,   765,    94,    11,   233,   190,     0,   298,
     297,   296,   262,   273,   683,   682,   684,   681,     0,     0,
       0,     0,     0,     0,   560,     0,     0,     0,     0,   557,
       0,   552,     0,   585,   584,    84,     0,   765,    96,   661,
     197,     0,    28,     0,     0,    30,     0,     0,     0,   559,
       0,   583,   765,   765,    35,     0,     0,     0,     0,     0,
       0,     0,   765,    90,    38,     0,    31,   555,   554,   556,
     553,    92,     0,    32
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -930,  -930,  -312,  -930,    34,  -930,  -930,   835,  -130,  -930,
       3,  -440,   500,  -128,  -930,  -930,  -109,  -930,  -930,  -181,
    -930,  -930,  -930,  -930,   818,  -930,  -930,  -930,  -930,  -930,
    -595,  -930,  -930,  -110,  -930,  -930,  -930,  -930,   263,   452,
    -671,  -930,  -701,  -694,  -306,  -501,  -930,   -95,  -930,    73,
    -550,  -930,  -502,  -929,  -930,  -452,   308,  -626,   345,  -409,
     747,   -82,   194,   217,  -281,  -633,   824,  1209,  -169,  -125,
    -930,  -122,  -930,  -930,  -930,  -930,  -106,  -117,  -930,  -475,
    -930,  -930,   -33,    -8,  -930,  -930,  -930,  -930,   -28,    40,
    -930,  -930,  -728,  -930,   -61,  -930,  -581,  -121,   -60,   269,
     310,   251,   520,  -930,  -930,   774,  -857,  1161,   -56,  -490,
      -1
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     4,     5,   925,   926,   139,   528,   140,   141,   311,
     142,   296,   297,   143,   536,   530,   755,   335,   713,   902,
     349,   716,  1333,   720,   350,   923,  1432,  1501,  1106,  1337,
     590,   984,  1088,   144,   332,   704,   705,   706,   707,   708,
     756,  1255,   757,   786,  1077,   469,   470,   676,   677,  1095,
     414,   740,   534,   936,   937,   471,   679,   730,   803,   813,
     282,   283,    91,    92,   351,   182,   352,    93,   293,    94,
     646,    95,   647,   829,  1031,  1032,  1285,    96,    97,   480,
     476,   477,    98,    99,   145,   695,   878,   146,   100,   101,
     102,   103,   741,   742,   931,  1245,   638,   359,   360,  1531,
     216,    65,   680,   681,   231,   232,  1286,  1287,   627,    66,
     147
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
       6,   215,   329,   308,   331,   682,  1246,   643,   924,   509,
     285,   183,   903,   712,   613,   395,   185,   353,   497,  1354,
     354,   799,   718,   617,   609,   355,   790,   850,   362,   835,
     364,   365,   366,   367,   411,   369,   184,   371,   772,   373,
     264,   717,   292,   678,   718,   148,   644,   104,   908,   259,
     407,   260,   556,   516,   650,   389,   412,  1112,   287,   288,
     289,   234,   992,   149,   637,   407,   397,   398,   150,   408,
    -757,   557,  -758,   404,   405,  1113,   810,   942,   943,   151,
     985,   986,   987,   988,   594,   407,   152,   820,   773,   244,
     284,   284,   153,  -759,  -760,   607,   791,   912,   294,   914,
     915,   916,   917,   918,  1045,  1019,  1074,   265,   154,   356,
     407,   302,   303,   304,   358,   305,   307,   309,   156,   407,
     313,   268,   269,   270,   775,  1075,   407,   320,   273,  1259,
     215,   860,   326,   327,   357,   330,   333,   334,  1260,   338,
     339,  -757,  1006,  -758,  -757,  1261,  -758,   361,   361,   155,
     361,   361,   361,   361,   407,   361,   618,   361,   157,   361,
     851,   290,  1416,   158,  -759,  -760,   801,  -759,  -760,   719,
     413,  1355,   159,  1262,   353,   361,   682,   354,   822,   440,
     441,   823,   355,   294,   186,   809,   361,   361,   539,   686,
     160,   719,   407,   361,   361,   457,   459,   438,   291,  1383,
     274,   161,   275,   796,   276,   353,   886,   994,   354,   353,
    1083,  1302,   354,   355,  1387,   905,   734,   355,  1384,   909,
     256,   257,   258,   814,   815,   816,   817,   818,  1022,  1390,
     259,   415,   260,  1388,   407,   407,  1101,   491,  1025,   162,
     407,   989,   990,   991,  1102,  1015,  1016,   277,  1391,   268,
     269,   270,   273,  1477,  1514,   995,   990,   991,   413,  1515,
     284,   284,   872,   873,   874,   163,   356,  1094,   164,   261,
    1249,   358,   572,   819,   165,   455,   284,   284,   455,   455,
     474,  1269,   809,   166,   996,   478,   629,  1105,   630,   407,
     631,   357,   262,  1426,  1427,  1428,   167,   356,   407,   901,
     538,   356,   358,   307,   313,   168,   358,   268,  1516,   499,
    1522,   447,    64,   448,   244,   449,   407,  1517,  1556,   407,
       6,   169,   357,   217,   218,   219,   357,   407,   278,  1523,
     407,   481,   407,   632,   827,  1533,  1007,  1557,  1567,  1107,
    1012,   170,   279,     1,     2,     3,  1568,   280,    10,  1569,
      11,  1570,   281,  1097,   171,   531,   294,   532,   450,   533,
     191,   682,   172,   519,   825,   520,   196,   197,   198,   199,
     200,   173,  1264,   235,   919,   920,   736,   220,   737,   738,
     739,   174,  1341,   885,   -97,  1014,   -97,   175,   -97,   221,
     222,   176,   361,  1410,  1411,  1412,  1413,  1414,  1415,   678,
     187,  1098,  1023,   -97,   188,   -97,   192,   -97,  1416,  1263,
    1256,   591,   193,   531,   633,   532,   406,   993,  1440,   607,
     797,   521,  1108,  1363,  1365,  1367,   223,   224,   634,   225,
     990,   991,  1253,   635,   226,   194,   227,   195,   636,   451,
     263,   253,   254,   255,   455,   256,   257,   258,   455,   455,
     455,   455,   455,   452,   990,   991,  1334,   272,   453,   607,
     798,   286,   455,  1271,  1272,   299,   455,   455,   587,   731,
     310,   628,   314,   230,   640,   472,  1369,  1370,  1371,  1085,
     758,   928,   929,   491,   709,   475,   814,   815,   816,   817,
     818,   809,  1021,   315,   683,   316,   649,   317,   473,   318,
       6,   819,  1024,   403,  1332,  1449,   319,  1450,  1336,  1451,
    1270,   710,  1452,  1453,  1454,   323,  1273,  1274,  1104,   920,
     353,   324,   481,   354,   732,  1110,  1111,     6,   355,   217,
     218,   219,   325,  1421,  1422,  1423,  1424,  1425,   525,  1426,
    1427,  1428,   990,   991,   328,   390,   416,   417,   418,   419,
     420,   421,   422,   423,   424,   425,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,  1072,   392,   439,  1352,
     393,   399,   413,   443,   445,  -275,   482,   493,   494,   510,
     495,   512,   407,   220,   522,   523,   535,   415,   474,   787,
     540,  1412,  1413,  1414,  1415,   221,   222,   586,   527,   455,
     547,   554,   541,   542,  1416,  1338,   640,   543,   544,   498,
     628,   545,   356,   546,   847,   591,   548,   358,   549,   628,
     628,   628,   628,   628,   628,   415,   550,   551,   558,   183,
     903,   552,   223,   224,   185,   225,   415,   357,   511,   553,
     226,   555,   227,   559,   560,     6,   830,   574,   561,   562,
     563,   564,   565,   566,   184,   567,   568,   758,   569,   611,
     472,   575,   576,   758,   578,   579,   580,   731,   582,   731,
     731,   731,   731,   731,   709,   589,   583,   600,   596,   598,
    -277,   607,   612,   473,  1023,   616,  1267,   875,   876,   472,
     642,   645,   758,   758,     6,   758,   758,   758,   758,   648,
     570,   997,   998,   684,   687,   711,   688,   628,   689,  1002,
     690,  1003,   473,   691,  1508,   474,   584,   585,   723,   474,
     692,   693,   732,   592,   732,   732,   732,   732,   732,  1421,
    1422,  1423,  1424,  1425,   714,  1426,  1427,  1428,   244,   735,
     759,   932,   183,   761,   939,  1435,   762,   185,   769,   771,
    1509,  1510,  1511,   767,   768,   787,   415,   792,   770,  1086,
     802,  1087,  1444,  1445,  1446,   682,   811,   184,   821,  -366,
     287,   288,   289,   747,  1360,   824,  1361,   748,   847,  1089,
     828,   832,   833,   472,   834,   639,   836,   840,   841,   879,
     880,   849,   628,   881,   415,   415,   882,   883,   787,   481,
     884,   628,   887,   678,   793,   889,   473,   890,   640,   904,
     906,   907,   472,  1070,   910,   913,   921,   626,   640,   933,
     749,   934,   930,   941,   999,  1000,  1008,   794,  1033,  1001,
    1009,  1416,  1430,   722,  1004,   473,  1433,   809,  1010,  1504,
    1011,  1017,  1018,   746,   819,  -284,  1507,  1027,  1030,  1037,
    1039,   758,  1512,  1513,  1044,  1073,  1076,   731,  1079,  1563,
    1080,  1081,   709,   251,   252,   253,   254,   255,  1571,   256,
     257,   258,   750,   290,  1092,  1093,  1248,     6,  1099,  1100,
    1078,  1114,  1115,  1103,   920,   758,  1250,   628,   584,  1109,
    1247,  1251,   330,   628,   628,   628,   628,   628,   628,  1096,
    1252,   751,   415,   788,  1258,  1535,  1416,  1266,  1538,  1275,
     472,  1276,   732,  1277,   472,   752,  1293,   639,  1288,   640,
     753,  1278,   474,  1289,  1265,   754,  1290,   242,   243,  1291,
    1292,  1502,  1296,   473,   939,  1294,  1298,   473,   244,  1297,
    1305,  1306,  1553,  1307,   287,   288,   289,   619,   217,   218,
     219,   620,  1308,  1310,  1311,   826,   795,  1562,  1423,  1424,
    1425,  1312,  1426,  1427,  1428,  1313,   804,   805,   806,   807,
     808,  1309,   183,  1331,  1335,  1339,  1373,   185,  1340,  1357,
     842,   843,   844,   845,  1350,   848,   472,  1346,  1414,  1415,
     640,  1343,  1344,  1358,   621,  1356,  1359,   184,  1372,  1416,
    1536,  1375,   220,   591,  1376,   284,  1378,  1377,  1380,   473,
     474,  1379,   415,   415,   221,   222,   474,   474,  1382,  1385,
    1389,  1386,  1392,   454,   456,   458,   460,   461,  1431,  1434,
    1393,  1421,  1422,  1423,  1424,  1425,   361,  1426,  1427,  1428,
    1394,  1395,  1399,  1436,  1438,   472,  1437,   290,  1441,  1442,
    1443,   223,   224,   900,   225,   938,  1447,  1448,  1460,   226,
    1461,   227,  1462,   251,   252,   253,   254,   255,   473,   256,
     257,   258,  1463,  1464,  1465,   622,  1466,  1467,  1468,  1473,
    1505,  1518,  1476,  1096,  1500,  1503,  1540,  1506,  1520,   623,
    1524,  1529,   628,  1521,   624,  1537,  1525,  1526,   591,   625,
    1539,  1542,   591,  1527,  -276,   474,   287,   288,   289,   724,
    1530,   361,   361,   725,  1541,  1543,  1544,   472,  1545,   639,
    1546,  1547,  1548,  1550,  1421,  1422,  1423,  1424,  1425,   639,
    1426,  1427,  1428,  1026,  1549,  1552,  1554,  1555,  1013,  1564,
     473,  1565,  1566,  1572,  1573,  1342,   500,  1020,   831,  1351,
    1429,  1043,   515,  1090,   888,  1519,   726,  1314,   517,  1047,
    1349,  1345,  1048,  1049,  1050,  1051,  1052,  1053,  1054,  1055,
    1056,  1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,
    1066,  1067,  1353,  1374,  1071,   588,   839,     0,   287,   288,
     289,   893,   599,   630,     0,   894,   602,   603,   604,   605,
     606,     0,   758,     0,     0,   472,     0,     0,     0,   290,
     608,   472,   472,     0,   614,   615,     0,     0,     0,     0,
       0,   932,    70,   233,    71,    72,    73,     0,   473,     0,
     639,     0,     0,  1084,   473,   473,     0,   727,   895,     0,
     804,   805,   806,   807,   808,   938,   271,     0,     0,     0,
       0,   728,    80,     0,   683,     0,   729,     0,     0,     0,
       0,     0,   787,   284,     0,     0,   298,  1406,   267,     0,
     214,     0,     0,     0,   474,   758,   474,  1408,  1409,  1410,
    1411,  1412,  1413,  1414,  1415,     0,   322,     6,    82,    83,
       0,   290,     0,     0,  1416,     0,   337,     0,     0,  1254,
     472,   639,     0,  1257,     0,    88,     0,     0,     0,     0,
      90,     0,     0,     0,     0,  1456,  1457,     0,  1458,   896,
    1459,     0,     0,   473,     0,     0,     0,     0,     0,     0,
       0,     0,   474,   897,     0,     0,   474,  1406,   898,   591,
       0,   391,     0,   899,   394,  1330,   939,   789,     0,     0,
       0,     0,     0,     0,  1300,     0,   591,   591,   591,   363,
       0,     0,     0,  1329,   368,     0,   370,  1498,   372,     0,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,     0,     0,     0,     0,     0,
     409,   410,     0,     0,     0,   396,     0,     0,     0,   400,
       0,   401,   402,     0,     0,     0,     0,     0,     0,     0,
       0,  1532,   479,  1417,  1418,  1419,  1420,   436,     0,  1421,
    1422,  1423,  1424,  1425,     0,  1426,  1427,  1428,     0,     0,
       0,   474,     0,   591,     0,     0,   446,     0,  1020,     0,
     591,     0,     0,   787,   787,   787,   591,   591,     0,   472,
       0,     0,     0,     0,   490,    70,   492,    71,    72,    73,
    1078,     0,     0,     0,     0,     0,     0,     0,     0,   472,
       0,   472,   473,   502,     0,   503,   504,   505,   506,   507,
     508,   444,     0,     0,     0,    80,  1558,  1559,  1560,     0,
    1561,     0,   473,     0,   473,     0,     0,   518,     0,   591,
     474,   267,   591,     0,     0,     0,   526,     0,     0,   529,
       0,     0,     0,     0,     0,     0,    70,   537,    71,    72,
      73,    82,    83,     0,     0,     0,     0,   472,   266,     0,
       0,   472,     0,     0,     0,     0,   591,     0,    88,     0,
       0,     0,     0,    90,     0,     0,    80,     0,     0,     0,
     473,   591,   787,     0,   473,     0,   573,     0,  1348,     0,
     577,   787,   267,     0,     0,   238,   239,   240,   241,   242,
     243,  1330,   233,  1330,  1330,  1330,  1330,  1330,     0,  1330,
     244,     0,    82,    83,     0,     0,     0,     0,     0,  1398,
       0,  1400,  1401,  1402,  1403,  1404,     0,  1407,     0,    88,
       0,   571,     0,     0,    90,     0,  1300,     0,     0,   601,
       0,  1381,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   298,   472,   176,     0,     0,
       0,  1410,  1411,  1412,  1413,  1414,  1415,   641,     0,     0,
       0,     0,     0,     0,     0,     0,  1416,   298,     0,   473,
       0,     0,     0,     0,     0,   298,     0,   938,     0,  1330,
    1330,  1330,  1330,  1330,  1330,  1330,  1330,  1330,  1330,  1330,
    1330,  1330,  1330,  1330,  1330,  1330,  1330,  1478,  1479,  1480,
    1481,  1482,  1483,  1484,  1485,  1486,  1487,  1488,  1489,  1490,
    1491,  1492,  1493,  1494,  1495,   472,     0,     0,     0,     0,
     760,   247,   248,   249,   250,   251,   252,   253,   254,   255,
       0,   256,   257,   258,     0,   217,   218,   219,   473,     0,
       0,     0,     0,     0,     0,     0,     0,  1330,     0,   715,
       0,     0,     0,     0,     0,     0,   733,     0,  1499,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   409,     0,
       0,     7,     8,     9,    10,     0,    11,    12,    13,    14,
       0,     0,     0,   763,     0,   764,     0,   765,  1420,   220,
       0,  1421,  1422,  1423,  1424,  1425,     0,  1426,  1427,  1428,
    1330,   221,   222,  1330,   237,   238,   239,   240,   241,   242,
     243,   812,     0,     0,     0,     0,     0,     0,    15,     0,
     244,  1551,    16,     0,    17,    18,    19,     0,     0,   298,
      20,     0,   743,   744,    21,    22,     0,     0,   223,   224,
       0,   225,     0,    23,    24,    25,   226,     0,   227,    26,
       0,     0,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,     0,
       0,     0,     0,     0,     0,     0,   228,    44,     0,    45,
     229,    46,     0,     0,     0,   230,    47,   892,    48,    49,
      50,     0,     0,    51,     0,     0,     0,     0,    52,     0,
       0,    53,     0,   846,     0,    54,     0,     0,     0,     0,
      55,     0,     0,     0,     0,   745,     0,     0,     0,   927,
       0,     0,     0,    56,     0,     0,    57,    58,    59,     0,
       0,    60,     0,    61,    62,     0,     0,    63,     0,     0,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
       0,   256,   257,   258,     0,     0,     0,   298,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1116,
    1117,  1118,  1119,  1120,  1121,  1122,  1123,  1124,  1125,  1126,
       0,  1127,  1128,  1129,  1130,  1131,  1132,  1133,  1134,  1135,
    1136,  1137,     0,     0,     0,     0,     0,     0,     0,  1138,
    1139,  1140,  1141,  1142,  1143,  1144,  1145,  1146,  1147,  1148,
    1149,  1150,  1151,  1152,  1153,  1154,  1155,  1156,     0,     0,
    1157,  1158,  1159,  1160,  1161,  1162,  1163,  1164,  1165,  1166,
    1167,  1168,  1169,  1170,  1171,     0,  1172,     0,  1173,  1174,
    1175,  1176,  1177,  1178,  1179,  1180,  1181,     0,  1182,  1183,
    1184,     0,     0,  1068,     0,   240,   241,   242,   243,     0,
       0,  1034,  1035,  1036,     0,  1038,  1185,  1040,   244,  1041,
    1042,     0,  1091,  1186,  1187,  1188,     0,  1189,  1190,  1191,
    1192,  1193,  1194,  1195,  1196,  1197,  1198,  1199,  1200,  1201,
    1202,  1203,  1204,  1205,  1206,  1207,  1208,  1209,  1210,  1211,
    1212,  1213,  1214,  1215,  1216,  1217,  1218,  1219,  1220,  1221,
       0,     0,     0,  1222,  1223,  1224,  1225,  1226,  1227,  1228,
    1229,  1230,  1231,  1232,  1233,  1234,  1235,  1236,  1237,  1238,
    1239,  1240,  1241,  1242,  1439,  1243,  1244,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   238,   239,   240,   241,   242,   243,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   244,     0,     0,  1268,
       0,   249,   250,   251,   252,   253,   254,   255,     0,   256,
     257,   258,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1295,     0,     0,     0,     0,     0,  1116,  1117,  1118,  1119,
    1120,  1121,  1122,  1123,  1124,  1125,  1126,     0,  1127,  1128,
    1129,  1130,  1131,  1132,  1133,  1134,  1135,  1136,  1137,     0,
       0,     0,     0,     0,     0,     0,  1138,  1139,  1140,  1141,
    1142,  1143,  1144,  1145,  1146,  1147,  1148,  1149,  1150,  1151,
    1152,  1153,  1154,  1155,  1156,     0,     0,  1157,  1158,  1159,
    1160,  1161,  1162,  1163,  1164,  1165,  1166,  1167,  1168,  1169,
    1170,  1171,   927,  1172,     0,  1173,  1174,  1175,  1176,  1177,
    1178,  1179,  1180,  1181,     0,  1182,  1183,  1184,   248,   249,
     250,   251,   252,   253,   254,   255,     0,   256,   257,   258,
       0,  1315,     0,  1185,     0,     0,     0,     0,     0,     0,
    1186,  1187,  1188,     0,  1189,  1190,  1191,  1192,  1193,  1194,
    1195,  1196,  1197,  1198,  1199,  1200,  1201,  1202,  1203,  1204,
    1205,  1206,  1207,  1208,  1209,  1210,  1211,  1212,  1213,  1214,
    1215,  1216,  1217,  1218,  1219,  1220,  1221,     0,     0,     0,
    1222,  1223,  1224,  1225,  1226,  1227,  1228,  1229,  1230,  1231,
    1232,  1233,  1234,  1235,  1236,  1237,  1238,  1239,  1240,  1241,
    1242,     0,  1243,  1244,     0,     7,     8,     9,    10,     0,
      11,    12,    13,   201,    68,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,     0,     0,     0,     0,     0,
       0,     0,    15,    69,   244,     0,   202,     0,   203,   204,
     205,    74,    75,     0,    20,    76,     0,     0,   206,    22,
       0,     0,    78,     0,  1368,     0,     0,    23,    24,   207,
       0,     0,     0,    26,     0,     0,   208,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,   209,     0,     0,     0,     0,     0,     0,     0,
       0,    44,     0,    45,     0,    46,     0,     0,     0,     0,
      47,     0,   210,   211,    50,     0,     0,    51,    84,     0,
       0,     0,    52,     0,     0,    53,    85,    86,    87,   212,
       0,     0,    89,     0,   213,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    56,     0,     0,
      57,    58,    59,     0,     0,    60,  1405,    61,    62,     0,
       0,    63,     0,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,     0,   256,   257,   258,     0,     0,
       0,   595,     0,     7,     8,     9,    10,     0,    11,    12,
      13,   496,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1496,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1469,  1470,  1471,  1472,     0,  1474,     0,  1475,     0,
      15,   342,     0,     0,   202,     0,   203,   204,   205,    74,
       0,     0,    20,   343,     0,     0,   206,    22,     0,     0,
      78,     0,     0,     0,  1528,    23,    24,   207,     0,     0,
       0,    26,     0,     0,   208,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
     209,     0,     0,     0,     0,     0,     0,     0,     0,    44,
       0,    45,     0,    46,     0,     0,     0,     0,    47,     0,
     210,   211,    50,     0,     0,    51,    84,     0,     0,     0,
      52,     0,     0,    53,   345,   346,    87,   212,     0,     0,
      89,     0,   213,     0,     7,     8,     9,    10,     0,    11,
      12,    13,    14,     0,     0,    56,   189,     0,    57,    58,
      59,     0,     0,    60,     0,    61,    62,     0,     0,    63,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,     0,     0,     0,     0,     0,     0,     0,
       0,    15,   244,     0,     0,    16,     0,    17,    18,    19,
       0,     0,     0,    20,     0,     0,     0,    21,    22,     0,
       0,     0,     0,     0,     0,     0,    23,    24,    25,     0,
       0,     0,    26,     0,     0,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,     0,     0,     0,     0,     0,     0,     0,     0,
      44,     0,    45,     0,    46,     0,     0,     0,     0,    47,
       0,    48,    49,    50,     0,     0,    51,     0,     0,     0,
       0,    52,     0,     0,    53,     0,     0,     0,    54,     7,
       8,     9,    10,    55,    11,    12,    13,    14,     0,     0,
       0,     0,     0,     0,     0,     0,    56,     0,     0,    57,
      58,    59,     0,     0,    60,     0,   190,    62,     0,     0,
      63,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,     0,   256,   257,   258,    15,     0,     0,  1303,
      16,     0,    17,    18,    19,     0,     0,     0,    20,     0,
       0,     0,    21,    22,     0,   483,   484,   485,     0,     0,
       0,    23,    24,    25,     0,     0,     0,    26,     0,     0,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,     0,     0,     0,
       0,     0,     0,     0,     0,    44,     0,    45,     0,    46,
       0,     0,     0,     0,    47,     0,    48,    49,    50,   220,
       0,    51,     0,     0,     0,     0,    52,     0,     0,    53,
       0,   221,   222,    54,     7,     8,     9,    10,    55,    11,
      12,    13,    14,     0,     0,     0,     0,     0,     0,     0,
       0,    56,     0,     0,    57,    58,    59,     0,     0,    60,
       0,    61,    62,   437,     0,    63,     0,     0,   488,   224,
       0,   225,     0,     0,     0,     0,   226,     0,   227,     0,
       0,    15,   442,     0,     0,    16,     0,    17,    18,    19,
       0,     0,     0,    20,     0,     0,     0,    21,    22,     0,
       0,     0,     0,     0,     0,   291,    23,    24,    25,     0,
       0,     0,    26,     0,     0,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,     0,     0,     0,     0,     0,     0,     0,     0,
      44,     0,    45,     0,    46,     0,     0,     0,     0,    47,
       0,    48,    49,    50,     0,     0,    51,     0,     0,     0,
       0,    52,     0,     0,    53,     0,     0,     0,    54,     7,
       8,     9,    10,    55,    11,    12,    13,    14,     0,     0,
       0,     0,     0,     0,     0,     0,    56,     0,     0,    57,
      58,    59,     0,     0,    60,     0,    61,    62,     0,     0,
      63,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,     0,     0,     0,    15,   721,     0,     0,
      16,   244,    17,    18,    19,     0,     0,     0,    20,     0,
       0,     0,    21,    22,     0,     0,     0,     0,     0,     0,
       0,    23,    24,    25,     0,     0,     0,    26,     0,     0,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,     0,     0,     0,
       0,     0,     0,     0,     0,    44,     0,    45,     0,    46,
       0,     0,     0,     0,    47,     0,    48,    49,    50,     0,
       0,    51,     0,     0,     0,     0,    52,     0,     0,    53,
       0,     0,     0,    54,     7,     8,     9,    10,    55,    11,
      12,    13,    14,     0,     0,     0,     0,     0,     0,     0,
       0,    56,     0,     0,    57,    58,    59,     0,     0,    60,
       0,    61,    62,     0,     0,    63,     0,     0,   593,     0,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,    15,   256,   257,   258,    16,     0,    17,    18,    19,
       0,     0,     0,    20,     0,     0,     0,    21,    22,     0,
       0,     0,     0,     0,     0,     0,    23,    24,    25,     0,
       0,     0,    26,     0,     0,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,     0,     0,     0,     0,     0,     0,     0,     0,
      44,     0,    45,     0,    46,     0,     0,     0,     0,    47,
       0,    48,    49,    50,     0,     0,    51,     0,     0,     0,
       0,    52,     0,     0,    53,     0,     0,     0,    54,     7,
       8,     9,    10,    55,    11,    12,    13,    14,   935,     0,
       0,     0,     0,     0,     0,     0,    56,     0,     0,    57,
      58,    59,     0,     0,    60,     0,    61,    62,     0,     0,
      63,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,     0,     0,     0,    15,     0,     0,     0,
      16,   244,    17,    18,    19,     0,     0,     0,    20,     0,
       0,     0,    21,    22,     0,     0,     0,     0,     0,     0,
       0,    23,    24,    25,     0,     0,     0,    26,     0,     0,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,     0,     0,     0,
       0,     0,     0,     0,     0,    44,     0,    45,     0,    46,
       0,     0,     0,     0,    47,     0,    48,    49,    50,     0,
       0,    51,     0,     0,     0,     0,    52,     0,     0,    53,
       0,     0,     0,    54,     7,     8,     9,    10,    55,    11,
      12,    13,    14,     0,     0,     0,     0,     0,     0,     0,
       0,    56,     0,     0,    57,    58,    59,     0,     0,    60,
       0,    61,    62,  1069,     0,    63,     0,   940,     0,     0,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,    15,   256,   257,   258,    16,     0,    17,    18,    19,
       0,     0,     0,    20,     0,     0,     0,    21,    22,     0,
       0,     0,     0,     0,     0,     0,    23,    24,    25,     0,
       0,     0,    26,     0,     0,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,     0,     0,     0,     0,     0,     0,     0,     0,
      44,     0,    45,     0,    46,     0,     0,     0,     0,    47,
       0,    48,    49,    50,     0,     0,    51,     0,     0,     0,
       0,    52,     0,     0,    53,     0,     0,     0,    54,     7,
       8,     9,    10,    55,    11,    12,    13,    14,  1347,     0,
       0,     0,     0,     0,     0,     0,    56,     0,     0,    57,
      58,    59,     0,     0,    60,     0,    61,    62,     0,     0,
      63,     0,     0,     0,   236,   237,   238,   239,   240,   241,
     242,   243,     0,     0,     0,     0,    15,     0,     0,     0,
      16,   244,    17,    18,    19,     0,     0,     0,    20,     0,
       0,     0,    21,    22,     0,     0,     0,     0,     0,     0,
       0,    23,    24,    25,     0,     0,     0,    26,     0,     0,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,     0,     0,     0,
       0,     0,     0,     0,     0,    44,     0,    45,     0,    46,
       0,     0,     0,     0,    47,     0,    48,    49,    50,     0,
       0,    51,     0,     0,     0,     0,    52,     0,     0,    53,
       0,     0,     0,    54,     7,     8,     9,    10,    55,    11,
      12,    13,    14,     0,     0,     0,     0,     0,     0,     0,
       0,    56,     0,     0,    57,    58,    59,     0,     0,    60,
       0,    61,    62,  1497,     0,    63,  1279,     0,     0,     0,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,    15,   256,   257,   258,    16,     0,    17,    18,    19,
       0,     0,     0,    20,     0,     0,     0,    21,    22,     0,
       0,     0,     0,     0,     0,     0,    23,    24,    25,     0,
       0,     0,    26,     0,     0,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,     0,     0,     0,     0,     0,     0,     0,     0,
      44,     0,    45,     0,    46,   483,   484,   485,     0,    47,
       0,    48,    49,    50,     0,     0,    51,     0,     0,     0,
       0,    52,     0,     0,    53,     0,     0,     0,    54,   651,
     652,   653,    10,    55,    11,   654,   655,    67,    68,     0,
       0,   656,   486,     0,   487,     0,    56,     0,     0,    57,
      58,    59,     0,     0,    60,     0,    61,    62,     0,   220,
      63,   236,   237,   238,   239,   240,   241,   242,   243,     0,
       0,   221,   222,   464,     0,     0,   657,    69,   244,     0,
      70,     0,    71,    72,    73,    74,   465,     0,   658,    76,
       0,     0,    77,   659,     0,     0,    78,     0,     0,     0,
       0,   660,   661,    79,     0,     0,     0,     0,   488,   224,
      80,   225,     0,     0,     0,     0,   226,     0,   227,     0,
       0,     0,     0,     0,     0,     0,    81,     0,     0,     0,
       0,     0,     0,     0,     0,   662,     0,   663,     0,   664,
       0,     0,   489,   466,   665,     0,    82,    83,   666,     0,
       0,   667,    84,     0,     0,     0,   668,     0,     0,   669,
      85,    86,    87,    88,     0,     0,    89,     0,    90,     7,
       8,     9,    10,     0,    11,    12,    13,    14,     0,     0,
       0,   670,     0,     0,   671,   672,     0,     0,     0,   673,
       0,   674,     0,     0,     0,   675,     0,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,     0,   256,
     257,   258,     0,     0,     0,  1534,    15,     0,     0,     0,
      16,     0,    17,    18,    19,     0,     0,     0,    20,     0,
       0,     0,    21,    22,     0,     0,     0,     0,     0,     0,
       0,    23,    24,    25,     0,     0,     0,    26,     0,     0,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,     0,     0,     0,
       0,     0,     0,     0,     0,    44,     0,    45,     0,    46,
     217,   218,   219,     0,    47,     0,    48,    49,    50,     0,
       0,    51,     0,     0,     0,     0,    52,     0,     0,    53,
       0,     0,     0,    54,   651,   652,   653,    10,    55,    11,
     654,   655,    67,    68,     0,     0,  1046,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    60,
       0,    61,    62,     0,   220,    63,   236,   237,   238,   239,
     240,   241,   242,   243,     0,     0,   221,   222,   464,     0,
       0,   657,    69,   244,     0,    70,     0,    71,    72,    73,
      74,   465,     0,   658,    76,     0,     0,    77,   659,     0,
       0,    78,     0,     0,     0,     0,   660,   661,    79,     0,
       0,     0,     0,   223,   224,    80,   225,     0,     0,     0,
       0,   226,     0,   227,     0,   217,   218,   219,     0,     0,
       0,    81,     0,     0,     0,     0,     0,     0,     0,     0,
     662,     0,   663,     0,   664,     0,     0,   321,   466,   665,
       0,    82,    83,   666,     0,     0,   667,    84,     0,     0,
       0,   668,     0,     0,   669,    85,    86,    87,    88,     0,
       0,    89,     0,    90,     0,     7,     8,     9,    10,   220,
      11,    12,    13,     0,     0,     0,   670,  1396,     0,   671,
     672,   221,   222,     0,   673,     0,   674,     0,   696,     0,
     675,     0,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,     0,   256,   257,   258,   697,     0,     0,
       0,     0,  1316,     0,     0,     0,     0,     0,   223,  1280,
    1281,  1282,     0,     0,  1317,     0,   226,     0,   227,  1318,
       0,     0,     0,     0,     0,     0,     0,    23,    24,  1283,
       0,     0,     0,    26,  1284,     0,     0,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,     0,     0,     0,     7,     8,     9,    10,     0,
      11,    12,    13,    45,     0,    46,     0,     0,     0,     0,
    1319,     0,     0,     0,  1320,     0,     0,  1321,     0,     0,
       0,     0,    52,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1316,     0,     0,     0,     0,  1322,     0,     0,
    1323,  1324,  1325,     0,  1317,  1326,     0,  1397,    62,  1318,
       0,  1328,     0,     0,     0,     0,     0,    23,    24,     0,
       0,     0,     0,    26,     0,     0,     0,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,     0,     0,     0,     7,     8,     9,    10,     0,
      11,    12,    13,    45,     0,    46,     0,     0,     0,     0,
    1319,     0,     0,     0,  1320,     0,     0,  1321,     0,     0,
       0,     0,    52,     0,     0,     0,     0,     0,     0,     0,
       0,   236,   237,   238,   239,   240,   241,   242,   243,     0,
       0,     0,  1316,     0,     0,     0,     0,  1322,   244,     0,
    1323,  1324,  1325,     0,  1317,  1326,     0,  1327,    62,  1318,
       0,  1328,     0,     0,     0,     0,     0,    23,    24,     0,
       0,     0,     0,    26,     0,     0,     0,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,   651,   652,   653,    10,     0,    11,   654,   655,
       0,     0,     0,    45,   837,    46,     0,     0,     0,     0,
    1319,     0,     0,     0,  1320,     0,     0,  1321,     0,   774,
       0,     0,    52,     0,     0,     0,     0,     0,     0,   217,
     218,   219,     0,     0,     0,   775,     0,     0,     0,   657,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   776,
       0,   658,     0,     0,     0,  1326,   659,  1327,    62,     0,
       0,  1328,   777,   778,   660,   661,     0,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   779,   256,
     257,   258,   581,   220,     0,     0,     0,   236,   237,   238,
     239,   240,   241,   242,   243,   221,   222,     0,   662,     0,
     663,     0,   664,     0,   244,     0,     0,   665,     0,   780,
       0,   666,   781,     0,   667,   782,     0,     0,     0,   668,
       0,     0,   669,     0,     0,     0,    70,     0,    71,    72,
      73,   783,   223,   224,     0,   225,     0,     0,   266,     0,
     226,     0,   227,   784,   670,     0,     0,   671,   672,   944,
       0,     0,   673,  1283,   838,     0,    80,   785,   675,   945,
     946,   947,   948,   949,   950,   951,   952,     0,     0,     0,
       0,     0,   267,     0,     0,     0,   953,     0,   954,   955,
     956,   957,   958,   959,   960,   961,   962,   963,   964,   965,
       0,     0,    82,    83,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   966,    88,
       0,     0,     0,     0,    90,     0,     0,     0,     0,     0,
       0,   340,   341,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   597,     0,
    1408,  1409,  1410,  1411,  1412,  1413,  1414,  1415,     0,     0,
       0,     0,   967,     0,     0,     0,     0,  1416,     0,     0,
       0,     0,   342,     0,     0,    70,     0,    71,    72,    73,
      74,     0,     0,     0,   343,     0,     0,    77,     0,     0,
       0,    78,   698,   699,   700,     0,     0,     0,    79,     0,
       0,   968,     0,     0,   969,    80,   970,   971,   972,   973,
     974,   975,   976,   977,   978,   979,   980,     0,   981,   982,
       0,    81,   983,   340,   341,     0,     0,     0,     0,     0,
       0,     0,     0,   344,     0,     0,    70,     0,    71,    72,
      73,    82,    83,     0,     0,     0,     0,    84,    77,     0,
       0,     0,     0,     0,     0,   345,   346,    87,    88,    79,
       0,    89,     0,    90,   342,     0,    80,    70,   347,    71,
      72,    73,    74,     0,     0,     0,   343,     0,     0,    77,
       0,     0,    81,    78,   348,   774,  1417,  1418,  1419,  1420,
      79,     0,  1421,  1422,  1423,  1424,  1425,    80,  1426,  1427,
    1428,     0,    82,    83,     0,     0,     0,     0,     0,     0,
     513,   514,     0,    81,     0,   776,     0,     0,     0,    88,
       0,     0,    89,     0,    90,   344,     0,     0,   777,   778,
       0,     0,     0,    82,    83,     0,     0,     0,     0,    84,
       0,     0,     0,     0,   779,     0,     0,   345,   346,    87,
      88,   342,     0,    89,    70,    90,    71,    72,    73,    74,
       0,     0,     0,   343,     0,     0,    77,     0,     0,     0,
      78,     0,     0,     0,     0,   780,   348,    79,   781,     0,
       0,   782,     0,     0,    80,   236,   237,   238,   239,   240,
     241,   242,   243,     0,     0,     0,     0,   783,     0,     0,
      81,     0,   244,     0,     0,     0,     0,     0,     0,   784,
       0,     0,   344,     0,     0,     0,     0,     0,     0,     0,
      82,    83,     0,   785,     0,     0,    84,     0,     0,     0,
       0,     0,     0,     0,   345,   346,    87,    88,     0,     0,
      89,     0,    90,   236,   237,   238,   239,   240,   241,   242,
     243,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     244,     0,     0,   348,   236,   237,   238,   239,   240,   241,
     242,   243,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   244,   236,   237,   238,   239,   240,   241,   242,   243,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   244,
     236,   237,   238,   239,   240,   241,   242,   243,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   244,     0,     0,
       0,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,     0,   256,   257,   258,   685,   236,   237,   238,
     239,   240,   241,   242,   243,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   244,   236,   237,   238,   239,   240,
     241,   242,   243,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   244,     0,     0,     0,     0,     0,     0,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
       0,   256,   257,   258,   766,     0,     0,     0,     0,     0,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,     0,   256,   257,   258,   911,     0,     0,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,     0,
     256,   257,   258,  1028,     0,     0,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,     0,   256,   257,
     258,  1299,   852,   853,   854,   855,   856,   857,   858,   859,
       0,     0,     0,     0,     0,     0,   217,   218,   219,   860,
       0,  1301,     0,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,     0,   256,   257,   258,     0,     0,
       0,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,    -2,   256,   257,   258,     0,     0,     0,     0,
       0,  1409,  1410,  1411,  1412,  1413,  1414,  1415,     0,     0,
     220,     0,     0,     0,     0,     0,     0,  1416,     0,     0,
       0,     0,   221,   222,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   105,
       0,   106,     0,     0,   107,   108,     0,     0,     0,     0,
       0,     0,   109,   110,   336,     0,     0,     0,     0,   223,
     224,   111,   225,   112,   113,   114,   115,   226,     0,   227,
     116,     0,     0,     0,     0,   117,     0,     0,   861,   862,
     863,   864,   865,   866,   867,   868,   869,   870,   871,     0,
     872,   873,   874,   118,   119,   120,   121,   122,   123,   124,
     125,     0,     0,     0,     0,     0,   126,   127,   128,   129,
       0,     0,     0,     0,     0,   130,   131,    67,    68,   132,
     133,   462,     0,   463,   134,     0,     0,     0,     0,     0,
     135,   136,     0,   137,     0,     0,     0,  1418,  1419,  1420,
       0,   138,  1421,  1422,  1423,  1424,  1425,     0,  1426,  1427,
    1428,     0,     0,   464,     0,     0,     0,    69,     0,     0,
      70,     0,    71,    72,    73,    74,   465,     0,     0,    76,
       0,     0,    77,     0,     0,     0,    78,   238,   239,   240,
     241,   242,   243,    79,     0,    70,     0,    71,    72,    73,
      80,     0,   244,  1410,  1411,  1412,  1413,  1414,  1415,     0,
       0,     0,     0,     0,     0,     0,    81,     0,  1416,   238,
     239,   240,   241,   242,   243,    80,     0,     0,     0,     0,
       0,     0,     0,   466,   244,     0,    82,    83,     0,     0,
       0,   267,    84,     0,  1410,  1411,  1412,  1413,  1414,  1415,
      85,    86,    87,    88,     0,     0,    89,     0,    90,  1416,
       0,    82,    83,     0,     0,     0,     0,     0,     0,     0,
       0,   467,     0,     0,     0,     0,   468,     0,    88,     0,
       0,     0,     0,    90,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   217,   218,   219,     0,   187,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,     0,   256,   257,   258,     0,     0,  1418,  1419,
    1420,     0,     0,  1421,  1422,  1423,  1424,  1425,     0,  1426,
    1427,  1428,     0,     0,     0,   306,   220,   249,   250,   251,
     252,   253,   254,   255,     0,   256,   257,   258,   221,   222,
       0,     0,     0,     0,     0,     0,   217,   218,   219,     0,
    1419,  1420,   306,     0,  1421,  1422,  1423,  1424,  1425,     0,
    1426,  1427,  1428,     0,     0,     0,   105,     0,   106,     0,
       0,     0,   108,     0,     0,   223,   224,     0,   225,   109,
     110,     0,     0,   226,     0,   227,     0,     0,     0,     0,
     112,   113,   114,   105,     0,   106,     0,     0,     0,   108,
     220,     0,   301,     0,     0,     0,   109,   110,     0,   501,
       0,     0,   221,   222,     0,     0,     0,   112,   300,   114,
       0,     0,     0,   217,   218,   219,   124,     0,     0,   301,
       0,     0,   698,   699,   700,     0,   129,     0,     0,     0,
       0,     0,   130,     0,     0,     0,   132,   133,     0,   223,
     224,     0,   225,   124,     0,     0,     0,   226,   136,   227,
     137,     0,     0,   129,    67,    68,     0,     0,   462,   130,
    1283,     0,     0,     0,   133,  1362,    70,   220,    71,    72,
      73,   701,   702,     0,     0,   136,     0,   137,    77,   221,
     222,     0,     0,     0,     0,     0,     0,     0,     0,    79,
     464,     0,     0,     0,    69,     0,    80,    70,     0,    71,
      72,    73,    74,   465,     0,     0,    76,     0,     0,    77,
       0,     0,    81,    78,     0,     0,   223,   224,     0,   225,
      79,     0,     0,     0,   226,     0,   227,    80,     0,     0,
       0,     0,    82,    83,     0,     0,     0,  1283,     0,     0,
       0,     0,  1364,    81,     0,     0,   703,     0,     0,    88,
       0,     0,    89,     0,    90,    67,    68,     0,     0,   800,
     466,     0,     0,    82,    83,     0,     0,     0,     0,    84,
       0,     0,     0,     0,     0,     0,     0,    85,    86,    87,
      88,     0,     0,    89,     0,    90,    67,    68,     0,     0,
       0,   464,     0,     0,     0,    69,     0,     0,    70,     0,
      71,    72,    73,    74,   465,     0,     0,    76,     0,     0,
      77,     0,     0,     0,    78,     0,     0,     0,     0,     0,
       0,    79,   464,   217,   218,   219,    69,     0,    80,    70,
       0,    71,    72,    73,    74,   465,     0,     0,    76,     0,
       0,    77,     0,     0,    81,    78,     0,     0,     0,     0,
       0,     0,    79,     0,     0,     0,     0,     0,     0,    80,
       0,   466,     0,     0,    82,    83,     0,     0,     0,     0,
      84,     0,     0,    67,    68,    81,     0,   220,    85,    86,
      87,    88,     0,     0,    89,     0,    90,     0,     0,   221,
     222,     0,   466,     0,     0,    82,    83,    67,    68,     0,
       0,    84,     0,     0,     0,     0,     0,     0,     0,    85,
      86,    87,    88,    69,     0,    89,    70,    90,    71,    72,
      73,    74,    75,     0,     0,    76,   223,   224,    77,   225,
       0,     0,    78,     0,   226,     0,   227,    69,     0,    79,
      70,     0,    71,    72,    73,    74,    80,     0,     0,    76,
       0,   295,    77,     0,     0,     0,    78,     0,     0,     0,
       0,     0,    81,    79,     0,     0,     0,     0,     0,     0,
      80,   217,   218,   219,     0,     0,     0,     0,     0,     0,
       0,     0,    82,    83,    67,    68,    81,     0,    84,     0,
       0,     0,     0,     0,     0,     0,    85,    86,    87,    88,
       0,     0,    89,   610,    90,     0,    82,    83,   486,     0,
     487,     0,    84,    67,     0,     0,     0,     0,     0,     0,
      85,    86,    87,    88,    69,   220,    89,    70,    90,    71,
      72,    73,    74,     0,     0,     0,    76,   221,   222,    77,
       0,     0,     0,    78,     0,     0,     0,     0,     0,     0,
      79,     0,     0,    69,     0,     0,    70,    80,    71,    72,
      73,    74,   524,     0,     0,    76,     0,     0,    77,     0,
       0,     0,    78,    81,   223,   224,     0,   225,     0,    79,
       0,     0,   226,     0,   227,     0,    80,     0,     0,     0,
       0,     0,     0,    82,    83,     0,     0,     0,     0,    84,
     177,     0,    81,     0,     0,     0,     0,    85,    86,    87,
      88,     0,     0,    89,     0,    90,     0,     0,     0,     0,
       0,     0,    82,    83,   177,     0,     0,     0,    84,     0,
       0,     0,     0,     0,     0,     0,    85,    86,    87,    88,
     178,     0,    89,    70,    90,    71,    72,    73,    74,  1005,
       0,     0,   179,     0,     0,    77,     0,     0,     0,    78,
       0,     0,     0,     0,   178,     0,    79,    70,     0,    71,
      72,    73,    74,    80,     0,     0,   179,     0,     0,    77,
       0,     0,     0,    78,     0,     0,     0,     0,     0,    81,
      79,     0,     0,     0,     0,     0,     0,    80,   217,   218,
     219,     0,     0,     0,     0,     0,     0,     0,     0,    82,
      83,    67,     0,    81,     0,    84,     0,     0,     0,     0,
       0,     0,     0,   180,   181,    87,    88,     0,     0,    89,
       0,    90,     0,    82,    83,     0,     0,     0,     0,    84,
       0,     0,     0,     0,     0,     0,     0,   180,   181,    87,
      88,    69,   220,    89,    70,    90,    71,    72,    73,    74,
       0,     0,     0,    76,   221,   222,    77,     0,     0,     0,
      78,     0,     0,     0,     0,     0,     0,    79,     0,     0,
       0,     0,     0,     0,    80,     0,     0,     0,     0,     0,
       0,     0,   105,     0,   106,     0,     0,   107,   108,     0,
      81,   223,   224,     0,   225,   109,   110,     0,     0,   226,
       0,   227,     0,     0,   111,     0,   112,   113,   114,   115,
      82,    83,  1283,   116,     0,     0,    84,  1366,   117,     0,
       0,     0,     0,     0,    85,    86,    87,    88,     0,     0,
      89,     0,    90,     0,     0,     0,   118,   119,   120,   121,
     122,   123,   124,   125,     0,     0,     0,     0,     0,   126,
     127,   128,   129,     0,     0,   105,     0,   106,   130,   131,
     107,   108,   132,   133,     0,     0,     0,   134,   109,   110,
       0,     0,     0,   135,   136,     0,   137,   111,     0,   112,
     113,   114,   115,     0,   138,     0,   116,     0,     0,     0,
       0,   117,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   694,     0,     0,     0,     0,     0,   118,
     119,   120,   121,   122,   123,   124,   125,     0,     0,     0,
       0,     0,   126,   127,   128,   129,     0,     0,   105,     0,
     106,   130,   131,   107,   108,   132,   133,     0,     0,     0,
     134,   109,   110,     0,     0,     0,   135,   136,     0,   137,
     111,     0,   112,   113,   114,   115,     0,   138,     0,   116,
       0,     0,     0,     0,   117,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   877,     0,     0,     0,
       0,     0,   118,   119,   120,   121,   122,   123,   124,   125,
       0,     0,     0,     0,     0,   126,   127,   128,   129,     0,
       0,   105,     0,   106,   130,   131,   107,   108,   132,   133,
       0,     0,     0,   134,   109,   110,     0,     0,     0,   135,
     136,     0,   137,   111,     0,   112,   113,   114,   115,     0,
     138,     0,   116,     0,     0,     0,     0,   117,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   922,
       0,     0,     0,     0,     0,   118,   119,   120,   121,   122,
     123,   124,   125,     0,     0,     0,     0,     0,   126,   127,
     128,   129,     0,     0,   105,     0,   106,   130,   131,   107,
     108,   132,   133,     0,     0,     0,   134,   109,   110,     0,
       0,     0,   135,   136,     0,   137,   111,     0,   112,   113,
     114,   115,     0,   138,     0,   116,     0,     0,     0,     0,
     117,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1029,     0,     0,     0,     0,     0,   118,   119,
     120,   121,   122,   123,   124,   125,     0,     0,     0,     0,
       0,   126,   127,   128,   129,     0,     0,   105,     0,   106,
     130,   131,   107,   108,   132,   133,     0,     0,     0,   134,
     109,   110,     0,     0,     0,   135,   136,     0,   137,   111,
       0,   112,   113,   114,   115,     0,   138,     0,   116,     0,
       0,     0,     0,   117,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1082,     0,     0,     0,     0,
       0,   118,   119,   120,   121,   122,   123,   124,   125,     0,
       0,     0,     0,     0,   126,   127,   128,   129,     0,     0,
     105,     0,   106,   130,   131,   107,   108,   132,   133,     0,
       0,     0,   134,   109,   110,     0,     0,     0,   135,   136,
       0,   137,   111,     0,   112,   113,   114,   115,     0,   138,
       0,   116,   217,   218,   219,     0,   117,   891,     0,     0,
       0,     0,     0,   217,   218,   219,     0,     0,  1304,    70,
       0,    71,    72,    73,   118,   119,   120,   121,   122,   123,
     124,   125,     0,     0,     0,     0,     0,   126,   127,   128,
     129,     0,     0,     0,     0,     0,   130,   131,     0,    80,
     132,   133,     0,     0,     0,   134,   220,     0,     0,     0,
       0,   135,   136,     0,   137,   267,     0,   220,   221,   222,
       0,     0,   138,     0,    70,     0,    71,    72,    73,   221,
     222,     0,     0,     0,     0,    82,    83,     0,     0,     0,
       0,  1455,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    88,     0,    80,   223,   224,    90,   225,     0,
       0,     0,     0,   226,     0,   227,   223,   224,     0,   225,
     267,     0,     0,   105,   226,   106,   227,     0,     0,   108,
     188,     0,     0,     0,     0,     0,   109,   110,     0,     0,
      82,    83,     0,     0,     0,     0,     0,   112,   300,   114,
       0,     0,     0,     0,   116,     0,     0,    88,     0,   301,
       0,     0,    90,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   124,     0,   194,     0,     0,     0,     0,
       0,     0,     0,   129,     0,     0,     0,     0,     0,   130,
       0,     0,     0,     0,   133,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   135,   136,   105,   137,   106,     0,
       0,   107,   108,     0,     0,     0,     0,     0,     0,   109,
     110,     0,  -155,     0,     0,     0,     0,     0,   111,     0,
     112,   113,   114,   115,     0,     0,     0,   116,     0,     0,
       0,     0,   117,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     118,   119,   120,   121,   122,   123,   124,   125,     0,     0,
       0,     0,     0,   126,   127,   128,   129,     0,     0,   105,
       0,   106,   130,   131,     0,   108,   132,   133,     0,     0,
       0,   134,   109,   110,     0,     0,     0,   135,   136,     0,
     137,     0,     0,   112,   113,   114,   105,     0,   106,     0,
     116,     0,   108,     0,     0,   301,     0,     0,     0,   109,
     110,   105,     0,   106,     0,     0,     0,   108,     0,     0,
     112,   300,   114,     0,   109,   110,     0,     0,     0,   124,
       0,     0,   301,     0,     0,   112,   300,   114,     0,   129,
       0,     0,     0,     0,     0,   130,     0,   301,     0,   132,
     133,     0,     0,     0,     0,     0,   124,   312,     0,     0,
     135,   136,     0,   137,     0,     0,   129,     0,     0,     0,
       0,   124,   130,     0,     0,     0,     0,   133,     0,     0,
       0,   129,     0,     0,     0,     0,     0,   130,   136,     0,
     137,     0,   133,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   136,     0,   137
};

static const yytype_int16 yycheck[] =
{
       1,    61,   132,   113,   132,   495,   935,   482,   736,   321,
      92,    44,   713,   515,   466,   184,    44,   142,   299,    15,
     142,   616,    13,    15,   464,   142,   607,    15,   149,   662,
     151,   152,   153,   154,   148,   156,    44,   158,   588,   160,
      59,    10,    98,   495,    13,   147,   486,     0,   719,     6,
     148,     8,   148,   334,   494,   176,   170,   147,    10,    11,
      12,    62,   756,   165,   473,   148,   187,   188,   165,   167,
      76,   167,    76,   194,   195,   165,   626,   748,   749,   165,
     751,   752,   753,   754,   167,   148,   165,   637,   589,    33,
      91,    92,   165,    76,    76,   166,   167,   723,    99,   725,
     726,   727,   728,   729,   167,   799,   148,   126,   165,   142,
     148,   108,   109,   110,   142,   112,   113,   114,   165,   148,
     117,    81,    82,    83,    33,   167,   148,   124,    88,   167,
     190,    33,   129,   130,   142,   132,   133,   134,   167,   136,
     137,   147,   775,   147,   150,   167,   150,   148,   149,   156,
     151,   152,   153,   154,   148,   156,   148,   158,   156,   160,
     148,   113,    33,   165,   147,   147,   618,   150,   150,   160,
     151,   167,   165,   167,   299,   176,   666,   299,   148,   261,
     262,   151,   299,   184,   156,   166,   187,   188,   357,   501,
     165,   160,   148,   194,   195,   277,   278,   257,   150,   148,
      13,   165,    15,   612,    17,   330,   696,   757,   330,   334,
     167,   167,   334,   330,   148,   716,   528,   334,   167,   720,
     164,   165,   166,   632,   633,   634,   635,   636,   809,   148,
       6,   232,     8,   167,   148,   148,   907,   293,   819,   165,
     148,   150,   165,   166,   167,   795,   796,    60,   167,   209,
     210,   211,   212,   167,   167,   757,   165,   166,   151,   167,
     261,   262,   164,   165,   166,   165,   299,   151,   165,    75,
     941,   299,   393,   166,   165,   276,   277,   278,   279,   280,
     281,  1009,   166,   165,   759,   286,    13,   913,    15,   148,
      17,   299,    75,   164,   165,   166,   165,   330,   148,   708,
     356,   334,   330,   300,   301,   165,   334,   267,   167,   306,
     148,    13,     2,    15,    33,    17,   148,   167,   148,   148,
     321,   165,   330,    10,    11,    12,   334,   148,   141,   167,
     148,   291,   148,    60,   646,   167,   776,   167,   167,   920,
     792,   165,   155,   144,   145,   146,   167,   160,     6,   167,
       8,   167,   165,   903,   165,   147,   357,   149,    60,   151,
      50,   851,   165,   149,   645,   151,    56,    57,    58,    59,
      60,   165,  1005,    63,   165,   166,   147,    64,   149,   150,
     151,   165,  1110,   695,   147,   794,   149,   165,   151,    76,
      77,   165,   393,    18,    19,    20,    21,    22,    23,   851,
     165,   903,   811,   147,   165,   149,   156,   151,    33,  1004,
     991,   412,   165,   147,   141,   149,   167,   151,  1347,   166,
     167,   165,   923,  1280,  1281,  1282,   113,   114,   155,   116,
     165,   166,   167,   160,   121,   165,   123,   165,   165,   141,
     165,   160,   161,   162,   445,   164,   165,   166,   449,   450,
     451,   452,   453,   155,   165,   166,   167,   165,   160,   166,
     167,   147,   463,  1013,  1014,   165,   467,   468,   155,   525,
     150,   472,   165,   160,   475,   281,   114,   115,   116,   888,
     536,    64,    65,   539,   512,   166,   895,   896,   897,   898,
     899,   166,   167,   165,   495,   165,   493,   165,   281,   165,
     501,   166,   167,   193,  1099,  1362,   165,  1364,  1103,  1366,
    1011,   512,  1369,  1370,  1371,   150,  1017,  1018,   165,   166,
     645,   150,   482,   645,   525,   147,   148,   528,   645,    10,
      11,    12,   150,   158,   159,   160,   161,   162,   344,   164,
     165,   166,   165,   166,   165,   165,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   878,   165,   258,  1263,
     165,   165,   151,   263,   160,   166,   150,    48,   148,   147,
     165,   156,   148,    64,   165,   165,   149,   588,   589,   590,
     168,    20,    21,    22,    23,    76,    77,    15,   165,   600,
     157,   148,   167,   167,    33,  1106,   607,   167,   167,   299,
     611,   167,   645,   167,   674,   616,   167,   645,   157,   620,
     621,   622,   623,   624,   625,   626,   167,   167,   148,   662,
    1331,   167,   113,   114,   662,   116,   637,   645,   328,   167,
     121,   167,   123,   167,   167,   646,   647,   157,   167,   167,
     167,   167,   167,   167,   662,   167,   167,   713,   167,   465,
     466,   167,   167,   719,   167,   157,   167,   723,   167,   725,
     726,   727,   728,   729,   702,   165,   167,   160,   167,   167,
     166,   166,   465,   466,  1093,   167,   167,   684,   685,   495,
     168,   165,   748,   749,   695,   751,   752,   753,   754,   150,
     390,   761,   762,   167,   147,   165,   148,   708,   148,   769,
     148,   771,   495,   148,  1442,   716,   406,   407,   524,   720,
     148,   148,   723,   413,   725,   726,   727,   728,   729,   158,
     159,   160,   161,   162,   149,   164,   165,   166,    33,   165,
     150,   742,   775,   165,   745,  1340,   165,   775,   165,   165,
    1444,  1445,  1446,   167,   167,   756,   757,    48,   167,   889,
     160,   889,  1357,  1358,  1359,  1255,   160,   775,   170,   147,
      10,    11,    12,    13,  1275,    48,  1277,    17,   838,   889,
      76,   165,   156,   589,   156,   475,   156,   156,   165,    10,
      10,   167,   793,    10,   795,   796,    10,    10,   799,   759,
      10,   802,   149,  1255,   610,   157,   589,   148,   809,   149,
     167,   160,   618,   873,   167,   160,   167,   472,   819,   149,
      60,   149,   168,   160,   167,   167,   165,   610,   829,   167,
     147,    33,  1333,   523,   167,   618,  1337,   166,   170,  1434,
     165,   165,   165,   533,   166,   166,  1441,   167,   150,   165,
     165,   907,  1447,  1448,   167,   148,   148,   913,   148,  1553,
     148,   148,   890,   158,   159,   160,   161,   162,  1562,   164,
     165,   166,   112,   113,   151,   160,   148,   878,   167,   165,
     881,   149,   149,   167,   166,   941,    10,   888,   578,   168,
     168,   167,   889,   894,   895,   896,   897,   898,   899,   900,
     170,   141,   903,   593,   148,  1500,    33,    48,  1503,   165,
     716,   170,   913,   165,   720,   155,  1037,   607,   147,   920,
     160,   170,   923,   148,  1006,   165,   167,    22,    23,   157,
     157,  1432,   167,   716,   935,   157,   167,   720,    33,   157,
      10,    10,  1537,   149,    10,    11,    12,    13,    10,    11,
      12,    17,    10,    10,    10,   645,   611,  1552,   160,   161,
     162,    10,   164,   165,   166,   149,   621,   622,   623,   624,
     625,   167,  1005,   148,   165,   170,  1288,  1005,   167,   167,
     670,   671,   672,   673,   170,   675,   792,   168,    22,    23,
     991,  1112,  1113,   167,    60,   168,   167,  1005,    15,    33,
    1501,   165,    64,  1004,   165,  1006,   165,   167,   165,   792,
    1011,   167,  1013,  1014,    76,    77,  1017,  1018,   167,   148,
     167,   149,   165,   276,   277,   278,   279,   280,   165,   167,
     156,   158,   159,   160,   161,   162,  1037,   164,   165,   166,
     156,   156,   156,   168,   167,   851,   168,   113,   167,   147,
     167,   113,   114,   708,   116,   745,   167,   167,   149,   121,
      10,   123,   149,   158,   159,   160,   161,   162,   851,   164,
     165,   166,    10,    10,   149,   141,   149,    10,   149,   165,
      15,   148,   167,  1084,   167,   167,    10,   168,   167,   155,
     167,   167,  1093,   148,   160,   167,   157,   157,  1099,   165,
     168,   149,  1103,   157,   166,  1106,    10,    11,    12,    13,
     157,  1112,  1113,    17,   167,    10,    10,   923,   149,   809,
     165,   165,   165,   165,   158,   159,   160,   161,   162,   819,
     164,   165,   166,   823,   167,   167,   149,   167,   793,   149,
     923,    10,   149,   167,   149,  1111,   311,   802,   648,  1258,
    1331,   841,   334,   890,   702,  1461,    60,  1084,   334,   851,
    1255,  1222,   852,   853,   854,   855,   856,   857,   858,   859,
     860,   861,   862,   863,   864,   865,   866,   867,   868,   869,
     870,   871,  1264,  1289,   874,   411,   666,    -1,    10,    11,
      12,    13,   445,    15,    -1,    17,   449,   450,   451,   452,
     453,    -1,  1258,    -1,    -1,  1011,    -1,    -1,    -1,   113,
     463,  1017,  1018,    -1,   467,   468,    -1,    -1,    -1,    -1,
      -1,  1222,    54,    62,    56,    57,    58,    -1,  1011,    -1,
     920,    -1,    -1,   888,  1017,  1018,    -1,   141,    60,    -1,
     895,   896,   897,   898,   899,   935,    85,    -1,    -1,    -1,
      -1,   155,    84,    -1,  1255,    -1,   160,    -1,    -1,    -1,
      -1,    -1,  1263,  1264,    -1,    -1,   105,  1327,   100,    -1,
      61,    -1,    -1,    -1,  1275,  1331,  1277,    16,    17,    18,
      19,    20,    21,    22,    23,    -1,   125,  1288,   120,   121,
      -1,   113,    -1,    -1,    33,    -1,   135,    -1,    -1,   989,
    1106,   991,    -1,   993,    -1,   137,    -1,    -1,    -1,    -1,
     142,    -1,    -1,    -1,    -1,  1375,  1376,    -1,  1378,   141,
    1380,    -1,    -1,  1106,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1333,   155,    -1,    -1,  1337,  1397,   160,  1340,
      -1,   180,    -1,   165,   183,  1094,  1347,   600,    -1,    -1,
      -1,    -1,    -1,    -1,  1044,    -1,  1357,  1358,  1359,   150,
      -1,    -1,    -1,  1094,   155,    -1,   157,  1427,   159,    -1,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,    -1,    -1,    -1,    -1,    -1,
     229,   230,    -1,    -1,    -1,   186,    -1,    -1,    -1,   190,
      -1,   192,   193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   150,    11,   152,   153,   154,   155,   256,    -1,   158,
     159,   160,   161,   162,    -1,   164,   165,   166,    -1,    -1,
      -1,  1432,    -1,  1434,    -1,    -1,   275,    -1,  1093,    -1,
    1441,    -1,    -1,  1444,  1445,  1446,  1447,  1448,    -1,  1255,
      -1,    -1,    -1,    -1,   293,    54,   295,    56,    57,    58,
    1461,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1275,
      -1,  1277,  1255,   312,    -1,   314,   315,   316,   317,   318,
     319,   272,    -1,    -1,    -1,    84,  1546,  1547,  1548,    -1,
    1550,    -1,  1275,    -1,  1277,    -1,    -1,   336,    -1,  1500,
    1501,   100,  1503,    -1,    -1,    -1,   345,    -1,    -1,   348,
      -1,    -1,    -1,    -1,    -1,    -1,    54,   356,    56,    57,
      58,   120,   121,    -1,    -1,    -1,    -1,  1333,    66,    -1,
      -1,  1337,    -1,    -1,    -1,    -1,  1537,    -1,   137,    -1,
      -1,    -1,    -1,   142,    -1,    -1,    84,    -1,    -1,    -1,
    1333,  1552,  1553,    -1,  1337,    -1,   395,    -1,  1248,    -1,
     399,  1562,   100,    -1,    -1,    18,    19,    20,    21,    22,
      23,  1320,   411,  1322,  1323,  1324,  1325,  1326,    -1,  1328,
      33,    -1,   120,   121,    -1,    -1,    -1,    -1,    -1,  1320,
      -1,  1322,  1323,  1324,  1325,  1326,    -1,  1328,    -1,   137,
      -1,   392,    -1,    -1,   142,    -1,  1296,    -1,    -1,   448,
      -1,  1301,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   464,  1432,   165,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,   476,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,   486,    -1,  1432,
      -1,    -1,    -1,    -1,    -1,   494,    -1,  1347,    -1,  1408,
    1409,  1410,  1411,  1412,  1413,  1414,  1415,  1416,  1417,  1418,
    1419,  1420,  1421,  1422,  1423,  1424,  1425,  1408,  1409,  1410,
    1411,  1412,  1413,  1414,  1415,  1416,  1417,  1418,  1419,  1420,
    1421,  1422,  1423,  1424,  1425,  1501,    -1,    -1,    -1,    -1,
     539,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,   165,   166,    -1,    10,    11,    12,  1501,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1476,    -1,   520,
      -1,    -1,    -1,    -1,    -1,    -1,   527,    -1,  1428,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   587,    -1,
      -1,     3,     4,     5,     6,    -1,     8,     9,    10,    11,
      -1,    -1,    -1,   554,    -1,   556,    -1,   558,   155,    64,
      -1,   158,   159,   160,   161,   162,    -1,   164,   165,   166,
    1529,    76,    77,  1532,    17,    18,    19,    20,    21,    22,
      23,   630,    -1,    -1,    -1,    -1,    -1,    -1,    50,    -1,
      33,  1532,    54,    -1,    56,    57,    58,    -1,    -1,   648,
      62,    -1,    64,    65,    66,    67,    -1,    -1,   113,   114,
      -1,   116,    -1,    75,    76,    77,   121,    -1,   123,    81,
      -1,    -1,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   151,   109,    -1,   111,
     155,   113,    -1,    -1,    -1,   160,   118,   706,   120,   121,
     122,    -1,    -1,   125,    -1,    -1,    -1,    -1,   130,    -1,
      -1,   133,    -1,   674,    -1,   137,    -1,    -1,    -1,    -1,
     142,    -1,    -1,    -1,    -1,   147,    -1,    -1,    -1,   738,
      -1,    -1,    -1,   155,    -1,    -1,   158,   159,   160,    -1,
      -1,   163,    -1,   165,   166,    -1,    -1,   169,    -1,    -1,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,   165,   166,    -1,    -1,    -1,   776,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    -1,    70,    -1,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    -1,   872,    -1,    20,    21,    22,    23,    -1,
      -1,   832,   833,   834,    -1,   836,   100,   838,    33,   840,
     841,    -1,   891,   107,   108,   109,    -1,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
      -1,    -1,    -1,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    18,    19,    20,    21,    22,    23,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    -1,    -1,  1008,
      -1,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
     165,   166,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1039,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    -1,    -1,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,  1111,    70,    -1,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,   155,   156,
     157,   158,   159,   160,   161,   162,    -1,   164,   165,   166,
      -1,  1092,    -1,   100,    -1,    -1,    -1,    -1,    -1,    -1,
     107,   108,   109,    -1,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,    -1,    -1,    -1,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,    -1,   169,   170,    -1,     3,     4,     5,     6,    -1,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    16,    17,    18,
      19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    50,    51,    33,    -1,    54,    -1,    56,    57,
      58,    59,    60,    -1,    62,    63,    -1,    -1,    66,    67,
      -1,    -1,    70,    -1,  1283,    -1,    -1,    75,    76,    77,
      -1,    -1,    -1,    81,    -1,    -1,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   109,    -1,   111,    -1,   113,    -1,    -1,    -1,    -1,
     118,    -1,   120,   121,   122,    -1,    -1,   125,   126,    -1,
      -1,    -1,   130,    -1,    -1,   133,   134,   135,   136,   137,
      -1,    -1,   140,    -1,   142,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   155,    -1,    -1,
     158,   159,   160,    -1,    -1,   163,  1327,   165,   166,    -1,
      -1,   169,    -1,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,   165,   166,    -1,    -1,
      -1,   170,    -1,     3,     4,     5,     6,    -1,     8,     9,
      10,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1426,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1392,  1393,  1394,  1395,    -1,  1397,    -1,  1399,    -1,
      50,    51,    -1,    -1,    54,    -1,    56,    57,    58,    59,
      -1,    -1,    62,    63,    -1,    -1,    66,    67,    -1,    -1,
      70,    -1,    -1,    -1,  1473,    75,    76,    77,    -1,    -1,
      -1,    81,    -1,    -1,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   109,
      -1,   111,    -1,   113,    -1,    -1,    -1,    -1,   118,    -1,
     120,   121,   122,    -1,    -1,   125,   126,    -1,    -1,    -1,
     130,    -1,    -1,   133,   134,   135,   136,   137,    -1,    -1,
     140,    -1,   142,    -1,     3,     4,     5,     6,    -1,     8,
       9,    10,    11,    -1,    -1,   155,    15,    -1,   158,   159,
     160,    -1,    -1,   163,    -1,   165,   166,    -1,    -1,   169,
      -1,    -1,    -1,    -1,    -1,    16,    17,    18,    19,    20,
      21,    22,    23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    50,    33,    -1,    -1,    54,    -1,    56,    57,    58,
      -1,    -1,    -1,    62,    -1,    -1,    -1,    66,    67,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    75,    76,    77,    -1,
      -1,    -1,    81,    -1,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     109,    -1,   111,    -1,   113,    -1,    -1,    -1,    -1,   118,
      -1,   120,   121,   122,    -1,    -1,   125,    -1,    -1,    -1,
      -1,   130,    -1,    -1,   133,    -1,    -1,    -1,   137,     3,
       4,     5,     6,   142,     8,     9,    10,    11,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   155,    -1,    -1,   158,
     159,   160,    -1,    -1,   163,    -1,   165,   166,    -1,    -1,
     169,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,   165,   166,    50,    -1,    -1,   170,
      54,    -1,    56,    57,    58,    -1,    -1,    -1,    62,    -1,
      -1,    -1,    66,    67,    -1,    10,    11,    12,    -1,    -1,
      -1,    75,    76,    77,    -1,    -1,    -1,    81,    -1,    -1,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,    -1,   111,    -1,   113,
      -1,    -1,    -1,    -1,   118,    -1,   120,   121,   122,    64,
      -1,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,   133,
      -1,    76,    77,   137,     3,     4,     5,     6,   142,     8,
       9,    10,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   155,    -1,    -1,   158,   159,   160,    -1,    -1,   163,
      -1,   165,   166,   167,    -1,   169,    -1,    -1,   113,   114,
      -1,   116,    -1,    -1,    -1,    -1,   121,    -1,   123,    -1,
      -1,    50,    51,    -1,    -1,    54,    -1,    56,    57,    58,
      -1,    -1,    -1,    62,    -1,    -1,    -1,    66,    67,    -1,
      -1,    -1,    -1,    -1,    -1,   150,    75,    76,    77,    -1,
      -1,    -1,    81,    -1,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     109,    -1,   111,    -1,   113,    -1,    -1,    -1,    -1,   118,
      -1,   120,   121,   122,    -1,    -1,   125,    -1,    -1,    -1,
      -1,   130,    -1,    -1,   133,    -1,    -1,    -1,   137,     3,
       4,     5,     6,   142,     8,     9,    10,    11,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   155,    -1,    -1,   158,
     159,   160,    -1,    -1,   163,    -1,   165,   166,    -1,    -1,
     169,    -1,    -1,    -1,    16,    17,    18,    19,    20,    21,
      22,    23,    -1,    -1,    -1,    -1,    50,    51,    -1,    -1,
      54,    33,    56,    57,    58,    -1,    -1,    -1,    62,    -1,
      -1,    -1,    66,    67,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    75,    76,    77,    -1,    -1,    -1,    81,    -1,    -1,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,    -1,   111,    -1,   113,
      -1,    -1,    -1,    -1,   118,    -1,   120,   121,   122,    -1,
      -1,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,   133,
      -1,    -1,    -1,   137,     3,     4,     5,     6,   142,     8,
       9,    10,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   155,    -1,    -1,   158,   159,   160,    -1,    -1,   163,
      -1,   165,   166,    -1,    -1,   169,    -1,    -1,   150,    -1,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    50,   164,   165,   166,    54,    -1,    56,    57,    58,
      -1,    -1,    -1,    62,    -1,    -1,    -1,    66,    67,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    75,    76,    77,    -1,
      -1,    -1,    81,    -1,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     109,    -1,   111,    -1,   113,    -1,    -1,    -1,    -1,   118,
      -1,   120,   121,   122,    -1,    -1,   125,    -1,    -1,    -1,
      -1,   130,    -1,    -1,   133,    -1,    -1,    -1,   137,     3,
       4,     5,     6,   142,     8,     9,    10,    11,   147,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   155,    -1,    -1,   158,
     159,   160,    -1,    -1,   163,    -1,   165,   166,    -1,    -1,
     169,    -1,    -1,    -1,    16,    17,    18,    19,    20,    21,
      22,    23,    -1,    -1,    -1,    -1,    50,    -1,    -1,    -1,
      54,    33,    56,    57,    58,    -1,    -1,    -1,    62,    -1,
      -1,    -1,    66,    67,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    75,    76,    77,    -1,    -1,    -1,    81,    -1,    -1,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,    -1,   111,    -1,   113,
      -1,    -1,    -1,    -1,   118,    -1,   120,   121,   122,    -1,
      -1,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,   133,
      -1,    -1,    -1,   137,     3,     4,     5,     6,   142,     8,
       9,    10,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   155,    -1,    -1,   158,   159,   160,    -1,    -1,   163,
      -1,   165,   166,   167,    -1,   169,    -1,   149,    -1,    -1,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    50,   164,   165,   166,    54,    -1,    56,    57,    58,
      -1,    -1,    -1,    62,    -1,    -1,    -1,    66,    67,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    75,    76,    77,    -1,
      -1,    -1,    81,    -1,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     109,    -1,   111,    -1,   113,    -1,    -1,    -1,    -1,   118,
      -1,   120,   121,   122,    -1,    -1,   125,    -1,    -1,    -1,
      -1,   130,    -1,    -1,   133,    -1,    -1,    -1,   137,     3,
       4,     5,     6,   142,     8,     9,    10,    11,   147,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   155,    -1,    -1,   158,
     159,   160,    -1,    -1,   163,    -1,   165,   166,    -1,    -1,
     169,    -1,    -1,    -1,    16,    17,    18,    19,    20,    21,
      22,    23,    -1,    -1,    -1,    -1,    50,    -1,    -1,    -1,
      54,    33,    56,    57,    58,    -1,    -1,    -1,    62,    -1,
      -1,    -1,    66,    67,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    75,    76,    77,    -1,    -1,    -1,    81,    -1,    -1,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,    -1,   111,    -1,   113,
      -1,    -1,    -1,    -1,   118,    -1,   120,   121,   122,    -1,
      -1,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,   133,
      -1,    -1,    -1,   137,     3,     4,     5,     6,   142,     8,
       9,    10,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   155,    -1,    -1,   158,   159,   160,    -1,    -1,   163,
      -1,   165,   166,   167,    -1,   169,   148,    -1,    -1,    -1,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    50,   164,   165,   166,    54,    -1,    56,    57,    58,
      -1,    -1,    -1,    62,    -1,    -1,    -1,    66,    67,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    75,    76,    77,    -1,
      -1,    -1,    81,    -1,    -1,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     109,    -1,   111,    -1,   113,    10,    11,    12,    -1,   118,
      -1,   120,   121,   122,    -1,    -1,   125,    -1,    -1,    -1,
      -1,   130,    -1,    -1,   133,    -1,    -1,    -1,   137,     3,
       4,     5,     6,   142,     8,     9,    10,    11,    12,    -1,
      -1,    15,    47,    -1,    49,    -1,   155,    -1,    -1,   158,
     159,   160,    -1,    -1,   163,    -1,   165,   166,    -1,    64,
     169,    16,    17,    18,    19,    20,    21,    22,    23,    -1,
      -1,    76,    77,    47,    -1,    -1,    50,    51,    33,    -1,
      54,    -1,    56,    57,    58,    59,    60,    -1,    62,    63,
      -1,    -1,    66,    67,    -1,    -1,    70,    -1,    -1,    -1,
      -1,    75,    76,    77,    -1,    -1,    -1,    -1,   113,   114,
      84,   116,    -1,    -1,    -1,    -1,   121,    -1,   123,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,    -1,   111,    -1,   113,
      -1,    -1,   147,   117,   118,    -1,   120,   121,   122,    -1,
      -1,   125,   126,    -1,    -1,    -1,   130,    -1,    -1,   133,
     134,   135,   136,   137,    -1,    -1,   140,    -1,   142,     3,
       4,     5,     6,    -1,     8,     9,    10,    11,    -1,    -1,
      -1,   155,    -1,    -1,   158,   159,    -1,    -1,    -1,   163,
      -1,   165,    -1,    -1,    -1,   169,    -1,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    -1,   164,
     165,   166,    -1,    -1,    -1,   170,    50,    -1,    -1,    -1,
      54,    -1,    56,    57,    58,    -1,    -1,    -1,    62,    -1,
      -1,    -1,    66,    67,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    75,    76,    77,    -1,    -1,    -1,    81,    -1,    -1,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   109,    -1,   111,    -1,   113,
      10,    11,    12,    -1,   118,    -1,   120,   121,   122,    -1,
      -1,   125,    -1,    -1,    -1,    -1,   130,    -1,    -1,   133,
      -1,    -1,    -1,   137,     3,     4,     5,     6,   142,     8,
       9,    10,    11,    12,    -1,    -1,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   163,
      -1,   165,   166,    -1,    64,   169,    16,    17,    18,    19,
      20,    21,    22,    23,    -1,    -1,    76,    77,    47,    -1,
      -1,    50,    51,    33,    -1,    54,    -1,    56,    57,    58,
      59,    60,    -1,    62,    63,    -1,    -1,    66,    67,    -1,
      -1,    70,    -1,    -1,    -1,    -1,    75,    76,    77,    -1,
      -1,    -1,    -1,   113,   114,    84,   116,    -1,    -1,    -1,
      -1,   121,    -1,   123,    -1,    10,    11,    12,    -1,    -1,
      -1,   100,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     109,    -1,   111,    -1,   113,    -1,    -1,   147,   117,   118,
      -1,   120,   121,   122,    -1,    -1,   125,   126,    -1,    -1,
      -1,   130,    -1,    -1,   133,   134,   135,   136,   137,    -1,
      -1,   140,    -1,   142,    -1,     3,     4,     5,     6,    64,
       8,     9,    10,    -1,    -1,    -1,   155,    15,    -1,   158,
     159,    76,    77,    -1,   163,    -1,   165,    -1,   148,    -1,
     169,    -1,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,    -1,   164,   165,   166,   167,    -1,    -1,
      -1,    -1,    50,    -1,    -1,    -1,    -1,    -1,   113,   114,
     115,   116,    -1,    -1,    62,    -1,   121,    -1,   123,    67,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    75,    76,   134,
      -1,    -1,    -1,    81,   139,    -1,    -1,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,    -1,    -1,    -1,     3,     4,     5,     6,    -1,
       8,     9,    10,   111,    -1,   113,    -1,    -1,    -1,    -1,
     118,    -1,    -1,    -1,   122,    -1,    -1,   125,    -1,    -1,
      -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    50,    -1,    -1,    -1,    -1,   155,    -1,    -1,
     158,   159,   160,    -1,    62,   163,    -1,   165,   166,    67,
      -1,   169,    -1,    -1,    -1,    -1,    -1,    75,    76,    -1,
      -1,    -1,    -1,    81,    -1,    -1,    -1,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,    -1,    -1,    -1,     3,     4,     5,     6,    -1,
       8,     9,    10,   111,    -1,   113,    -1,    -1,    -1,    -1,
     118,    -1,    -1,    -1,   122,    -1,    -1,   125,    -1,    -1,
      -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    16,    17,    18,    19,    20,    21,    22,    23,    -1,
      -1,    -1,    50,    -1,    -1,    -1,    -1,   155,    33,    -1,
     158,   159,   160,    -1,    62,   163,    -1,   165,   166,    67,
      -1,   169,    -1,    -1,    -1,    -1,    -1,    75,    76,    -1,
      -1,    -1,    -1,    81,    -1,    -1,    -1,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,     3,     4,     5,     6,    -1,     8,     9,    10,
      -1,    -1,    -1,   111,    15,   113,    -1,    -1,    -1,    -1,
     118,    -1,    -1,    -1,   122,    -1,    -1,   125,    -1,    17,
      -1,    -1,   130,    -1,    -1,    -1,    -1,    -1,    -1,    10,
      11,    12,    -1,    -1,    -1,    33,    -1,    -1,    -1,    50,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    47,
      -1,    62,    -1,    -1,    -1,   163,    67,   165,   166,    -1,
      -1,   169,    60,    61,    75,    76,    -1,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,    76,   164,
     165,   166,   167,    64,    -1,    -1,    -1,    16,    17,    18,
      19,    20,    21,    22,    23,    76,    77,    -1,   109,    -1,
     111,    -1,   113,    -1,    33,    -1,    -1,   118,    -1,   107,
      -1,   122,   110,    -1,   125,   113,    -1,    -1,    -1,   130,
      -1,    -1,   133,    -1,    -1,    -1,    54,    -1,    56,    57,
      58,   129,   113,   114,    -1,   116,    -1,    -1,    66,    -1,
     121,    -1,   123,   141,   155,    -1,    -1,   158,   159,     6,
      -1,    -1,   163,   134,   165,    -1,    84,   155,   169,    16,
      17,    18,    19,    20,    21,    22,    23,    -1,    -1,    -1,
      -1,    -1,   100,    -1,    -1,    -1,    33,    -1,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      -1,    -1,   120,   121,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    65,   137,
      -1,    -1,    -1,    -1,   142,    -1,    -1,    -1,    -1,    -1,
      -1,    10,    11,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,   165,   166,   167,    -1,
      16,    17,    18,    19,    20,    21,    22,    23,    -1,    -1,
      -1,    -1,   109,    -1,    -1,    -1,    -1,    33,    -1,    -1,
      -1,    -1,    51,    -1,    -1,    54,    -1,    56,    57,    58,
      59,    -1,    -1,    -1,    63,    -1,    -1,    66,    -1,    -1,
      -1,    70,    10,    11,    12,    -1,    -1,    -1,    77,    -1,
      -1,   148,    -1,    -1,   151,    84,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,    -1,   165,   166,
      -1,   100,   169,    10,    11,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   112,    -1,    -1,    54,    -1,    56,    57,
      58,   120,   121,    -1,    -1,    -1,    -1,   126,    66,    -1,
      -1,    -1,    -1,    -1,    -1,   134,   135,   136,   137,    77,
      -1,   140,    -1,   142,    51,    -1,    84,    54,   147,    56,
      57,    58,    59,    -1,    -1,    -1,    63,    -1,    -1,    66,
      -1,    -1,   100,    70,   163,    17,   152,   153,   154,   155,
      77,    -1,   158,   159,   160,   161,   162,    84,   164,   165,
     166,    -1,   120,   121,    -1,    -1,    -1,    -1,    -1,    -1,
      10,    11,    -1,   100,    -1,    47,    -1,    -1,    -1,   137,
      -1,    -1,   140,    -1,   142,   112,    -1,    -1,    60,    61,
      -1,    -1,    -1,   120,   121,    -1,    -1,    -1,    -1,   126,
      -1,    -1,    -1,    -1,    76,    -1,    -1,   134,   135,   136,
     137,    51,    -1,   140,    54,   142,    56,    57,    58,    59,
      -1,    -1,    -1,    63,    -1,    -1,    66,    -1,    -1,    -1,
      70,    -1,    -1,    -1,    -1,   107,   163,    77,   110,    -1,
      -1,   113,    -1,    -1,    84,    16,    17,    18,    19,    20,
      21,    22,    23,    -1,    -1,    -1,    -1,   129,    -1,    -1,
     100,    -1,    33,    -1,    -1,    -1,    -1,    -1,    -1,   141,
      -1,    -1,   112,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     120,   121,    -1,   155,    -1,    -1,   126,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   134,   135,   136,   137,    -1,    -1,
     140,    -1,   142,    16,    17,    18,    19,    20,    21,    22,
      23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    -1,    -1,   163,    16,    17,    18,    19,    20,    21,
      22,    23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    16,    17,    18,    19,    20,    21,    22,    23,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      16,    17,    18,    19,    20,    21,    22,    23,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    -1,    -1,
      -1,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,   165,   166,   167,    16,    17,    18,
      19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    16,    17,    18,    19,    20,
      21,    22,    23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    -1,    -1,    -1,    -1,    -1,    -1,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,   164,   165,   166,   167,    -1,    -1,    -1,    -1,    -1,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,    -1,   164,   165,   166,   167,    -1,    -1,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,   165,   166,   167,    -1,    -1,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,    -1,   164,   165,
     166,   167,    16,    17,    18,    19,    20,    21,    22,    23,
      -1,    -1,    -1,    -1,    -1,    -1,    10,    11,    12,    33,
      -1,   150,    -1,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,   165,   166,    -1,    -1,
      -1,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,     0,   164,   165,   166,    -1,    -1,    -1,    -1,
      -1,    17,    18,    19,    20,    21,    22,    23,    -1,    -1,
      64,    -1,    -1,    -1,    -1,    -1,    -1,    33,    -1,    -1,
      -1,    -1,    76,    77,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    47,
      -1,    49,    -1,    -1,    52,    53,    -1,    -1,    -1,    -1,
      -1,    -1,    60,    61,   108,    -1,    -1,    -1,    -1,   113,
     114,    69,   116,    71,    72,    73,    74,   121,    -1,   123,
      78,    -1,    -1,    -1,    -1,    83,    -1,    -1,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,    -1,
     164,   165,   166,   101,   102,   103,   104,   105,   106,   107,
     108,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,   117,
      -1,    -1,    -1,    -1,    -1,   123,   124,    11,    12,   127,
     128,    15,    -1,    17,   132,    -1,    -1,    -1,    -1,    -1,
     138,   139,    -1,   141,    -1,    -1,    -1,   153,   154,   155,
      -1,   149,   158,   159,   160,   161,   162,    -1,   164,   165,
     166,    -1,    -1,    47,    -1,    -1,    -1,    51,    -1,    -1,
      54,    -1,    56,    57,    58,    59,    60,    -1,    -1,    63,
      -1,    -1,    66,    -1,    -1,    -1,    70,    18,    19,    20,
      21,    22,    23,    77,    -1,    54,    -1,    56,    57,    58,
      84,    -1,    33,    18,    19,    20,    21,    22,    23,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,    -1,    33,    18,
      19,    20,    21,    22,    23,    84,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   117,    33,    -1,   120,   121,    -1,    -1,
      -1,   100,   126,    -1,    18,    19,    20,    21,    22,    23,
     134,   135,   136,   137,    -1,    -1,   140,    -1,   142,    33,
      -1,   120,   121,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   155,    -1,    -1,    -1,    -1,   160,    -1,   137,    -1,
      -1,    -1,    -1,   142,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    10,    11,    12,    -1,   165,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,    -1,   164,   165,   166,    -1,    -1,   153,   154,
     155,    -1,    -1,   158,   159,   160,   161,   162,    -1,   164,
     165,   166,    -1,    -1,    -1,     6,    64,   156,   157,   158,
     159,   160,   161,   162,    -1,   164,   165,   166,    76,    77,
      -1,    -1,    -1,    -1,    -1,    -1,    10,    11,    12,    -1,
     154,   155,     6,    -1,   158,   159,   160,   161,   162,    -1,
     164,   165,   166,    -1,    -1,    -1,    47,    -1,    49,    -1,
      -1,    -1,    53,    -1,    -1,   113,   114,    -1,   116,    60,
      61,    -1,    -1,   121,    -1,   123,    -1,    -1,    -1,    -1,
      71,    72,    73,    47,    -1,    49,    -1,    -1,    -1,    53,
      64,    -1,    83,    -1,    -1,    -1,    60,    61,    -1,   147,
      -1,    -1,    76,    77,    -1,    -1,    -1,    71,    72,    73,
      -1,    -1,    -1,    10,    11,    12,   107,    -1,    -1,    83,
      -1,    -1,    10,    11,    12,    -1,   117,    -1,    -1,    -1,
      -1,    -1,   123,    -1,    -1,    -1,   127,   128,    -1,   113,
     114,    -1,   116,   107,    -1,    -1,    -1,   121,   139,   123,
     141,    -1,    -1,   117,    11,    12,    -1,    -1,    15,   123,
     134,    -1,    -1,    -1,   128,   139,    54,    64,    56,    57,
      58,    59,    60,    -1,    -1,   139,    -1,   141,    66,    76,
      77,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    77,
      47,    -1,    -1,    -1,    51,    -1,    84,    54,    -1,    56,
      57,    58,    59,    60,    -1,    -1,    63,    -1,    -1,    66,
      -1,    -1,   100,    70,    -1,    -1,   113,   114,    -1,   116,
      77,    -1,    -1,    -1,   121,    -1,   123,    84,    -1,    -1,
      -1,    -1,   120,   121,    -1,    -1,    -1,   134,    -1,    -1,
      -1,    -1,   139,   100,    -1,    -1,   134,    -1,    -1,   137,
      -1,    -1,   140,    -1,   142,    11,    12,    -1,    -1,    15,
     117,    -1,    -1,   120,   121,    -1,    -1,    -1,    -1,   126,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   134,   135,   136,
     137,    -1,    -1,   140,    -1,   142,    11,    12,    -1,    -1,
      -1,    47,    -1,    -1,    -1,    51,    -1,    -1,    54,    -1,
      56,    57,    58,    59,    60,    -1,    -1,    63,    -1,    -1,
      66,    -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    77,    47,    10,    11,    12,    51,    -1,    84,    54,
      -1,    56,    57,    58,    59,    60,    -1,    -1,    63,    -1,
      -1,    66,    -1,    -1,   100,    70,    -1,    -1,    -1,    -1,
      -1,    -1,    77,    -1,    -1,    -1,    -1,    -1,    -1,    84,
      -1,   117,    -1,    -1,   120,   121,    -1,    -1,    -1,    -1,
     126,    -1,    -1,    11,    12,   100,    -1,    64,   134,   135,
     136,   137,    -1,    -1,   140,    -1,   142,    -1,    -1,    76,
      77,    -1,   117,    -1,    -1,   120,   121,    11,    12,    -1,
      -1,   126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   134,
     135,   136,   137,    51,    -1,   140,    54,   142,    56,    57,
      58,    59,    60,    -1,    -1,    63,   113,   114,    66,   116,
      -1,    -1,    70,    -1,   121,    -1,   123,    51,    -1,    77,
      54,    -1,    56,    57,    58,    59,    84,    -1,    -1,    63,
      -1,   138,    66,    -1,    -1,    -1,    70,    -1,    -1,    -1,
      -1,    -1,   100,    77,    -1,    -1,    -1,    -1,    -1,    -1,
      84,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   120,   121,    11,    12,   100,    -1,   126,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   134,   135,   136,   137,
      -1,    -1,   140,   117,   142,    -1,   120,   121,    47,    -1,
      49,    -1,   126,    11,    -1,    -1,    -1,    -1,    -1,    -1,
     134,   135,   136,   137,    51,    64,   140,    54,   142,    56,
      57,    58,    59,    -1,    -1,    -1,    63,    76,    77,    66,
      -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,    -1,
      77,    -1,    -1,    51,    -1,    -1,    54,    84,    56,    57,
      58,    59,    60,    -1,    -1,    63,    -1,    -1,    66,    -1,
      -1,    -1,    70,   100,   113,   114,    -1,   116,    -1,    77,
      -1,    -1,   121,    -1,   123,    -1,    84,    -1,    -1,    -1,
      -1,    -1,    -1,   120,   121,    -1,    -1,    -1,    -1,   126,
      11,    -1,   100,    -1,    -1,    -1,    -1,   134,   135,   136,
     137,    -1,    -1,   140,    -1,   142,    -1,    -1,    -1,    -1,
      -1,    -1,   120,   121,    11,    -1,    -1,    -1,   126,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   134,   135,   136,   137,
      51,    -1,   140,    54,   142,    56,    57,    58,    59,    60,
      -1,    -1,    63,    -1,    -1,    66,    -1,    -1,    -1,    70,
      -1,    -1,    -1,    -1,    51,    -1,    77,    54,    -1,    56,
      57,    58,    59,    84,    -1,    -1,    63,    -1,    -1,    66,
      -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,   100,
      77,    -1,    -1,    -1,    -1,    -1,    -1,    84,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,
     121,    11,    -1,   100,    -1,   126,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   134,   135,   136,   137,    -1,    -1,   140,
      -1,   142,    -1,   120,   121,    -1,    -1,    -1,    -1,   126,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   134,   135,   136,
     137,    51,    64,   140,    54,   142,    56,    57,    58,    59,
      -1,    -1,    -1,    63,    76,    77,    66,    -1,    -1,    -1,
      70,    -1,    -1,    -1,    -1,    -1,    -1,    77,    -1,    -1,
      -1,    -1,    -1,    -1,    84,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    47,    -1,    49,    -1,    -1,    52,    53,    -1,
     100,   113,   114,    -1,   116,    60,    61,    -1,    -1,   121,
      -1,   123,    -1,    -1,    69,    -1,    71,    72,    73,    74,
     120,   121,   134,    78,    -1,    -1,   126,   139,    83,    -1,
      -1,    -1,    -1,    -1,   134,   135,   136,   137,    -1,    -1,
     140,    -1,   142,    -1,    -1,    -1,   101,   102,   103,   104,
     105,   106,   107,   108,    -1,    -1,    -1,    -1,    -1,   114,
     115,   116,   117,    -1,    -1,    47,    -1,    49,   123,   124,
      52,    53,   127,   128,    -1,    -1,    -1,   132,    60,    61,
      -1,    -1,    -1,   138,   139,    -1,   141,    69,    -1,    71,
      72,    73,    74,    -1,   149,    -1,    78,    -1,    -1,    -1,
      -1,    83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   168,    -1,    -1,    -1,    -1,    -1,   101,
     102,   103,   104,   105,   106,   107,   108,    -1,    -1,    -1,
      -1,    -1,   114,   115,   116,   117,    -1,    -1,    47,    -1,
      49,   123,   124,    52,    53,   127,   128,    -1,    -1,    -1,
     132,    60,    61,    -1,    -1,    -1,   138,   139,    -1,   141,
      69,    -1,    71,    72,    73,    74,    -1,   149,    -1,    78,
      -1,    -1,    -1,    -1,    83,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,
      -1,    -1,   101,   102,   103,   104,   105,   106,   107,   108,
      -1,    -1,    -1,    -1,    -1,   114,   115,   116,   117,    -1,
      -1,    47,    -1,    49,   123,   124,    52,    53,   127,   128,
      -1,    -1,    -1,   132,    60,    61,    -1,    -1,    -1,   138,
     139,    -1,   141,    69,    -1,    71,    72,    73,    74,    -1,
     149,    -1,    78,    -1,    -1,    -1,    -1,    83,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   168,
      -1,    -1,    -1,    -1,    -1,   101,   102,   103,   104,   105,
     106,   107,   108,    -1,    -1,    -1,    -1,    -1,   114,   115,
     116,   117,    -1,    -1,    47,    -1,    49,   123,   124,    52,
      53,   127,   128,    -1,    -1,    -1,   132,    60,    61,    -1,
      -1,    -1,   138,   139,    -1,   141,    69,    -1,    71,    72,
      73,    74,    -1,   149,    -1,    78,    -1,    -1,    -1,    -1,
      83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   168,    -1,    -1,    -1,    -1,    -1,   101,   102,
     103,   104,   105,   106,   107,   108,    -1,    -1,    -1,    -1,
      -1,   114,   115,   116,   117,    -1,    -1,    47,    -1,    49,
     123,   124,    52,    53,   127,   128,    -1,    -1,    -1,   132,
      60,    61,    -1,    -1,    -1,   138,   139,    -1,   141,    69,
      -1,    71,    72,    73,    74,    -1,   149,    -1,    78,    -1,
      -1,    -1,    -1,    83,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,    -1,
      -1,   101,   102,   103,   104,   105,   106,   107,   108,    -1,
      -1,    -1,    -1,    -1,   114,   115,   116,   117,    -1,    -1,
      47,    -1,    49,   123,   124,    52,    53,   127,   128,    -1,
      -1,    -1,   132,    60,    61,    -1,    -1,    -1,   138,   139,
      -1,   141,    69,    -1,    71,    72,    73,    74,    -1,   149,
      -1,    78,    10,    11,    12,    -1,    83,    15,    -1,    -1,
      -1,    -1,    -1,    10,    11,    12,    -1,    -1,   168,    54,
      -1,    56,    57,    58,   101,   102,   103,   104,   105,   106,
     107,   108,    -1,    -1,    -1,    -1,    -1,   114,   115,   116,
     117,    -1,    -1,    -1,    -1,    -1,   123,   124,    -1,    84,
     127,   128,    -1,    -1,    -1,   132,    64,    -1,    -1,    -1,
      -1,   138,   139,    -1,   141,   100,    -1,    64,    76,    77,
      -1,    -1,   149,    -1,    54,    -1,    56,    57,    58,    76,
      77,    -1,    -1,    -1,    -1,   120,   121,    -1,    -1,    -1,
      -1,   168,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   137,    -1,    84,   113,   114,   142,   116,    -1,
      -1,    -1,    -1,   121,    -1,   123,   113,   114,    -1,   116,
     100,    -1,    -1,    47,   121,    49,   123,    -1,    -1,    53,
     165,    -1,    -1,    -1,    -1,    -1,    60,    61,    -1,    -1,
     120,   121,    -1,    -1,    -1,    -1,    -1,    71,    72,    73,
      -1,    -1,    -1,    -1,    78,    -1,    -1,   137,    -1,    83,
      -1,    -1,   142,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   107,    -1,   165,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   117,    -1,    -1,    -1,    -1,    -1,   123,
      -1,    -1,    -1,    -1,   128,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   138,   139,    47,   141,    49,    -1,
      -1,    52,    53,    -1,    -1,    -1,    -1,    -1,    -1,    60,
      61,    -1,   156,    -1,    -1,    -1,    -1,    -1,    69,    -1,
      71,    72,    73,    74,    -1,    -1,    -1,    78,    -1,    -1,
      -1,    -1,    83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     101,   102,   103,   104,   105,   106,   107,   108,    -1,    -1,
      -1,    -1,    -1,   114,   115,   116,   117,    -1,    -1,    47,
      -1,    49,   123,   124,    -1,    53,   127,   128,    -1,    -1,
      -1,   132,    60,    61,    -1,    -1,    -1,   138,   139,    -1,
     141,    -1,    -1,    71,    72,    73,    47,    -1,    49,    -1,
      78,    -1,    53,    -1,    -1,    83,    -1,    -1,    -1,    60,
      61,    47,    -1,    49,    -1,    -1,    -1,    53,    -1,    -1,
      71,    72,    73,    -1,    60,    61,    -1,    -1,    -1,   107,
      -1,    -1,    83,    -1,    -1,    71,    72,    73,    -1,   117,
      -1,    -1,    -1,    -1,    -1,   123,    -1,    83,    -1,   127,
     128,    -1,    -1,    -1,    -1,    -1,   107,   108,    -1,    -1,
     138,   139,    -1,   141,    -1,    -1,   117,    -1,    -1,    -1,
      -1,   107,   123,    -1,    -1,    -1,    -1,   128,    -1,    -1,
      -1,   117,    -1,    -1,    -1,    -1,    -1,   123,   139,    -1,
     141,    -1,   128,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   139,    -1,   141
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   144,   145,   146,   172,   173,   281,     3,     4,     5,
       6,     8,     9,    10,    11,    50,    54,    56,    57,    58,
      62,    66,    67,    75,    76,    77,    81,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   109,   111,   113,   118,   120,   121,
     122,   125,   130,   133,   137,   142,   155,   158,   159,   160,
     163,   165,   166,   169,   271,   272,   280,    11,    12,    51,
      54,    56,    57,    58,    59,    60,    63,    66,    70,    77,
      84,   100,   120,   121,   126,   134,   135,   136,   137,   140,
     142,   233,   234,   238,   240,   242,   248,   249,   253,   254,
     259,   260,   261,   262,     0,    47,    49,    52,    53,    60,
      61,    69,    71,    72,    73,    74,    78,    83,   101,   102,
     103,   104,   105,   106,   107,   108,   114,   115,   116,   117,
     123,   124,   127,   128,   132,   138,   139,   141,   149,   176,
     178,   179,   181,   184,   204,   255,   258,   281,   147,   165,
     165,   165,   165,   165,   165,   156,   165,   156,   165,   165,
     165,   165,   165,   165,   165,   165,   165,   165,   165,   165,
     165,   165,   165,   165,   165,   165,   165,    11,    51,    63,
     134,   135,   236,   253,   254,   259,   156,   165,   165,    15,
     165,   271,   156,   165,   165,   165,   271,   271,   271,   271,
     271,    11,    54,    56,    57,    58,    66,    77,    84,   100,
     120,   121,   137,   142,   238,   269,   271,    10,    11,    12,
      64,    76,    77,   113,   114,   116,   121,   123,   151,   155,
     160,   275,   276,   278,   281,   271,    16,    17,    18,    19,
      20,    21,    22,    23,    33,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   164,   165,   166,     6,
       8,   233,   234,   165,    59,   126,    66,   100,   260,   260,
     260,   278,   165,   260,    13,    15,    17,    60,   141,   155,
     160,   165,   231,   232,   281,   232,   147,    10,    11,    12,
     113,   150,   279,   239,   281,   138,   182,   183,   278,   165,
      72,    83,   181,   181,   181,   181,     6,   181,   204,   181,
     150,   180,   108,   181,   165,   165,   165,   165,   165,   165,
     181,   147,   278,   150,   150,   150,   181,   181,   165,   179,
     181,   184,   205,   181,   181,   188,   108,   278,   181,   181,
      10,    11,    51,    63,   112,   134,   135,   147,   163,   191,
     195,   235,   237,   240,   242,   248,   253,   254,   259,   268,
     269,   281,   268,   238,   268,   268,   268,   268,   238,   268,
     238,   268,   238,   268,   238,   238,   238,   238,   238,   238,
     238,   238,   238,   238,   238,   238,   238,   238,   238,   268,
     165,   278,   165,   165,   278,   239,   238,   268,   268,   165,
     238,   238,   238,   271,   268,   268,   167,   148,   167,   278,
     278,   148,   170,   151,   221,   281,   271,   271,   271,   271,
     271,   271,   271,   271,   271,   271,   271,   271,   271,   271,
     271,   271,   271,   271,   271,   271,   278,   167,   269,   271,
     232,   232,    51,   271,   238,   160,   278,    13,    15,    17,
      60,   141,   155,   160,   231,   281,   231,   232,   231,   232,
     231,   231,    15,    17,    47,    60,   117,   155,   160,   216,
     217,   226,   233,   234,   281,   166,   251,   252,   281,    11,
     250,   260,   150,    10,    11,    12,    47,    49,   113,   147,
     278,   279,   278,    48,   148,   165,    11,   235,   271,   181,
     178,   147,   278,   278,   278,   278,   278,   278,   278,   173,
     147,   271,   156,    10,    11,   195,   235,   237,   278,   149,
     151,   165,   165,   165,    60,   233,   278,   165,   177,   278,
     186,   147,   149,   151,   223,   149,   185,   278,   279,   239,
     168,   167,   167,   167,   167,   167,   167,   157,   167,   157,
     167,   167,   167,   167,   148,   167,   148,   167,   148,   167,
     167,   167,   167,   167,   167,   167,   167,   167,   167,   167,
     271,   238,   268,   278,   157,   167,   167,   278,   167,   157,
     167,   167,   167,   167,   271,   271,    15,   155,   276,   165,
     201,   281,   271,   150,   167,   170,   167,   167,   167,   231,
     160,   278,   231,   231,   231,   231,   231,   166,   231,   182,
     117,   233,   234,   226,   231,   231,   167,    15,   148,    13,
      17,    60,   141,   155,   160,   165,   229,   279,   281,    13,
      15,    17,    60,   141,   155,   160,   165,   230,   267,   271,
     281,   278,   168,   250,   182,   165,   241,   243,   150,   181,
     182,     3,     4,     5,     9,    10,    15,    50,    62,    67,
      75,    76,   109,   111,   113,   118,   122,   125,   130,   133,
     155,   158,   159,   163,   165,   169,   218,   219,   226,   227,
     273,   274,   280,   281,   167,   167,   173,   147,   148,   148,
     148,   148,   148,   148,   168,   256,   148,   167,    10,    11,
      12,    59,    60,   134,   206,   207,   208,   209,   210,   259,
     281,   165,   223,   189,   149,   238,   192,    10,    13,   160,
     194,    51,   271,   233,    13,    17,    60,   141,   155,   160,
     228,   279,   281,   238,   173,   165,   147,   149,   150,   151,
     222,   263,   264,    64,    65,   147,   271,    13,    17,    60,
     112,   141,   155,   160,   165,   187,   211,   213,   279,   150,
     278,   165,   165,   238,   238,   238,   167,   167,   167,   165,
     167,   165,   221,   216,    17,    33,    47,    60,    61,    76,
     107,   110,   113,   129,   141,   155,   214,   281,   271,   231,
     267,   167,    48,   233,   234,   229,   230,   167,   167,   201,
      15,   226,   160,   229,   229,   229,   229,   229,   229,   166,
     221,   160,   278,   230,   230,   230,   230,   230,   230,   166,
     221,   170,   148,   151,    48,   235,   271,   173,    76,   244,
     281,   183,   165,   156,   156,   236,   156,    15,   165,   273,
     156,   165,   271,   271,   271,   271,   238,   269,   271,   167,
      15,   148,    16,    17,    18,    19,    20,    21,    22,    23,
      33,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   164,   165,   166,   181,   181,   168,   257,    10,
      10,    10,    10,    10,    10,   173,   280,   149,   210,   157,
     148,    15,   278,    13,    17,    60,   141,   155,   160,   165,
     229,   230,   190,   213,   149,   216,   167,   160,   211,   216,
     167,   167,   228,   160,   228,   228,   228,   228,   228,   165,
     166,   167,   168,   196,   263,   174,   175,   278,    64,    65,
     168,   265,   281,   149,   149,   147,   224,   225,   271,   281,
     149,   160,   211,   211,     6,    16,    17,    18,    19,    20,
      21,    22,    23,    33,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    65,   109,   148,   151,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   165,   166,   169,   202,   211,   211,   211,   211,   150,
     165,   166,   214,   151,   221,   223,   250,   269,   269,   167,
     167,   167,   269,   269,   167,    60,   236,   182,   165,   147,
     170,   165,   226,   229,   230,   221,   221,   165,   165,   214,
     229,   167,   267,   230,   167,   267,   271,   167,   167,   168,
     150,   245,   246,   281,   238,   238,   238,   165,   238,   165,
     238,   238,   238,   271,   167,   167,    15,   227,   271,   271,
     271,   271,   271,   271,   271,   271,   271,   271,   271,   271,
     271,   271,   271,   271,   271,   271,   271,   271,   278,   167,
     269,   271,   173,   148,   148,   167,   148,   215,   281,   148,
     148,   148,   168,   167,   229,   230,   179,   184,   203,   204,
     209,   278,   151,   160,   151,   220,   281,   221,   223,   167,
     165,   211,   167,   167,   165,   228,   199,   267,   216,   168,
     147,   148,   147,   165,   149,   149,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    70,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    82,    83,    84,   100,   107,   108,   109,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   169,   170,   266,   224,   168,   148,   211,
      10,   167,   170,   167,   271,   212,   267,   271,   148,   167,
     167,   167,   167,   201,   236,   232,    48,   167,   278,   263,
     216,   221,   221,   216,   216,   165,   170,   165,   170,   148,
     114,   115,   116,   134,   139,   247,   277,   278,   147,   148,
     167,   157,   157,   268,   157,   278,   167,   157,   167,   167,
     271,   150,   167,   170,   168,    10,    10,   149,    10,   167,
      10,    10,    10,   149,   220,   238,    50,    62,    67,   118,
     122,   125,   155,   158,   159,   160,   163,   165,   169,   270,
     272,   148,   201,   193,   167,   165,   201,   200,   216,   170,
     167,   263,   175,   268,   268,   265,   168,   147,   271,   218,
     170,   187,   214,   232,    15,   167,   168,   167,   167,   167,
     216,   216,   139,   277,   139,   277,   139,   277,   278,   114,
     115,   116,    15,   173,   247,   165,   165,   167,   165,   167,
     165,   271,   167,   148,   167,   148,   149,   148,   167,   167,
     148,   167,   165,   156,   156,   156,    15,   165,   270,   156,
     270,   270,   270,   270,   270,   238,   269,   270,    16,    17,
      18,    19,    20,    21,    22,    23,    33,   152,   153,   154,
     155,   158,   159,   160,   161,   162,   164,   165,   166,   190,
     216,   165,   197,   216,   167,   201,   168,   168,   167,   168,
     224,   167,   147,   167,   201,   201,   201,   167,   167,   277,
     277,   277,   277,   277,   277,   168,   269,   269,   269,   269,
     149,    10,   149,    10,    10,   149,   149,    10,   149,   238,
     238,   238,   238,   165,   238,   238,   167,   167,   270,   270,
     270,   270,   270,   270,   270,   270,   270,   270,   270,   270,
     270,   270,   270,   270,   270,   270,   278,   167,   269,   271,
     167,   198,   216,   167,   201,    15,   168,   201,   263,   214,
     214,   214,   201,   201,   167,   167,   167,   167,   148,   215,
     167,   148,   148,   167,   167,   157,   157,   157,   278,   167,
     157,   270,   150,   167,   170,   201,   216,   167,   201,   168,
      10,   167,   149,    10,    10,   149,   165,   165,   165,   167,
     165,   270,   167,   201,   149,   167,   148,   167,   269,   269,
     269,   269,   201,   214,   149,    10,   149,   167,   167,   167,
     167,   214,   167,   149
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   171,   172,   172,   172,   173,   173,   173,   174,   174,
     175,   175,   175,   177,   176,   178,   178,   178,   178,   178,
     178,   178,   178,   178,   178,   178,   178,   178,   178,   178,
     178,   178,   178,   178,   178,   178,   178,   178,   178,   178,
     178,   178,   180,   179,   181,   181,   181,   181,   181,   181,
     181,   181,   181,   181,   181,   181,   181,   181,   181,   181,
     181,   181,   182,   182,   183,   183,   183,   185,   184,   184,
     186,   184,   184,   184,   187,   187,   189,   188,   188,   190,
     190,   192,   191,   193,   191,   194,   191,   196,   195,   197,
     195,   198,   195,   199,   195,   200,   195,   195,   201,   201,
     201,   201,   201,   201,   201,   201,   201,   201,   201,   201,
     201,   201,   202,   202,   202,   202,   202,   202,   202,   202,
     202,   202,   202,   202,   202,   202,   202,   202,   202,   202,
     202,   202,   202,   202,   202,   202,   202,   202,   202,   202,
     202,   202,   202,   202,   202,   202,   202,   202,   202,   202,
     202,   203,   203,   203,   204,   205,   204,   204,   204,   206,
     206,   207,   207,   208,   208,   209,   209,   209,   209,   209,
     209,   209,   209,   209,   210,   210,   210,   210,   211,   211,
     211,   211,   211,   211,   211,   211,   211,   211,   211,   212,
     211,   213,   213,   214,   214,   214,   215,   215,   216,   216,
     216,   216,   216,   217,   217,   218,   218,   218,   218,   218,
     219,   219,   220,   220,   221,   221,   222,   222,   222,   222,
     222,   223,   223,   223,   223,   223,   223,   224,   224,   224,
     225,   225,   225,   225,   226,   226,   226,   226,   226,   226,
     226,   226,   227,   227,   228,   228,   228,   228,   228,   228,
     228,   228,   228,   229,   229,   229,   229,   229,   229,   229,
     229,   229,   229,   229,   230,   230,   230,   230,   230,   230,
     230,   230,   230,   230,   230,   231,   231,   231,   231,   231,
     231,   231,   231,   231,   231,   232,   232,   232,   232,   232,
     232,   232,   232,   232,   232,   232,   232,   232,   232,   233,
     233,   233,   233,   233,   233,   233,   233,   233,   233,   233,
     233,   234,   235,   235,   235,   235,   235,   235,   235,   235,
     235,   235,   235,   235,   235,   236,   236,   236,   236,   236,
     236,   236,   236,   237,   237,   238,   238,   238,   238,   239,
     239,   239,   239,   241,   240,   243,   242,   244,   244,   245,
     245,   246,   246,   247,   247,   247,   247,   247,   247,   247,
     247,   247,   247,   248,   249,   249,   249,   249,   250,   250,
     251,   251,   251,   252,   252,   252,   253,   253,   253,   254,
     254,   254,   256,   255,   257,   255,   255,   255,   258,   258,
     258,   259,   259,   259,   260,   260,   260,   260,   260,   260,
     260,   260,   260,   260,   260,   260,   260,   260,   261,   261,
     261,   262,   264,   263,   265,   265,   266,   266,   266,   266,
     266,   266,   266,   266,   266,   266,   266,   266,   266,   266,
     266,   266,   266,   266,   266,   266,   266,   266,   266,   266,
     266,   266,   266,   266,   266,   266,   266,   266,   266,   266,
     266,   266,   266,   266,   266,   266,   266,   266,   266,   266,
     266,   266,   266,   266,   266,   266,   266,   266,   266,   266,
     266,   266,   266,   266,   266,   266,   266,   266,   266,   266,
     266,   266,   266,   266,   266,   266,   266,   266,   266,   266,
     266,   266,   266,   266,   266,   266,   266,   266,   266,   266,
     266,   266,   266,   266,   266,   266,   266,   266,   266,   266,
     266,   266,   266,   266,   266,   266,   266,   266,   266,   266,
     266,   266,   266,   266,   266,   266,   266,   266,   266,   266,
     266,   266,   266,   266,   266,   266,   266,   266,   266,   266,
     266,   266,   266,   266,   266,   267,   267,   268,   268,   269,
     269,   270,   270,   270,   270,   270,   270,   270,   270,   270,
     270,   270,   270,   270,   270,   270,   270,   270,   270,   270,
     270,   270,   270,   270,   270,   270,   270,   270,   270,   270,
     270,   270,   270,   270,   270,   270,   270,   270,   270,   270,
     271,   271,   271,   271,   271,   271,   271,   271,   271,   271,
     271,   271,   271,   271,   271,   271,   271,   271,   271,   271,
     271,   271,   271,   271,   271,   271,   271,   271,   271,   271,
     271,   271,   271,   271,   271,   271,   271,   271,   271,   271,
     271,   271,   271,   271,   271,   271,   271,   271,   271,   271,
     271,   271,   271,   271,   271,   271,   271,   271,   271,   272,
     272,   272,   272,   272,   272,   272,   272,   272,   272,   272,
     272,   272,   272,   272,   272,   272,   272,   272,   272,   272,
     272,   272,   272,   272,   272,   272,   272,   272,   272,   273,
     273,   273,   273,   273,   273,   273,   273,   273,   273,   273,
     273,   273,   273,   273,   273,   273,   273,   273,   273,   273,
     273,   273,   273,   273,   273,   273,   273,   273,   273,   273,
     273,   273,   273,   273,   273,   273,   273,   273,   273,   273,
     273,   273,   273,   274,   274,   274,   274,   274,   274,   274,
     274,   274,   274,   274,   275,   275,   275,   275,   275,   276,
     276,   276,   276,   277,   277,   277,   278,   278,   278,   278,
     278,   278,   278,   278,   278,   278,   278,   279,   279,   279,
     279,   280,   280,   280,   280,   281
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     2,     2,     2,     1,     2,     2,     1,     3,
       4,     5,     4,     0,     5,     1,     1,     1,     1,     1,
       2,     1,     1,     2,     2,     2,     2,     8,    11,     9,
      11,    13,    15,     7,     9,    12,     9,     9,    13,     9,
       7,     5,     0,     3,     1,     2,     2,     3,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     4,
       5,     5,     1,     3,     1,     4,     4,     0,     4,     3,
       0,     4,     3,     1,     2,     4,     0,     4,     3,     2,
       4,     0,     6,     0,     9,     0,     6,     0,     7,     0,
      11,     0,    12,     0,     8,     0,     9,     1,     1,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     4,     5,
       6,     4,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     1,
       1,     1,     1,     1,     2,     0,     6,     2,     2,     1,
       1,     1,     3,     1,     1,     1,     2,     4,     2,     3,
       3,     4,     2,     3,     1,     1,     1,     1,     1,     2,
       3,     2,     2,     2,     2,     2,     3,     4,     3,     0,
       6,     2,     3,     1,     3,     4,     1,     2,     1,     1,
       1,     3,     2,     1,     3,     1,     1,     1,     3,     2,
       1,     3,     1,     2,     1,     2,     1,     3,     5,     3,
       3,     1,     3,     3,     3,     3,     4,     1,     1,     2,
       1,     3,     3,     5,     3,     4,     5,     3,     4,     5,
       2,     4,     1,     1,     1,     1,     2,     2,     2,     2,
       2,     3,     4,     1,     1,     2,     2,     2,     2,     2,
       3,     4,     7,     3,     1,     2,     2,     2,     2,     2,
       2,     3,     4,     7,     3,     1,     1,     2,     2,     2,
       2,     2,     2,     3,     4,     1,     1,     2,     2,     2,
       2,     2,     2,     3,     4,     5,     9,     9,     9,     1,
       1,     2,     1,     1,     1,     3,     4,     4,     4,     4,
       1,     1,     1,     1,     2,     1,     1,     1,     3,     4,
       2,     4,     4,     4,     1,     1,     1,     2,     3,     2,
       4,     4,     1,     1,     1,     2,     3,     2,     3,     1,
       4,     5,     5,     0,     6,     0,     9,     1,     1,     1,
       1,     2,     3,     1,     2,     2,     2,     3,     3,     3,
       3,     3,     3,     4,     3,     1,     4,     2,     1,     1,
       1,     3,     5,     1,     2,     4,     1,     2,     2,     1,
       1,     1,     0,     6,     0,     7,     4,     5,     3,     5,
       4,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     2,     2,     1,     1,
       2,     1,     0,     2,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     1,     1,     1,     1,
       3,     1,     4,     7,     7,     7,     7,     4,     2,     5,
       4,     2,     2,     2,     2,     2,     2,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     5,     4,     4,     3,     3,     3,     3,
       1,     4,     7,     7,     7,     7,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     2,     5,     4,     2,     5,     4,     4,     2,     2,
       2,     2,     2,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     5,     4,     4,     3,     3,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       8,    11,     4,     4,     6,     4,     4,     6,     6,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     1,
       4,     7,     7,     7,     7,     4,     2,     5,     4,     2,
       5,     4,     4,     2,     2,     2,     2,     2,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     5,     4,     4,     3,
       3,     3,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     4,     2,
       3,     1,     2,     1,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     0
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YY_LOCATION_PRINT
#  if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#   define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

#  else
#   define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#  endif
# endif /* !defined YY_LOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  YYUSE (yylocationp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YY_LOCATION_PRINT (yyo, *yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, &yylloc);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3: /* grammar: START_CONST_EXPR const_expr  */
#line 454 "dtool/src/cppparser/cppBison.yxx"
{
  current_expr = (yyvsp[0].u.expr);
}
#line 3941 "built/tmp/cppBison.yxx.c"
    break;

  case 4: /* grammar: START_TYPE full_type  */
#line 458 "dtool/src/cppparser/cppBison.yxx"
{
  current_type = (yyvsp[0].u.type);
}
#line 3949 "built/tmp/cppBison.yxx.c"
    break;

  case 10: /* constructor_init: name '(' optional_const_expr_comma ')'  */
#line 476 "dtool/src/cppparser/cppBison.yxx"
{
  delete (yyvsp[-1].u.expr);
}
#line 3957 "built/tmp/cppBison.yxx.c"
    break;

  case 11: /* constructor_init: name '(' optional_const_expr_comma ')' ELLIPSIS  */
#line 480 "dtool/src/cppparser/cppBison.yxx"
{
  delete (yyvsp[-2].u.expr);
}
#line 3965 "built/tmp/cppBison.yxx.c"
    break;

  case 12: /* constructor_init: name '{' optional_const_expr_comma '}'  */
#line 484 "dtool/src/cppparser/cppBison.yxx"
{
  delete (yyvsp[-1].u.expr);
}
#line 3973 "built/tmp/cppBison.yxx.c"
    break;

  case 13: /* $@1: %empty  */
#line 496 "dtool/src/cppparser/cppBison.yxx"
{
  push_storage_class((current_storage_class & ~CPPInstance::SC_c_binding) |
                     ((yyvsp[-1].u.integer) & CPPInstance::SC_c_binding));
}
#line 3982 "built/tmp/cppBison.yxx.c"
    break;

  case 14: /* extern_c: storage_class '{' $@1 cpp '}'  */
#line 501 "dtool/src/cppparser/cppBison.yxx"
{
  pop_storage_class();
}
#line 3990 "built/tmp/cppBison.yxx.c"
    break;

  case 21: /* declaration: KW_BEGIN_PUBLISH  */
#line 514 "dtool/src/cppparser/cppBison.yxx"
{
  if (publish_nest_level != 0) {
    yyerror("Unclosed __begin_publish", publish_loc);
    publish_nest_level = 0;
    current_scope->set_current_vis(V_public);
  }

  publish_previous = current_scope->get_current_vis();
  publish_loc = (yylsp[0]);
  publish_nest_level++;
  current_scope->set_current_vis(V_published);
}
#line 4007 "built/tmp/cppBison.yxx.c"
    break;

  case 22: /* declaration: KW_END_PUBLISH  */
#line 527 "dtool/src/cppparser/cppBison.yxx"
{
  if (publish_nest_level != 1) {
    yyerror("Unmatched __end_publish", (yylsp[0]));
  } else {
    current_scope->set_current_vis(publish_previous);
  }
  publish_nest_level = 0;
}
#line 4020 "built/tmp/cppBison.yxx.c"
    break;

  case 23: /* declaration: KW_PUBLISHED ':'  */
#line 536 "dtool/src/cppparser/cppBison.yxx"
{
  current_scope->set_current_vis(V_published);
}
#line 4028 "built/tmp/cppBison.yxx.c"
    break;

  case 24: /* declaration: KW_PUBLIC ':'  */
#line 540 "dtool/src/cppparser/cppBison.yxx"
{
  if (publish_nest_level > 0) {
    current_scope->set_current_vis(V_published);
  } else {
    current_scope->set_current_vis(V_public);
  }
}
#line 4040 "built/tmp/cppBison.yxx.c"
    break;

  case 25: /* declaration: KW_PROTECTED ':'  */
#line 548 "dtool/src/cppparser/cppBison.yxx"
{
  current_scope->set_current_vis(V_protected);
}
#line 4048 "built/tmp/cppBison.yxx.c"
    break;

  case 26: /* declaration: KW_PRIVATE ':'  */
#line 552 "dtool/src/cppparser/cppBison.yxx"
{
  current_scope->set_current_vis(V_private);
}
#line 4056 "built/tmp/cppBison.yxx.c"
    break;

  case 27: /* declaration: KW_MAKE_PROPERTY '(' name ',' IDENTIFIER maybe_comma_identifier ')' ';'  */
#line 556 "dtool/src/cppparser/cppBison.yxx"
{
  CPPDeclaration *getter = (yyvsp[-3].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
  if (getter == nullptr || getter->get_subtype() != CPPDeclaration::ST_function_group) {
    yyerror("Reference to non-existent or invalid getter: " + (yyvsp[-3].u.identifier)->get_fully_scoped_name(), (yylsp[-3]));
  } else {
    CPPMakeProperty *make_property = new CPPMakeProperty((yyvsp[-5].u.identifier), CPPMakeProperty::T_normal, current_scope, (yylsp[-7]).file);
    make_property->_get_function = getter->as_function_group();

    if ((yyvsp[-2].u.identifier) != nullptr) {
      CPPDeclaration *setter = (yyvsp[-2].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
      if (setter == nullptr || setter->get_subtype() != CPPDeclaration::ST_function_group) {
        yyerror("Reference to non-existent or invalid setter: " + (yyvsp[-2].u.identifier)->get_fully_scoped_name(), (yylsp[-2]));
      } else {
        make_property->_set_function = setter->as_function_group();
      }
    }

    current_scope->add_declaration(make_property, global_scope, current_lexer, (yylsp[-7]));
  }
}
#line 4081 "built/tmp/cppBison.yxx.c"
    break;

  case 28: /* declaration: KW_MAKE_PROPERTY '(' name ',' IDENTIFIER ',' IDENTIFIER ',' IDENTIFIER ')' ';'  */
#line 577 "dtool/src/cppparser/cppBison.yxx"
{
  CPPDeclaration *getter = (yyvsp[-6].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
  if (getter == nullptr || getter->get_subtype() != CPPDeclaration::ST_function_group) {
    yyerror("Reference to non-existent or invalid getter: " + (yyvsp[-6].u.identifier)->get_fully_scoped_name(), (yylsp[-6]));

  } else {
    CPPMakeProperty *make_property = new CPPMakeProperty((yyvsp[-8].u.identifier), CPPMakeProperty::T_normal, current_scope, (yylsp[-10]).file);
    make_property->_get_function = getter->as_function_group();

    CPPDeclaration *setter = (yyvsp[-4].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
    if (setter == nullptr || setter->get_subtype() != CPPDeclaration::ST_function_group) {
      yyerror("Reference to non-existent or invalid setter: " + (yyvsp[-4].u.identifier)->get_fully_scoped_name(), (yylsp[-4]));
    } else {
      make_property->_set_function = setter->as_function_group();
    }

    CPPDeclaration *deleter = (yyvsp[-2].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
    if (deleter == nullptr || deleter->get_subtype() != CPPDeclaration::ST_function_group) {
      yyerror("reference to non-existent or invalid delete method: " + (yyvsp[-2].u.identifier)->get_fully_scoped_name(), (yylsp[-2]));
    } else {
      make_property->_del_function = deleter->as_function_group();
    }

    current_scope->add_declaration(make_property, global_scope, current_lexer, (yylsp[-10]));
  }
}
#line 4112 "built/tmp/cppBison.yxx.c"
    break;

  case 29: /* declaration: KW_MAKE_SEQ_PROPERTY '(' name ',' IDENTIFIER ',' IDENTIFIER ')' ';'  */
#line 604 "dtool/src/cppparser/cppBison.yxx"
{
  CPPDeclaration *length_getter = (yyvsp[-4].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
  if (length_getter == nullptr || length_getter->get_subtype() != CPPDeclaration::ST_function_group) {
    yyerror("reference to non-existent or invalid length method: " + (yyvsp[-4].u.identifier)->get_fully_scoped_name(), (yylsp[-4]));
    length_getter = nullptr;
  }

  CPPDeclaration *getter = (yyvsp[-2].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
  if (getter == nullptr || getter->get_subtype() != CPPDeclaration::ST_function_group) {
    yyerror("Reference to non-existent or invalid getter: " + (yyvsp[-2].u.identifier)->get_fully_scoped_name(), (yylsp[-2]));
    getter = nullptr;
  }

  if (getter != nullptr && length_getter != nullptr) {
    CPPMakeProperty *make_property = new CPPMakeProperty((yyvsp[-6].u.identifier), CPPMakeProperty::T_sequence, current_scope, (yylsp[-8]).file);
    make_property->_get_function = getter->as_function_group();
    make_property->_length_function = length_getter->as_function_group();
    current_scope->add_declaration(make_property, global_scope, current_lexer, (yylsp[-8]));
  }
}
#line 4137 "built/tmp/cppBison.yxx.c"
    break;

  case 30: /* declaration: KW_MAKE_SEQ_PROPERTY '(' name ',' IDENTIFIER ',' IDENTIFIER ',' IDENTIFIER ')' ';'  */
#line 625 "dtool/src/cppparser/cppBison.yxx"
{
  CPPDeclaration *length_getter = (yyvsp[-6].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
  if (length_getter == nullptr || length_getter->get_subtype() != CPPDeclaration::ST_function_group) {
    yyerror("reference to non-existent or invalid length method: " + (yyvsp[-6].u.identifier)->get_fully_scoped_name(), (yylsp[-6]));
    length_getter = nullptr;
  }

  CPPDeclaration *getter = (yyvsp[-4].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
  if (getter == nullptr || getter->get_subtype() != CPPDeclaration::ST_function_group) {
    yyerror("Reference to non-existent or invalid getter: " + (yyvsp[-4].u.identifier)->get_fully_scoped_name(), (yylsp[-4]));
    getter = nullptr;
  }

  if (getter != nullptr && length_getter != nullptr) {
    CPPMakeProperty *make_property = new CPPMakeProperty((yyvsp[-8].u.identifier), CPPMakeProperty::T_sequence, current_scope, (yylsp[-10]).file);
    make_property->_get_function = getter->as_function_group();
    make_property->_length_function = length_getter->as_function_group();

    CPPDeclaration *setter = (yyvsp[-2].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
    if (setter == nullptr || setter->get_subtype() != CPPDeclaration::ST_function_group) {
      yyerror("Reference to non-existent or invalid setter: " + (yyvsp[-2].u.identifier)->get_fully_scoped_name(), (yylsp[-2]));
    } else {
      make_property->_set_function = setter->as_function_group();
    }

    current_scope->add_declaration(make_property, global_scope, current_lexer, (yylsp[-10]));
  }
}
#line 4170 "built/tmp/cppBison.yxx.c"
    break;

  case 31: /* declaration: KW_MAKE_SEQ_PROPERTY '(' name ',' IDENTIFIER ',' IDENTIFIER ',' IDENTIFIER ',' IDENTIFIER ')' ';'  */
#line 654 "dtool/src/cppparser/cppBison.yxx"
{
  CPPDeclaration *length_getter = (yyvsp[-8].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
  if (length_getter == nullptr || length_getter->get_subtype() != CPPDeclaration::ST_function_group) {
    yyerror("reference to non-existent or invalid length method: " + (yyvsp[-8].u.identifier)->get_fully_scoped_name(), (yylsp[-8]));
    length_getter = nullptr;
  }

  CPPDeclaration *getter = (yyvsp[-6].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
  if (getter == nullptr || getter->get_subtype() != CPPDeclaration::ST_function_group) {
    yyerror("Reference to non-existent or invalid getter: " + (yyvsp[-6].u.identifier)->get_fully_scoped_name(), (yylsp[-6]));
    getter = nullptr;
  }

  if (getter != nullptr && length_getter != nullptr) {
    CPPMakeProperty *make_property = new CPPMakeProperty((yyvsp[-10].u.identifier), CPPMakeProperty::T_sequence, current_scope, (yylsp[-12]).file);
    make_property->_get_function = getter->as_function_group();
    make_property->_length_function = length_getter->as_function_group();

    CPPDeclaration *setter = (yyvsp[-4].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
    if (setter == nullptr || setter->get_subtype() != CPPDeclaration::ST_function_group) {
      yyerror("Reference to non-existent or invalid setter: " + (yyvsp[-4].u.identifier)->get_fully_scoped_name(), (yylsp[-4]));
    } else {
      make_property->_set_function = setter->as_function_group();
    }

    CPPDeclaration *deleter = (yyvsp[-2].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
    if (deleter == nullptr || deleter->get_subtype() != CPPDeclaration::ST_function_group) {
      yyerror("reference to non-existent or invalid delete method: " + (yyvsp[-2].u.identifier)->get_fully_scoped_name(), (yylsp[-2]));
    } else {
      make_property->_del_function = deleter->as_function_group();
    }

    current_scope->add_declaration(make_property, global_scope, current_lexer, (yylsp[-12]));
  }
}
#line 4210 "built/tmp/cppBison.yxx.c"
    break;

  case 32: /* declaration: KW_MAKE_SEQ_PROPERTY '(' name ',' IDENTIFIER ',' IDENTIFIER ',' IDENTIFIER ',' IDENTIFIER ',' IDENTIFIER ')' ';'  */
#line 690 "dtool/src/cppparser/cppBison.yxx"
{
  CPPDeclaration *length_getter = (yyvsp[-10].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
  if (length_getter == nullptr || length_getter->get_subtype() != CPPDeclaration::ST_function_group) {
    yyerror("reference to non-existent or invalid length method: " + (yyvsp[-10].u.identifier)->get_fully_scoped_name(), (yylsp[-10]));
    length_getter = nullptr;
  }

  CPPDeclaration *getter = (yyvsp[-8].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
  if (getter == nullptr || getter->get_subtype() != CPPDeclaration::ST_function_group) {
    yyerror("Reference to non-existent or invalid getter: " + (yyvsp[-8].u.identifier)->get_fully_scoped_name(), (yylsp[-8]));
    getter = nullptr;
  }

  if (getter != nullptr && length_getter != nullptr) {
    CPPMakeProperty *make_property = new CPPMakeProperty((yyvsp[-12].u.identifier), CPPMakeProperty::T_sequence, current_scope, (yylsp[-14]).file);
    make_property->_get_function = getter->as_function_group();
    make_property->_length_function = length_getter->as_function_group();

    CPPDeclaration *setter = (yyvsp[-6].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
    if (setter == nullptr || setter->get_subtype() != CPPDeclaration::ST_function_group) {
      yyerror("Reference to non-existent or invalid setter: " + (yyvsp[-6].u.identifier)->get_fully_scoped_name(), (yylsp[-6]));
    } else {
      make_property->_set_function = setter->as_function_group();
    }

    CPPDeclaration *deleter = (yyvsp[-4].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
    if (deleter == nullptr || deleter->get_subtype() != CPPDeclaration::ST_function_group) {
      yyerror("reference to non-existent or invalid delete method: " + (yyvsp[-4].u.identifier)->get_fully_scoped_name(), (yylsp[-4]));
    } else {
      make_property->_del_function = deleter->as_function_group();
    }

    CPPDeclaration *inserter = (yyvsp[-2].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
    if (inserter == nullptr || inserter->get_subtype() != CPPDeclaration::ST_function_group) {
      yyerror("reference to non-existent or invalid append method: " + (yyvsp[-2].u.identifier)->get_fully_scoped_name(), (yylsp[-2]));
    } else {
      make_property->_insert_function = inserter->as_function_group();
    }

    current_scope->add_declaration(make_property, global_scope, current_lexer, (yylsp[-14]));
  }
}
#line 4257 "built/tmp/cppBison.yxx.c"
    break;

  case 33: /* declaration: KW_MAKE_MAP_PROPERTY '(' name ',' IDENTIFIER ')' ';'  */
#line 733 "dtool/src/cppparser/cppBison.yxx"
{
  CPPDeclaration *getter = (yyvsp[-2].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
  if (getter == nullptr || getter->get_subtype() != CPPDeclaration::ST_function_group) {
    yyerror("reference to non-existent or invalid item getter method: " + (yyvsp[-2].u.identifier)->get_fully_scoped_name(), (yylsp[-2]));

  } else {
    CPPMakeProperty *make_property = new CPPMakeProperty((yyvsp[-4].u.identifier), CPPMakeProperty::T_mapping, current_scope, (yylsp[-6]).file);
    make_property->_get_function = getter->as_function_group();
    current_scope->add_declaration(make_property, global_scope, current_lexer, (yylsp[-6]));
  }
}
#line 4273 "built/tmp/cppBison.yxx.c"
    break;

  case 34: /* declaration: KW_MAKE_MAP_PROPERTY '(' name ',' IDENTIFIER ',' IDENTIFIER ')' ';'  */
#line 745 "dtool/src/cppparser/cppBison.yxx"
{
  CPPDeclaration *getter = (yyvsp[-2].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
  if (getter == nullptr || getter->get_subtype() != CPPDeclaration::ST_function_group) {
    yyerror("Reference to non-existent or invalid getter: " + (yyvsp[-2].u.identifier)->get_fully_scoped_name(), (yylsp[-2]));

  } else {
    CPPMakeProperty *make_property;
    make_property = new CPPMakeProperty((yyvsp[-6].u.identifier), CPPMakeProperty::T_mapping, current_scope, (yylsp[-8]).file);
    make_property->_get_function = getter->as_function_group();

    CPPDeclaration *hasser = (yyvsp[-4].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
    if (hasser == nullptr || hasser->get_subtype() != CPPDeclaration::ST_function_group) {
      yyerror("reference to non-existent or invalid has/find method: " + (yyvsp[-4].u.identifier)->get_fully_scoped_name(), (yylsp[-4]));
    } else {
      make_property->_has_function = hasser->as_function_group();
    }

    current_scope->add_declaration(make_property, global_scope, current_lexer, (yylsp[-8]));
  }
}
#line 4298 "built/tmp/cppBison.yxx.c"
    break;

  case 35: /* declaration: KW_MAKE_MAP_PROPERTY '(' name ',' IDENTIFIER ',' IDENTIFIER ',' IDENTIFIER maybe_comma_identifier ')' ';'  */
#line 766 "dtool/src/cppparser/cppBison.yxx"
{
  CPPDeclaration *getter = (yyvsp[-5].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
  if (getter == nullptr || getter->get_subtype() != CPPDeclaration::ST_function_group) {
    yyerror("Reference to non-existent or invalid getter: " + (yyvsp[-5].u.identifier)->get_fully_scoped_name(), (yylsp[-5]));

  } else {
    CPPMakeProperty *make_property = new CPPMakeProperty((yyvsp[-9].u.identifier), CPPMakeProperty::T_mapping, current_scope, (yylsp[-11]).file);
    make_property->_get_function = getter->as_function_group();

    CPPDeclaration *hasser = (yyvsp[-7].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
    if (hasser == nullptr || hasser->get_subtype() != CPPDeclaration::ST_function_group) {
      yyerror("reference to non-existent or invalid has/find method: " + (yyvsp[-7].u.identifier)->get_fully_scoped_name(), (yylsp[-7]));
    } else {
      make_property->_has_function = hasser->as_function_group();
    }

    CPPDeclaration *setter = (yyvsp[-3].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
    if (setter == nullptr || setter->get_subtype() != CPPDeclaration::ST_function_group) {
      yyerror("Reference to non-existent or invalid setter: " + (yyvsp[-3].u.identifier)->get_fully_scoped_name(), (yylsp[-3]));
    } else {
      make_property->_set_function = setter->as_function_group();
    }

    if ((yyvsp[-2].u.identifier) != nullptr) {
      CPPDeclaration *deleter = (yyvsp[-2].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
      if (deleter == nullptr || deleter->get_subtype() != CPPDeclaration::ST_function_group) {
        yyerror("reference to non-existent or invalid delete method: " + (yyvsp[-2].u.identifier)->get_fully_scoped_name(), (yylsp[-2]));
      } else {
        make_property->_del_function = deleter->as_function_group();
      }
    }

    current_scope->add_declaration(make_property, global_scope, current_lexer, (yylsp[-11]));
  }
}
#line 4338 "built/tmp/cppBison.yxx.c"
    break;

  case 36: /* declaration: KW_MAKE_MAP_KEYS_SEQ '(' name ',' IDENTIFIER ',' IDENTIFIER ')' ';'  */
#line 802 "dtool/src/cppparser/cppBison.yxx"
{
  CPPDeclaration *length_getter = (yyvsp[-4].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
  if (length_getter == nullptr || length_getter->get_subtype() != CPPDeclaration::ST_function_group) {
    yyerror("reference to non-existent or invalid length method: " + (yyvsp[-4].u.identifier)->get_fully_scoped_name(), (yylsp[-4]));
    length_getter = nullptr;
  }

  CPPDeclaration *getter = (yyvsp[-2].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
  if (getter == nullptr || getter->get_subtype() != CPPDeclaration::ST_function_group) {
    yyerror("reference to non-existent or invalid getter: " + (yyvsp[-2].u.identifier)->get_fully_scoped_name(), (yylsp[-2]));
    getter = nullptr;
  }

  if (getter != nullptr && length_getter != nullptr) {
    CPPMakeProperty *make_property = nullptr;
    for (size_t i = 0; i < current_scope->_declarations.size(); ++i) {
      make_property = current_scope->_declarations[i]->as_make_property();
      if (make_property != nullptr) {
        if (make_property->get_fully_scoped_name() == (yyvsp[-6].u.identifier)->get_fully_scoped_name()) {
          break;
        } else {
          make_property = nullptr;
        }
      }
    }
    if (make_property != nullptr) {
      make_property->_get_key_function = getter->as_function_group();
      make_property->_length_function = length_getter->as_function_group();
    } else {
      yyerror("reference to non-existent MAKE_MAP_PROPERTY: " + (yyvsp[-6].u.identifier)->get_fully_scoped_name(), (yylsp[-6]));
    }
  }
}
#line 4376 "built/tmp/cppBison.yxx.c"
    break;

  case 37: /* declaration: KW_MAKE_PROPERTY2 '(' name ',' IDENTIFIER ',' IDENTIFIER ')' ';'  */
#line 836 "dtool/src/cppparser/cppBison.yxx"
{
  CPPDeclaration *getter = (yyvsp[-2].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
  if (getter == nullptr || getter->get_subtype() != CPPDeclaration::ST_function_group) {
    yyerror("Reference to non-existent or invalid getter: " + (yyvsp[-2].u.identifier)->get_fully_scoped_name(), (yylsp[-2]));

  } else {
    CPPMakeProperty *make_property;
    make_property = new CPPMakeProperty((yyvsp[-6].u.identifier), CPPMakeProperty::T_normal,
                                        current_scope, (yylsp[-8]).file);
    make_property->_get_function = getter->as_function_group();

    CPPDeclaration *hasser = (yyvsp[-4].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
    if (hasser == nullptr || hasser->get_subtype() != CPPDeclaration::ST_function_group) {
      yyerror("reference to non-existent or invalid has/find method: " + (yyvsp[-4].u.identifier)->get_fully_scoped_name(), (yylsp[-4]));
    } else {
      make_property->_has_function = hasser->as_function_group();
    }

    current_scope->add_declaration(make_property, global_scope, current_lexer, (yylsp[-8]));
  }
}
#line 4402 "built/tmp/cppBison.yxx.c"
    break;

  case 38: /* declaration: KW_MAKE_PROPERTY2 '(' name ',' IDENTIFIER ',' IDENTIFIER ',' IDENTIFIER ',' IDENTIFIER ')' ';'  */
#line 858 "dtool/src/cppparser/cppBison.yxx"
{
  CPPDeclaration *getter = (yyvsp[-6].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
  if (getter == nullptr || getter->get_subtype() != CPPDeclaration::ST_function_group) {
    yyerror("Reference to non-existent or invalid getter: " + (yyvsp[-6].u.identifier)->get_fully_scoped_name(), (yylsp[-6]));

  } else {
    CPPMakeProperty *make_property;
    make_property = new CPPMakeProperty((yyvsp[-10].u.identifier), CPPMakeProperty::T_normal,
                                        current_scope, (yylsp[-12]).file);
    make_property->_get_function = getter->as_function_group();

    CPPDeclaration *hasser = (yyvsp[-8].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
    if (hasser == nullptr || hasser->get_subtype() != CPPDeclaration::ST_function_group) {
      yyerror("reference to non-existent or invalid has/find method: " + (yyvsp[-8].u.identifier)->get_fully_scoped_name(), (yylsp[-8]));
    } else {
      make_property->_has_function = hasser->as_function_group();
    }

    CPPDeclaration *setter = (yyvsp[-4].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
    if (setter == nullptr || setter->get_subtype() != CPPDeclaration::ST_function_group) {
      yyerror("reference to non-existent or invalid setter: " + (yyvsp[-4].u.identifier)->get_fully_scoped_name(), (yylsp[-4]));
    } else {
      make_property->_set_function = setter->as_function_group();
    }

    CPPDeclaration *clearer = (yyvsp[-2].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
    if (clearer == nullptr || clearer->get_subtype() != CPPDeclaration::ST_function_group) {
      yyerror("reference to non-existent or invalid clear method: " + (yyvsp[-2].u.identifier)->get_fully_scoped_name(), (yylsp[-2]));
    } else {
      make_property->_clear_function = clearer->as_function_group();
    }

    current_scope->add_declaration(make_property, global_scope, current_lexer, (yylsp[-12]));
  }
}
#line 4442 "built/tmp/cppBison.yxx.c"
    break;

  case 39: /* declaration: KW_MAKE_SEQ '(' name ',' IDENTIFIER ',' IDENTIFIER ')' ';'  */
#line 894 "dtool/src/cppparser/cppBison.yxx"
{
  CPPDeclaration *length_getter = (yyvsp[-4].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
  if (length_getter == nullptr || length_getter->get_subtype() != CPPDeclaration::ST_function_group) {
    yyerror("reference to non-existent or invalid length method: " + (yyvsp[-4].u.identifier)->get_fully_scoped_name(), (yylsp[-4]));
    length_getter = nullptr;
  }

  CPPDeclaration *element_getter = (yyvsp[-2].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
  if (element_getter == nullptr || element_getter->get_subtype() != CPPDeclaration::ST_function_group) {
    yyerror("reference to non-existent or invalid element method: " + (yyvsp[-2].u.identifier)->get_fully_scoped_name(), (yylsp[-4]));
    element_getter = nullptr;
  }

  if (length_getter != nullptr && element_getter != nullptr) {
    CPPMakeSeq *make_seq = new CPPMakeSeq((yyvsp[-6].u.identifier),
                                          length_getter->as_function_group(),
                                          element_getter->as_function_group(),
                                          current_scope, (yylsp[-8]).file);
    current_scope->add_declaration(make_seq, global_scope, current_lexer, (yylsp[-8]));
  }
}
#line 4468 "built/tmp/cppBison.yxx.c"
    break;

  case 40: /* declaration: KW_STATIC_ASSERT '(' const_expr ',' string_literal ')' ';'  */
#line 916 "dtool/src/cppparser/cppBison.yxx"
{
  CPPExpression::Result result = (yyvsp[-4].u.expr)->evaluate();
  if (result._type == CPPExpression::RT_error) {
    yywarning("static_assert requires a constant expression", (yylsp[-4]));
  } else if (!result.as_boolean()) {
    stringstream str;
    str << *(yyvsp[-2].u.expr);
    yywarning("static_assert failed: " + str.str(), (yylsp[-4]));
  }
}
#line 4483 "built/tmp/cppBison.yxx.c"
    break;

  case 41: /* declaration: KW_STATIC_ASSERT '(' const_expr ')' ';'  */
#line 927 "dtool/src/cppparser/cppBison.yxx"
{
  // This alternative version of static_assert was introduced in C++17.
  CPPExpression::Result result = (yyvsp[-2].u.expr)->evaluate();
  if (result._type == CPPExpression::RT_error) {
    yywarning("static_assert requires a constant expression", (yylsp[-2]));
  } else if (!result.as_boolean()) {
    yywarning("static_assert failed", (yylsp[-2]));
  }
}
#line 4497 "built/tmp/cppBison.yxx.c"
    break;

  case 42: /* $@2: %empty  */
#line 940 "dtool/src/cppparser/cppBison.yxx"
{
  CPPScope *new_scope = new CPPScope(current_scope, CPPNameComponent("temp"),
                                     V_public);
  push_scope(new_scope);
}
#line 4507 "built/tmp/cppBison.yxx.c"
    break;

  case 43: /* friend_declaration: KW_FRIEND $@2 declaration  */
#line 946 "dtool/src/cppparser/cppBison.yxx"
{
  delete current_scope;
  pop_scope();
}
#line 4516 "built/tmp/cppBison.yxx.c"
    break;

  case 44: /* storage_class: empty  */
#line 955 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.integer) = 0;
}
#line 4524 "built/tmp/cppBison.yxx.c"
    break;

  case 45: /* storage_class: KW_CONST storage_class  */
#line 959 "dtool/src/cppparser/cppBison.yxx"
{
  // This isn't really a storage class, but it helps with parsing.
  (yyval.u.integer) = (yyvsp[0].u.integer) | (int)CPPInstance::SC_const;
}
#line 4533 "built/tmp/cppBison.yxx.c"
    break;

  case 46: /* storage_class: KW_EXTERN storage_class  */
#line 964 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.integer) = (yyvsp[0].u.integer) | (int)CPPInstance::SC_extern;
}
#line 4541 "built/tmp/cppBison.yxx.c"
    break;

  case 47: /* storage_class: KW_EXTERN SIMPLE_STRING storage_class  */
#line 968 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.integer) = (yyvsp[0].u.integer) | (int)CPPInstance::SC_extern;
  if ((yyvsp[-1].str) == "C") {
    (yyval.u.integer) |= (int)CPPInstance::SC_c_binding;
  } else if ((yyvsp[-1].str) == "C++") {
    (yyval.u.integer) &= ~(int)CPPInstance::SC_c_binding;
  } else {
    yywarning("Ignoring unknown linkage type \"" + (yyvsp[-1].str) + "\"", (yylsp[-1]));
  }
}
#line 4556 "built/tmp/cppBison.yxx.c"
    break;

  case 48: /* storage_class: KW_STATIC storage_class  */
#line 979 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.integer) = (yyvsp[0].u.integer) | (int)CPPInstance::SC_static;
}
#line 4564 "built/tmp/cppBison.yxx.c"
    break;

  case 49: /* storage_class: KW_INLINE storage_class  */
#line 983 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.integer) = (yyvsp[0].u.integer) | (int)CPPInstance::SC_inline;
}
#line 4572 "built/tmp/cppBison.yxx.c"
    break;

  case 50: /* storage_class: KW_VIRTUAL storage_class  */
#line 987 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.integer) = (yyvsp[0].u.integer) | (int)CPPInstance::SC_virtual;
}
#line 4580 "built/tmp/cppBison.yxx.c"
    break;

  case 51: /* storage_class: KW_EXPLICIT storage_class  */
#line 991 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.integer) = (yyvsp[0].u.integer) | (int)CPPInstance::SC_explicit;
}
#line 4588 "built/tmp/cppBison.yxx.c"
    break;

  case 52: /* storage_class: KW_REGISTER storage_class  */
#line 995 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.integer) = (yyvsp[0].u.integer) | (int)CPPInstance::SC_register;
}
#line 4596 "built/tmp/cppBison.yxx.c"
    break;

  case 53: /* storage_class: KW_VOLATILE storage_class  */
#line 999 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.integer) = (yyvsp[0].u.integer) | (int)CPPInstance::SC_volatile;
}
#line 4604 "built/tmp/cppBison.yxx.c"
    break;

  case 54: /* storage_class: KW_MUTABLE storage_class  */
#line 1003 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.integer) = (yyvsp[0].u.integer) | (int)CPPInstance::SC_mutable;
}
#line 4612 "built/tmp/cppBison.yxx.c"
    break;

  case 55: /* storage_class: KW_CONSTEXPR storage_class  */
#line 1007 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.integer) = (yyvsp[0].u.integer) | (int)CPPInstance::SC_constexpr;
}
#line 4620 "built/tmp/cppBison.yxx.c"
    break;

  case 56: /* storage_class: KW_BLOCKING storage_class  */
#line 1011 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.integer) = (yyvsp[0].u.integer) | (int)CPPInstance::SC_blocking;
}
#line 4628 "built/tmp/cppBison.yxx.c"
    break;

  case 57: /* storage_class: KW_EXTENSION storage_class  */
#line 1015 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.integer) = (yyvsp[0].u.integer) | (int)CPPInstance::SC_extension;
}
#line 4636 "built/tmp/cppBison.yxx.c"
    break;

  case 58: /* storage_class: KW_THREAD_LOCAL storage_class  */
#line 1019 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.integer) = (yyvsp[0].u.integer) | (int)CPPInstance::SC_thread_local;
}
#line 4644 "built/tmp/cppBison.yxx.c"
    break;

  case 59: /* storage_class: ATTR_LEFT attribute_specifiers ATTR_RIGHT storage_class  */
#line 1023 "dtool/src/cppparser/cppBison.yxx"
{
  // Ignore attribute specifiers for now.
  (yyval.u.integer) = (yyvsp[0].u.integer);
}
#line 4653 "built/tmp/cppBison.yxx.c"
    break;

  case 60: /* storage_class: KW_ALIGNAS '(' const_expr ')' storage_class  */
#line 1028 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.integer) = (yyvsp[0].u.integer);
}
#line 4661 "built/tmp/cppBison.yxx.c"
    break;

  case 61: /* storage_class: KW_ALIGNAS '(' type_decl ')' storage_class  */
#line 1032 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.integer) = (yyvsp[0].u.integer);
}
#line 4669 "built/tmp/cppBison.yxx.c"
    break;

  case 67: /* $@3: %empty  */
#line 1050 "dtool/src/cppparser/cppBison.yxx"
{
  // We don't need to push/pop type, because we can't nest
  // type_like_declaration.
  if ((yyvsp[0].u.decl)->as_type_declaration()) {
    current_type = (yyvsp[0].u.decl)->as_type_declaration()->_type;
  } else {
    current_type = (yyvsp[0].u.decl)->as_type();
  }
  push_storage_class((yyvsp[-1].u.integer));
}
#line 4684 "built/tmp/cppBison.yxx.c"
    break;

  case 68: /* type_like_declaration: storage_class var_type_decl $@3 multiple_instance_identifiers  */
#line 1061 "dtool/src/cppparser/cppBison.yxx"
{
  pop_storage_class();
}
#line 4692 "built/tmp/cppBison.yxx.c"
    break;

  case 69: /* type_like_declaration: storage_class type_decl ';'  */
#line 1066 "dtool/src/cppparser/cppBison.yxx"
{
  // We don't really care about the storage class here.  In fact, it's
  // not actually legal to define a class or struct using a particular
  // storage class, but we require it just to help yacc out in its
  // parsing.

  current_scope->add_declaration((yyvsp[-1].u.decl), global_scope, current_lexer, (yylsp[-1]));
}
#line 4705 "built/tmp/cppBison.yxx.c"
    break;

  case 70: /* $@4: %empty  */
#line 1075 "dtool/src/cppparser/cppBison.yxx"
{
  if ((yyvsp[0].u.instance) != nullptr) {
    // Push the scope so that the initializers can make use of things defined
    // in the class body.
    push_scope((yyvsp[0].u.instance)->get_scope(current_scope, global_scope));
    (yyvsp[0].u.instance)->_storage_class |= (current_storage_class | (yyvsp[-1].u.integer));
  }
}
#line 4718 "built/tmp/cppBison.yxx.c"
    break;

  case 71: /* type_like_declaration: storage_class constructor_prototype $@4 maybe_initialize_or_constructor_body  */
#line 1084 "dtool/src/cppparser/cppBison.yxx"
{
  if ((yyvsp[-2].u.instance) != nullptr) {
    pop_scope();
    current_scope->add_declaration((yyvsp[-2].u.instance), global_scope, current_lexer, (yylsp[-2]));
    (yyvsp[-2].u.instance)->set_initializer((yyvsp[0].u.expr));
  }
}
#line 4730 "built/tmp/cppBison.yxx.c"
    break;

  case 72: /* type_like_declaration: storage_class function_prototype maybe_initialize_or_function_body  */
#line 1092 "dtool/src/cppparser/cppBison.yxx"
{
  if ((yyvsp[-1].u.instance) != nullptr) {
    (yyvsp[-1].u.instance)->_storage_class |= (current_storage_class | (yyvsp[-2].u.integer));
    current_scope->add_declaration((yyvsp[-1].u.instance), global_scope, current_lexer, (yylsp[-1]));
    (yyvsp[-1].u.instance)->set_initializer((yyvsp[0].u.expr));
  }
}
#line 4742 "built/tmp/cppBison.yxx.c"
    break;

  case 74: /* multiple_instance_identifiers: instance_identifier_and_maybe_trailing_return_type maybe_initialize_or_function_body  */
#line 1108 "dtool/src/cppparser/cppBison.yxx"
{
  if (current_storage_class & CPPInstance::SC_const) {
    (yyvsp[-1].u.inst_ident)->add_modifier(IIT_const);
  }
  CPPInstance *inst = new CPPInstance(current_type, (yyvsp[-1].u.inst_ident),
                                      current_storage_class,
                                      (yylsp[-1]).file);
  inst->set_initializer((yyvsp[0].u.expr));
  current_scope->add_declaration(inst, global_scope, current_lexer, (yylsp[-1]));
}
#line 4757 "built/tmp/cppBison.yxx.c"
    break;

  case 75: /* multiple_instance_identifiers: instance_identifier_and_maybe_trailing_return_type maybe_initialize ',' multiple_instance_identifiers  */
#line 1119 "dtool/src/cppparser/cppBison.yxx"
{
  if (current_storage_class & CPPInstance::SC_const) {
    (yyvsp[-3].u.inst_ident)->add_modifier(IIT_const);
  }
  CPPInstance *inst = new CPPInstance(current_type, (yyvsp[-3].u.inst_ident),
                                      current_storage_class,
                                      (yylsp[-3]).file);
  inst->set_initializer((yyvsp[-2].u.expr));
  current_scope->add_declaration(inst, global_scope, current_lexer, (yylsp[-3]));
}
#line 4772 "built/tmp/cppBison.yxx.c"
    break;

  case 76: /* $@5: %empty  */
#line 1134 "dtool/src/cppparser/cppBison.yxx"
{
  // We don't need to push/pop type, because we can't nest
  // multiple_var_declarations.
  if ((yyvsp[0].u.decl)->as_type_declaration()) {
    current_type = (yyvsp[0].u.decl)->as_type_declaration()->_type;
  } else {
    current_type = (yyvsp[0].u.decl)->as_type();
  }
  push_storage_class((yyvsp[-1].u.integer));
}
#line 4787 "built/tmp/cppBison.yxx.c"
    break;

  case 77: /* typedef_declaration: storage_class var_type_decl $@5 typedef_instance_identifiers  */
#line 1145 "dtool/src/cppparser/cppBison.yxx"
{
  pop_storage_class();
}
#line 4795 "built/tmp/cppBison.yxx.c"
    break;

  case 78: /* typedef_declaration: storage_class function_prototype maybe_initialize_or_function_body  */
#line 1149 "dtool/src/cppparser/cppBison.yxx"
{
  if ((yyvsp[-1].u.instance) != nullptr) {
    CPPInstance *inst = (yyvsp[-1].u.instance)->as_instance();
    if (inst != nullptr) {
      inst->_storage_class |= (current_storage_class | (yyvsp[-2].u.integer));
      current_scope->add_declaration(inst, global_scope, current_lexer, (yylsp[-1]));
      CPPTypedefType *typedef_type = new CPPTypedefType(inst->_type, inst->_ident, current_scope);
      current_scope->add_declaration(CPPType::new_type(typedef_type), global_scope, current_lexer, (yylsp[-1]));
    }
  }
}
#line 4811 "built/tmp/cppBison.yxx.c"
    break;

  case 79: /* typedef_instance_identifiers: instance_identifier_and_maybe_trailing_return_type maybe_initialize_or_function_body  */
#line 1164 "dtool/src/cppparser/cppBison.yxx"
{
  if (current_storage_class & CPPInstance::SC_const) {
    (yyvsp[-1].u.inst_ident)->add_modifier(IIT_const);
  }
  CPPType *target_type = current_type;
  CPPTypedefType *typedef_type = new CPPTypedefType(target_type, (yyvsp[-1].u.inst_ident), current_scope, (yylsp[-1]).file);
  current_scope->add_declaration(CPPType::new_type(typedef_type), global_scope, current_lexer, (yylsp[-1]));
}
#line 4824 "built/tmp/cppBison.yxx.c"
    break;

  case 80: /* typedef_instance_identifiers: instance_identifier_and_maybe_trailing_return_type maybe_initialize ',' typedef_instance_identifiers  */
#line 1173 "dtool/src/cppparser/cppBison.yxx"
{
  if (current_storage_class & CPPInstance::SC_const) {
    (yyvsp[-3].u.inst_ident)->add_modifier(IIT_const);
  }
  CPPType *target_type = current_type;
  CPPTypedefType *typedef_type = new CPPTypedefType(target_type, (yyvsp[-3].u.inst_ident), current_scope, (yylsp[-3]).file);
  current_scope->add_declaration(CPPType::new_type(typedef_type), global_scope, current_lexer, (yylsp[-3]));
}
#line 4837 "built/tmp/cppBison.yxx.c"
    break;

  case 81: /* $@6: %empty  */
#line 1187 "dtool/src/cppparser/cppBison.yxx"
{
  // Create a scope for this function.
  CPPScope *scope = new CPPScope((yyvsp[-1].u.identifier)->get_scope(current_scope, global_scope),
                                 (yyvsp[-1].u.identifier)->_names.back(), V_private);

  // It still needs to be able to pick up any template arguments, if this is
  // a definition for a method template.  Add a fake "using" declaration to
  // accomplish this.
  scope->_using.insert(current_scope);

  push_scope(scope);
}
#line 4854 "built/tmp/cppBison.yxx.c"
    break;

  case 82: /* constructor_prototype: IDENTIFIER '(' $@6 function_parameter_list ')' function_post  */
#line 1200 "dtool/src/cppparser/cppBison.yxx"
{
  CPPScope *scope = (yyvsp[-5].u.identifier)->get_scope(current_scope, global_scope);
  CPPType *type;
  std::string simple_name = (yyvsp[-5].u.identifier)->get_simple_name();
  if (!simple_name.empty() && simple_name[0] == '~') {
    // A destructor has no return type.
    type = new CPPSimpleType(CPPSimpleType::T_void);
  } else if (scope != nullptr && simple_name == scope->get_simple_name()) {
    // Neither does a constructor.
    type = new CPPSimpleType(CPPSimpleType::T_void);
  } else {
    // This isn't a constructor, so it has an implicit return type of
    // int.
    yywarning("function has no return type, assuming int", (yylsp[-5]));
    type = new CPPSimpleType(CPPSimpleType::T_int);
  }
  pop_scope();

  CPPInstanceIdentifier *ii = new CPPInstanceIdentifier((yyvsp[-5].u.identifier));
  ii->add_func_modifier((yyvsp[-2].u.param_list), (yyvsp[0].u.integer));

  (yyval.u.instance) = new CPPInstance(type, ii, 0, (yylsp[-5]).file);
}
#line 4882 "built/tmp/cppBison.yxx.c"
    break;

  case 83: /* $@7: %empty  */
#line 1226 "dtool/src/cppparser/cppBison.yxx"
{
  // Create a scope for this function.
  CPPScope *scope = new CPPScope((yyvsp[-2].u.identifier)->get_scope(current_scope, global_scope),
                                 (yyvsp[-2].u.identifier)->_names.back(), V_private);

  // It still needs to be able to pick up any template arguments, if this is
  // a definition for a method template.  Add a fake "using" declaration to
  // accomplish this.
  scope->_using.insert(current_scope);

  push_scope(scope);
}
#line 4899 "built/tmp/cppBison.yxx.c"
    break;

  case 84: /* constructor_prototype: TYPENAME_IDENTIFIER '(' IDENTIFIER ')' '(' $@7 function_parameter_list ')' function_post  */
#line 1239 "dtool/src/cppparser/cppBison.yxx"
{
  pop_scope();
  CPPType *type = (yyvsp[-8].u.identifier)->find_type(current_scope, global_scope, false, current_lexer);
  if (type == nullptr) {
    yyerror(string("internal error resolving type ") + (yyvsp[-8].u.identifier)->get_fully_scoped_name(), (yylsp[-8]));
  }
  assert(type != nullptr);

  CPPInstanceIdentifier *ii = new CPPInstanceIdentifier((yyvsp[-6].u.identifier));
  ii->add_func_modifier((yyvsp[-2].u.param_list), (yyvsp[0].u.integer));

  (yyval.u.instance) = new CPPInstance(type, ii, 0, (yylsp[-8]).file);
}
#line 4917 "built/tmp/cppBison.yxx.c"
    break;

  case 85: /* $@8: %empty  */
#line 1253 "dtool/src/cppparser/cppBison.yxx"
{
  // Create a scope for this function.
  CPPScope *scope = new CPPScope((yyvsp[-1].u.identifier)->get_scope(current_scope, global_scope),
                                 (yyvsp[-1].u.identifier)->_names.back(), V_private);

  // It still needs to be able to pick up any template arguments, if this is
  // a definition for a method template.  Add a fake "using" declaration to
  // accomplish this.
  scope->_using.insert(current_scope);

  push_scope(scope);
}
#line 4934 "built/tmp/cppBison.yxx.c"
    break;

  case 86: /* constructor_prototype: TYPENAME_IDENTIFIER '(' $@8 function_parameter_list ')' function_post  */
#line 1266 "dtool/src/cppparser/cppBison.yxx"
{
  pop_scope();
  CPPType *type;
  if ((yyvsp[-5].u.identifier)->get_simple_name() == current_scope->get_simple_name()) {
    // This is a constructor, and has no return.
    type = new CPPSimpleType(CPPSimpleType::T_void);
  } else {
    // This isn't a constructor, so it has an implicit return type of
    // int.
    type = new CPPSimpleType(CPPSimpleType::T_int);
  }

  CPPInstanceIdentifier *ii = new CPPInstanceIdentifier((yyvsp[-5].u.identifier));
  ii->add_func_modifier((yyvsp[-2].u.param_list), (yyvsp[0].u.integer));

  (yyval.u.instance) = new CPPInstance(type, ii, 0, (yylsp[-5]).file);
}
#line 4956 "built/tmp/cppBison.yxx.c"
    break;

  case 87: /* $@9: %empty  */
#line 1289 "dtool/src/cppparser/cppBison.yxx"
{
  push_scope((yyvsp[-1].u.identifier)->get_scope(current_scope, global_scope));
}
#line 4964 "built/tmp/cppBison.yxx.c"
    break;

  case 88: /* function_prototype: '~' name '(' $@9 function_parameter_list ')' function_post  */
#line 1293 "dtool/src/cppparser/cppBison.yxx"
{
  pop_scope();
  if ((yyvsp[-5].u.identifier)->is_scoped()) {
    yyerror("Invalid destructor name: ~" + (yyvsp[-5].u.identifier)->get_fully_scoped_name(), (yylsp[-5]));
  } else {
    CPPIdentifier *ident =
      new CPPIdentifier("~" + (yyvsp[-5].u.identifier)->get_simple_name(), (yylsp[-5]));
    delete (yyvsp[-5].u.identifier);

    CPPType *type;
    type = new CPPSimpleType(CPPSimpleType::T_void);

    CPPInstanceIdentifier *ii = new CPPInstanceIdentifier(ident);
    ii->add_func_modifier((yyvsp[-2].u.param_list), (yyvsp[0].u.integer));

    (yyval.u.instance) = new CPPInstance(type, ii, 0, (yylsp[-5]).file);
  }
}
#line 4987 "built/tmp/cppBison.yxx.c"
    break;

  case 89: /* $@10: %empty  */
#line 1319 "dtool/src/cppparser/cppBison.yxx"
{
  push_scope((yyvsp[-2].u.inst_ident)->get_scope(current_scope, global_scope));
}
#line 4995 "built/tmp/cppBison.yxx.c"
    break;

  case 90: /* function_prototype: TYPENAME_IDENTIFIER '(' '*' instance_identifier ')' '(' $@10 function_parameter_list ')' function_post maybe_trailing_return_type  */
#line 1323 "dtool/src/cppparser/cppBison.yxx"
{
  pop_scope();
  CPPType *type = (yyvsp[-10].u.identifier)->find_type(current_scope, global_scope, false, current_lexer);
  if (type == nullptr) {
    yyerror(string("internal error resolving type ") + (yyvsp[-10].u.identifier)->get_fully_scoped_name(), (yylsp[-10]));
  }
  assert(type != nullptr);

  CPPInstanceIdentifier *ii = (yyvsp[-7].u.inst_ident);
  ii->add_modifier(IIT_pointer);
  ii->add_func_modifier((yyvsp[-3].u.param_list), (yyvsp[-1].u.integer));
  (yyval.u.instance) = new CPPInstance(type, ii, 0, (yylsp[-10]).file);
}
#line 5013 "built/tmp/cppBison.yxx.c"
    break;

  case 91: /* $@11: %empty  */
#line 1337 "dtool/src/cppparser/cppBison.yxx"
{
  push_scope((yyvsp[-2].u.inst_ident)->get_scope(current_scope, global_scope));
}
#line 5021 "built/tmp/cppBison.yxx.c"
    break;

  case 92: /* function_prototype: TYPENAME_IDENTIFIER '(' SCOPING '*' instance_identifier ')' '(' $@11 function_parameter_list ')' function_post maybe_trailing_return_type  */
#line 1341 "dtool/src/cppparser/cppBison.yxx"
{
  pop_scope();
  CPPType *type = (yyvsp[-11].u.identifier)->find_type(current_scope, global_scope, false, current_lexer);
  if (type == nullptr) {
    yyerror(string("internal error resolving type ") + (yyvsp[-11].u.identifier)->get_fully_scoped_name(), (yylsp[-11]));
  }
  assert(type != nullptr);

  CPPInstanceIdentifier *ii = (yyvsp[-7].u.inst_ident);
  ii->add_scoped_pointer_modifier((yyvsp[-9].u.identifier));
  ii->add_func_modifier((yyvsp[-3].u.param_list), (yyvsp[-1].u.integer));
  (yyval.u.instance) = new CPPInstance(type, ii, 0, (yylsp[-11]).file);
}
#line 5039 "built/tmp/cppBison.yxx.c"
    break;

  case 93: /* $@12: %empty  */
#line 1357 "dtool/src/cppparser/cppBison.yxx"
{
  if ((yyvsp[-3].u.identifier) != nullptr) {
    push_scope((yyvsp[-3].u.identifier)->get_scope(current_scope, global_scope));
  }
}
#line 5049 "built/tmp/cppBison.yxx.c"
    break;

  case 94: /* function_prototype: KW_OPERATOR type not_paren_formal_parameter_identifier '(' $@12 function_parameter_list ')' function_post  */
#line 1363 "dtool/src/cppparser/cppBison.yxx"
{
  if ((yyvsp[-7].u.identifier) != nullptr) {
    pop_scope();
  }

  // We use formal_parameter_identifier, because that can match a type
  // name with or without an identifier, but especially without, which
  // is what follows the keyword "operator" in a typecast function.
  // As an added bonus, the type of the formal_parameter will be the
  // typecast type, i.e. the return type of the typecast function.

  // We give typecast operators the name "operator typecast <name>",
  // where <name> is a simple name of the type to be typecast.  Use
  // the method's return type to determine the full type description.
  string name = "operator typecast " + (yyvsp[-6].u.type)->get_simple_name();
  CPPIdentifier *ident = (yyvsp[-7].u.identifier);
  if (ident == nullptr) {
    ident = new CPPIdentifier(name, (yylsp[-6]));
  } else {
    ident->add_name(name);
  }
  (yyval.u.instance) = CPPInstance::make_typecast_function
    (new CPPInstance((yyvsp[-6].u.type), (yyvsp[-5].u.inst_ident), 0, (yylsp[-5]).file), ident, (yyvsp[-2].u.param_list), (yyvsp[0].u.integer));
}
#line 5078 "built/tmp/cppBison.yxx.c"
    break;

  case 95: /* $@13: %empty  */
#line 1388 "dtool/src/cppparser/cppBison.yxx"
{
  if ((yyvsp[-4].u.identifier) != nullptr) {
    push_scope((yyvsp[-4].u.identifier)->get_scope(current_scope, global_scope));
  }
}
#line 5088 "built/tmp/cppBison.yxx.c"
    break;

  case 96: /* function_prototype: KW_OPERATOR KW_CONST type not_paren_formal_parameter_identifier '(' $@13 function_parameter_list ')' function_post  */
#line 1394 "dtool/src/cppparser/cppBison.yxx"
{
  if ((yyvsp[-8].u.identifier) != nullptr) {
    pop_scope();
  }

  CPPIdentifier *ident = (yyvsp[-8].u.identifier);
  if (ident == nullptr) {
    ident = new CPPIdentifier("operator typecast", (yylsp[-5]));
  } else {
    ident->add_name("operator typecast");
  }
  (yyvsp[-5].u.inst_ident)->add_modifier(IIT_const);
  (yyval.u.instance) = CPPInstance::make_typecast_function
    (new CPPInstance((yyvsp[-6].u.type), (yyvsp[-5].u.inst_ident), 0, (yylsp[-5]).file), ident, (yyvsp[-2].u.param_list), (yyvsp[0].u.integer));
}
#line 5108 "built/tmp/cppBison.yxx.c"
    break;

  case 97: /* function_prototype: IDENTIFIER  */
#line 1414 "dtool/src/cppparser/cppBison.yxx"
{
  CPPDeclaration *decl =
    (yyvsp[0].u.identifier)->find_symbol(current_scope, global_scope, current_lexer);
  if (decl != nullptr) {
    (yyval.u.instance) = decl->as_instance();
  } else {
    (yyval.u.instance) = nullptr;
  }
}
#line 5122 "built/tmp/cppBison.yxx.c"
    break;

  case 98: /* function_post: empty  */
#line 1427 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.integer) = 0;
}
#line 5130 "built/tmp/cppBison.yxx.c"
    break;

  case 99: /* function_post: function_post KW_CONST  */
#line 1431 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.integer) = (yyvsp[-1].u.integer) | (int)CPPFunctionType::F_const_method;
}
#line 5138 "built/tmp/cppBison.yxx.c"
    break;

  case 100: /* function_post: function_post KW_VOLATILE  */
#line 1435 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.integer) = (yyvsp[-1].u.integer) | (int)CPPFunctionType::F_volatile_method;
}
#line 5146 "built/tmp/cppBison.yxx.c"
    break;

  case 101: /* function_post: function_post KW_NOEXCEPT  */
#line 1439 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.integer) = (yyvsp[-1].u.integer) | (int)CPPFunctionType::F_noexcept;
}
#line 5154 "built/tmp/cppBison.yxx.c"
    break;

  case 102: /* function_post: function_post KW_FINAL  */
#line 1452 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.integer) = (yyvsp[-1].u.integer) | (int)CPPFunctionType::F_final;
}
#line 5162 "built/tmp/cppBison.yxx.c"
    break;

  case 103: /* function_post: function_post KW_OVERRIDE  */
#line 1456 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.integer) = (yyvsp[-1].u.integer) | (int)CPPFunctionType::F_override;
}
#line 5170 "built/tmp/cppBison.yxx.c"
    break;

  case 104: /* function_post: function_post '&'  */
#line 1460 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.integer) = (yyvsp[-1].u.integer) | (int)CPPFunctionType::F_lvalue_method;
}
#line 5178 "built/tmp/cppBison.yxx.c"
    break;

  case 105: /* function_post: function_post ANDAND  */
#line 1464 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.integer) = (yyvsp[-1].u.integer) | (int)CPPFunctionType::F_rvalue_method;
}
#line 5186 "built/tmp/cppBison.yxx.c"
    break;

  case 106: /* function_post: function_post KW_MUTABLE  */
#line 1468 "dtool/src/cppparser/cppBison.yxx"
{
  // Used for lambdas, currently ignored.
  (yyval.u.integer) = (yyvsp[-1].u.integer);
}
#line 5195 "built/tmp/cppBison.yxx.c"
    break;

  case 107: /* function_post: function_post KW_CONSTEXPR  */
#line 1473 "dtool/src/cppparser/cppBison.yxx"
{
  // Used for lambdas in C++17, currently ignored.
  (yyval.u.integer) = (yyvsp[-1].u.integer);
}
#line 5204 "built/tmp/cppBison.yxx.c"
    break;

  case 108: /* function_post: function_post KW_THROW '(' ')'  */
#line 1478 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.integer) = (yyvsp[-3].u.integer);
}
#line 5212 "built/tmp/cppBison.yxx.c"
    break;

  case 109: /* function_post: function_post KW_THROW '(' name ')'  */
#line 1482 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.integer) = (yyvsp[-4].u.integer);
}
#line 5220 "built/tmp/cppBison.yxx.c"
    break;

  case 110: /* function_post: function_post KW_THROW '(' name ELLIPSIS ')'  */
#line 1486 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.integer) = (yyvsp[-5].u.integer);
}
#line 5228 "built/tmp/cppBison.yxx.c"
    break;

  case 111: /* function_post: function_post ATTR_LEFT attribute_specifiers ATTR_RIGHT  */
#line 1490 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.integer) = (yyvsp[-3].u.integer);
}
#line 5236 "built/tmp/cppBison.yxx.c"
    break;

  case 112: /* function_operator: '!'  */
#line 1497 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "!";
}
#line 5244 "built/tmp/cppBison.yxx.c"
    break;

  case 113: /* function_operator: '~'  */
#line 1501 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "~";
}
#line 5252 "built/tmp/cppBison.yxx.c"
    break;

  case 114: /* function_operator: '*'  */
#line 1505 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "*";
}
#line 5260 "built/tmp/cppBison.yxx.c"
    break;

  case 115: /* function_operator: '/'  */
#line 1509 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "/";
}
#line 5268 "built/tmp/cppBison.yxx.c"
    break;

  case 116: /* function_operator: '%'  */
#line 1513 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "%";
}
#line 5276 "built/tmp/cppBison.yxx.c"
    break;

  case 117: /* function_operator: '+'  */
#line 1517 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "+";
}
#line 5284 "built/tmp/cppBison.yxx.c"
    break;

  case 118: /* function_operator: '-'  */
#line 1521 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "-";
}
#line 5292 "built/tmp/cppBison.yxx.c"
    break;

  case 119: /* function_operator: '|'  */
#line 1525 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "|";
}
#line 5300 "built/tmp/cppBison.yxx.c"
    break;

  case 120: /* function_operator: '&'  */
#line 1529 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "&";
}
#line 5308 "built/tmp/cppBison.yxx.c"
    break;

  case 121: /* function_operator: '^'  */
#line 1533 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "^";
}
#line 5316 "built/tmp/cppBison.yxx.c"
    break;

  case 122: /* function_operator: OROR  */
#line 1537 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "||";
}
#line 5324 "built/tmp/cppBison.yxx.c"
    break;

  case 123: /* function_operator: ANDAND  */
#line 1541 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "&&";
}
#line 5332 "built/tmp/cppBison.yxx.c"
    break;

  case 124: /* function_operator: EQCOMPARE  */
#line 1545 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "==";
}
#line 5340 "built/tmp/cppBison.yxx.c"
    break;

  case 125: /* function_operator: NECOMPARE  */
#line 1549 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "!=";
}
#line 5348 "built/tmp/cppBison.yxx.c"
    break;

  case 126: /* function_operator: LECOMPARE  */
#line 1553 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "<=";
}
#line 5356 "built/tmp/cppBison.yxx.c"
    break;

  case 127: /* function_operator: GECOMPARE  */
#line 1557 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = ">=";
}
#line 5364 "built/tmp/cppBison.yxx.c"
    break;

  case 128: /* function_operator: '<'  */
#line 1561 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "<";
}
#line 5372 "built/tmp/cppBison.yxx.c"
    break;

  case 129: /* function_operator: '>'  */
#line 1565 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = ">";
}
#line 5380 "built/tmp/cppBison.yxx.c"
    break;

  case 130: /* function_operator: LSHIFT  */
#line 1569 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "<<";
}
#line 5388 "built/tmp/cppBison.yxx.c"
    break;

  case 131: /* function_operator: RSHIFT  */
#line 1573 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = ">>";
}
#line 5396 "built/tmp/cppBison.yxx.c"
    break;

  case 132: /* function_operator: '='  */
#line 1577 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "=";
}
#line 5404 "built/tmp/cppBison.yxx.c"
    break;

  case 133: /* function_operator: ','  */
#line 1581 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = ",";
}
#line 5412 "built/tmp/cppBison.yxx.c"
    break;

  case 134: /* function_operator: PLUSPLUS  */
#line 1585 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "++";
}
#line 5420 "built/tmp/cppBison.yxx.c"
    break;

  case 135: /* function_operator: MINUSMINUS  */
#line 1589 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "--";
}
#line 5428 "built/tmp/cppBison.yxx.c"
    break;

  case 136: /* function_operator: TIMESEQUAL  */
#line 1593 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "*=";
}
#line 5436 "built/tmp/cppBison.yxx.c"
    break;

  case 137: /* function_operator: DIVIDEEQUAL  */
#line 1597 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "/=";
}
#line 5444 "built/tmp/cppBison.yxx.c"
    break;

  case 138: /* function_operator: MODEQUAL  */
#line 1601 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "%=";
}
#line 5452 "built/tmp/cppBison.yxx.c"
    break;

  case 139: /* function_operator: PLUSEQUAL  */
#line 1605 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "+=";
}
#line 5460 "built/tmp/cppBison.yxx.c"
    break;

  case 140: /* function_operator: MINUSEQUAL  */
#line 1609 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "-=";
}
#line 5468 "built/tmp/cppBison.yxx.c"
    break;

  case 141: /* function_operator: OREQUAL  */
#line 1613 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "|=";
}
#line 5476 "built/tmp/cppBison.yxx.c"
    break;

  case 142: /* function_operator: ANDEQUAL  */
#line 1617 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "&=";
}
#line 5484 "built/tmp/cppBison.yxx.c"
    break;

  case 143: /* function_operator: XOREQUAL  */
#line 1621 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "^=";
}
#line 5492 "built/tmp/cppBison.yxx.c"
    break;

  case 144: /* function_operator: LSHIFTEQUAL  */
#line 1625 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "<<=";
}
#line 5500 "built/tmp/cppBison.yxx.c"
    break;

  case 145: /* function_operator: RSHIFTEQUAL  */
#line 1629 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = ">>=";
}
#line 5508 "built/tmp/cppBison.yxx.c"
    break;

  case 146: /* function_operator: POINTSAT  */
#line 1633 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "->";
}
#line 5516 "built/tmp/cppBison.yxx.c"
    break;

  case 147: /* function_operator: '[' ']'  */
#line 1637 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "[]";
}
#line 5524 "built/tmp/cppBison.yxx.c"
    break;

  case 148: /* function_operator: '(' ')'  */
#line 1641 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "()";
}
#line 5532 "built/tmp/cppBison.yxx.c"
    break;

  case 149: /* function_operator: KW_NEW  */
#line 1645 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "new";
}
#line 5540 "built/tmp/cppBison.yxx.c"
    break;

  case 150: /* function_operator: KW_DELETE  */
#line 1649 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.str) = "delete";
}
#line 5548 "built/tmp/cppBison.yxx.c"
    break;

  case 155: /* $@14: %empty  */
#line 1663 "dtool/src/cppparser/cppBison.yxx"
{
  push_scope(new CPPTemplateScope(current_scope));
}
#line 5556 "built/tmp/cppBison.yxx.c"
    break;

  case 156: /* template_declaration: KW_TEMPLATE $@14 '<' template_formal_parameters '>' more_template_declaration  */
#line 1667 "dtool/src/cppparser/cppBison.yxx"
{
  pop_scope();
}
#line 5564 "built/tmp/cppBison.yxx.c"
    break;

  case 161: /* template_nonempty_formal_parameters: template_formal_parameter  */
#line 1681 "dtool/src/cppparser/cppBison.yxx"
{
  CPPTemplateScope *ts = current_scope->as_template_scope();
  assert(ts != nullptr);
  ts->add_template_parameter((yyvsp[0].u.decl));
}
#line 5574 "built/tmp/cppBison.yxx.c"
    break;

  case 162: /* template_nonempty_formal_parameters: template_nonempty_formal_parameters ',' template_formal_parameter  */
#line 1687 "dtool/src/cppparser/cppBison.yxx"
{
  CPPTemplateScope *ts = current_scope->as_template_scope();
  assert(ts != nullptr);
  ts->add_template_parameter((yyvsp[0].u.decl));
}
#line 5584 "built/tmp/cppBison.yxx.c"
    break;

  case 165: /* template_formal_parameter: typename_keyword  */
#line 1701 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.decl) = CPPType::new_type(new CPPClassTemplateParameter(nullptr));
}
#line 5592 "built/tmp/cppBison.yxx.c"
    break;

  case 166: /* template_formal_parameter: typename_keyword name  */
#line 1705 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.decl) = CPPType::new_type(new CPPClassTemplateParameter((yyvsp[0].u.identifier)));
}
#line 5600 "built/tmp/cppBison.yxx.c"
    break;

  case 167: /* template_formal_parameter: typename_keyword name '=' full_type  */
#line 1709 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.decl) = CPPType::new_type(new CPPClassTemplateParameter((yyvsp[-2].u.identifier), (yyvsp[0].u.type)));
}
#line 5608 "built/tmp/cppBison.yxx.c"
    break;

  case 168: /* template_formal_parameter: typename_keyword ELLIPSIS  */
#line 1713 "dtool/src/cppparser/cppBison.yxx"
{
  CPPClassTemplateParameter *ctp = new CPPClassTemplateParameter(nullptr);
  ctp->_packed = true;
  (yyval.u.decl) = CPPType::new_type(ctp);
}
#line 5618 "built/tmp/cppBison.yxx.c"
    break;

  case 169: /* template_formal_parameter: typename_keyword ELLIPSIS name  */
#line 1719 "dtool/src/cppparser/cppBison.yxx"
{
  CPPClassTemplateParameter *ctp = new CPPClassTemplateParameter((yyvsp[0].u.identifier));
  ctp->_packed = true;
  (yyval.u.decl) = CPPType::new_type(ctp);
}
#line 5628 "built/tmp/cppBison.yxx.c"
    break;

  case 170: /* template_formal_parameter: template_formal_parameter_type formal_parameter_identifier template_parameter_maybe_initialize  */
#line 1725 "dtool/src/cppparser/cppBison.yxx"
{
  CPPInstance *inst = new CPPInstance((yyvsp[-2].u.type), (yyvsp[-1].u.inst_ident), 0, (yylsp[-1]).file);
  inst->set_initializer((yyvsp[0].u.expr));
  (yyval.u.decl) = inst;
}
#line 5638 "built/tmp/cppBison.yxx.c"
    break;

  case 171: /* template_formal_parameter: KW_CONST template_formal_parameter_type formal_parameter_identifier template_parameter_maybe_initialize  */
#line 1731 "dtool/src/cppparser/cppBison.yxx"
{
  (yyvsp[-1].u.inst_ident)->add_modifier(IIT_const);
  CPPInstance *inst = new CPPInstance((yyvsp[-2].u.type), (yyvsp[-1].u.inst_ident), 0, (yylsp[-1]).file);
  inst->set_initializer((yyvsp[0].u.expr));
  (yyval.u.decl) = inst;
}
#line 5649 "built/tmp/cppBison.yxx.c"
    break;

  case 172: /* template_formal_parameter: template_formal_parameter_type parameter_pack_identifier  */
#line 1738 "dtool/src/cppparser/cppBison.yxx"
{
  CPPInstance *inst = new CPPInstance((yyvsp[-1].u.type), (yyvsp[0].u.inst_ident), 0, (yylsp[0]).file);
  (yyval.u.decl) = inst;
}
#line 5658 "built/tmp/cppBison.yxx.c"
    break;

  case 173: /* template_formal_parameter: KW_CONST template_formal_parameter_type parameter_pack_identifier  */
#line 1743 "dtool/src/cppparser/cppBison.yxx"
{
  (yyvsp[0].u.inst_ident)->add_modifier(IIT_const);
  CPPInstance *inst = new CPPInstance((yyvsp[-1].u.type), (yyvsp[0].u.inst_ident), 0, (yylsp[0]).file);
  (yyval.u.decl) = inst;
}
#line 5668 "built/tmp/cppBison.yxx.c"
    break;

  case 174: /* template_formal_parameter_type: simple_type  */
#line 1752 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.type) = CPPType::new_type((yyvsp[0].u.simple_type));
}
#line 5676 "built/tmp/cppBison.yxx.c"
    break;

  case 175: /* template_formal_parameter_type: IDENTIFIER  */
#line 1756 "dtool/src/cppparser/cppBison.yxx"
{
  yywarning("Not a type: " + (yyvsp[0].u.identifier)->get_fully_scoped_name(), (yylsp[0]));
  (yyval.u.type) = CPPType::new_type(new CPPSimpleType(CPPSimpleType::T_unknown));
}
#line 5685 "built/tmp/cppBison.yxx.c"
    break;

  case 176: /* template_formal_parameter_type: TYPENAME_IDENTIFIER  */
#line 1761 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.type) = (yyvsp[0].u.identifier)->find_type(current_scope, global_scope, false, current_lexer);
  if ((yyval.u.type) == nullptr) {
    yyerror(string("internal error resolving type ") + (yyvsp[0].u.identifier)->get_fully_scoped_name(), (yylsp[0]));
  }
  assert((yyval.u.type) != nullptr);
}
#line 5697 "built/tmp/cppBison.yxx.c"
    break;

  case 177: /* template_formal_parameter_type: TYPEPACK_IDENTIFIER  */
#line 1769 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.type) = (yyvsp[0].u.identifier)->find_type(current_scope, global_scope, false, current_lexer);
  if ((yyval.u.type) == nullptr) {
    yyerror(string("internal error resolving type ") + (yyvsp[0].u.identifier)->get_fully_scoped_name(), (yylsp[0]));
  }
  assert((yyval.u.type) != nullptr);
}
#line 5709 "built/tmp/cppBison.yxx.c"
    break;

  case 178: /* instance_identifier: name_no_final  */
#line 1781 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = new CPPInstanceIdentifier((yyvsp[0].u.identifier));
}
#line 5717 "built/tmp/cppBison.yxx.c"
    break;

  case 179: /* instance_identifier: KW_OPERATOR function_operator  */
#line 1785 "dtool/src/cppparser/cppBison.yxx"
{
  // For an operator function.  We implement this simply by building a
  // ficticious name for the function; in other respects it's just
  // like a regular function.
  CPPIdentifier *ident = (yyvsp[-1].u.identifier);
  if (ident == nullptr) {
    ident = new CPPIdentifier("operator "+(yyvsp[0].str), (yylsp[0]));
  } else {
    ident->_names.push_back("operator "+(yyvsp[0].str));
  }

  (yyval.u.inst_ident) = new CPPInstanceIdentifier(ident);
}
#line 5735 "built/tmp/cppBison.yxx.c"
    break;

  case 180: /* instance_identifier: KW_OPERATOR SIMPLE_STRING IDENTIFIER  */
#line 1799 "dtool/src/cppparser/cppBison.yxx"
{
  // A C++11 literal operator.
  if (!(yyvsp[-1].str).empty()) {
    yyerror("expected empty string", (yylsp[-1]));
  }
  CPPIdentifier *ident = (yyvsp[-2].u.identifier);
  if (ident == nullptr) {
    ident = new CPPIdentifier("operator \"\" "+(yyvsp[0].u.identifier)->get_simple_name(), (yylsp[0]));
  } else {
    ident->_names.push_back("operator \"\" "+(yyvsp[0].u.identifier)->get_simple_name());
  }

  (yyval.u.inst_ident) = new CPPInstanceIdentifier(ident);
}
#line 5754 "built/tmp/cppBison.yxx.c"
    break;

  case 181: /* instance_identifier: KW_CONST instance_identifier  */
#line 1814 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_const);
}
#line 5763 "built/tmp/cppBison.yxx.c"
    break;

  case 182: /* instance_identifier: KW_VOLATILE instance_identifier  */
#line 1819 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_volatile);
}
#line 5772 "built/tmp/cppBison.yxx.c"
    break;

  case 183: /* instance_identifier: '*' instance_identifier  */
#line 1824 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_pointer);
}
#line 5781 "built/tmp/cppBison.yxx.c"
    break;

  case 184: /* instance_identifier: '&' instance_identifier  */
#line 1829 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_reference);
}
#line 5790 "built/tmp/cppBison.yxx.c"
    break;

  case 185: /* instance_identifier: ANDAND instance_identifier  */
#line 1834 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_rvalue_reference);
}
#line 5799 "built/tmp/cppBison.yxx.c"
    break;

  case 186: /* instance_identifier: SCOPING '*' instance_identifier  */
#line 1839 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_scoped_pointer_modifier((yyvsp[-2].u.identifier));
}
#line 5808 "built/tmp/cppBison.yxx.c"
    break;

  case 187: /* instance_identifier: instance_identifier '[' optional_const_expr ']'  */
#line 1844 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[-3].u.inst_ident);
  (yyval.u.inst_ident)->add_array_modifier((yyvsp[-1].u.expr));
}
#line 5817 "built/tmp/cppBison.yxx.c"
    break;

  case 188: /* instance_identifier: '(' instance_identifier ')'  */
#line 1849 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[-1].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_paren);
}
#line 5826 "built/tmp/cppBison.yxx.c"
    break;

  case 189: /* $@15: %empty  */
#line 1854 "dtool/src/cppparser/cppBison.yxx"
{
  // Create a scope for this function (in case it is a function)
  CPPScope *scope = new CPPScope((yyvsp[-1].u.inst_ident)->get_scope(current_scope, global_scope),
                                 CPPNameComponent(""), V_private);

  // It still needs to be able to pick up any template arguments, if this is
  // a definition for a method template.  Add a fake "using" declaration to
  // accomplish this.
  scope->_using.insert(current_scope);

  push_scope(scope);
}
#line 5843 "built/tmp/cppBison.yxx.c"
    break;

  case 190: /* instance_identifier: instance_identifier '(' $@15 formal_parameter_list ')' function_post  */
#line 1867 "dtool/src/cppparser/cppBison.yxx"
{
  pop_scope();
  (yyval.u.inst_ident) = (yyvsp[-5].u.inst_ident);
  if ((yyvsp[-2].u.param_list)->is_parameter_expr() && (yyvsp[0].u.integer) == 0) {
    // Oops, this must have been an instance declaration with a
    // parameter list, not a function prototype.
    (yyval.u.inst_ident)->add_initializer_modifier((yyvsp[-2].u.param_list));

  } else {
    // This was (probably) a function prototype.
    (yyval.u.inst_ident)->add_func_modifier((yyvsp[-2].u.param_list), (yyvsp[0].u.integer));
  }
}
#line 5861 "built/tmp/cppBison.yxx.c"
    break;

  case 191: /* instance_identifier_and_maybe_trailing_return_type: instance_identifier maybe_trailing_return_type  */
#line 1885 "dtool/src/cppparser/cppBison.yxx"
{
  // This is handled a bit awkwardly right now.  Ideally it'd be wrapped
  // up in the instance_identifier rule, but then more needs to happen in
  // order to avoid shift/reduce conflicts.
  if ((yyvsp[0].u.type) != nullptr) {
    (yyvsp[-1].u.inst_ident)->add_trailing_return_type((yyvsp[0].u.type));
  }
  (yyval.u.inst_ident) = (yyvsp[-1].u.inst_ident);
}
#line 5875 "built/tmp/cppBison.yxx.c"
    break;

  case 192: /* instance_identifier_and_maybe_trailing_return_type: instance_identifier ':' const_expr  */
#line 1895 "dtool/src/cppparser/cppBison.yxx"
{
  // Bitfield definition.
  (yyvsp[-2].u.inst_ident)->_bit_width = (yyvsp[0].u.expr);
  (yyval.u.inst_ident) = (yyvsp[-2].u.inst_ident);
}
#line 5885 "built/tmp/cppBison.yxx.c"
    break;

  case 193: /* maybe_trailing_return_type: empty  */
#line 1905 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.type) = nullptr;
}
#line 5893 "built/tmp/cppBison.yxx.c"
    break;

  case 194: /* maybe_trailing_return_type: POINTSAT predefined_type empty_instance_identifier  */
#line 1909 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.type) = (yyvsp[0].u.inst_ident)->unroll_type((yyvsp[-1].u.type));
}
#line 5901 "built/tmp/cppBison.yxx.c"
    break;

  case 195: /* maybe_trailing_return_type: POINTSAT KW_CONST predefined_type empty_instance_identifier  */
#line 1913 "dtool/src/cppparser/cppBison.yxx"
{
  (yyvsp[0].u.inst_ident)->add_modifier(IIT_const);
  (yyval.u.type) = (yyvsp[0].u.inst_ident)->unroll_type((yyvsp[-1].u.type));
}
#line 5910 "built/tmp/cppBison.yxx.c"
    break;

  case 196: /* maybe_comma_identifier: empty  */
#line 1922 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.identifier) = nullptr;
}
#line 5918 "built/tmp/cppBison.yxx.c"
    break;

  case 197: /* maybe_comma_identifier: ',' IDENTIFIER  */
#line 1926 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.identifier) = (yyvsp[0].u.identifier);
}
#line 5926 "built/tmp/cppBison.yxx.c"
    break;

  case 198: /* function_parameter_list: empty  */
#line 1934 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.param_list) = new CPPParameterList;
}
#line 5934 "built/tmp/cppBison.yxx.c"
    break;

  case 199: /* function_parameter_list: ELLIPSIS  */
#line 1938 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.param_list) = new CPPParameterList;
  (yyval.u.param_list)->_includes_ellipsis = true;
}
#line 5943 "built/tmp/cppBison.yxx.c"
    break;

  case 200: /* function_parameter_list: function_parameters  */
#line 1943 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.param_list) = (yyvsp[0].u.param_list);
}
#line 5951 "built/tmp/cppBison.yxx.c"
    break;

  case 201: /* function_parameter_list: function_parameters ',' ELLIPSIS  */
#line 1947 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.param_list) = (yyvsp[-2].u.param_list);
  (yyval.u.param_list)->_includes_ellipsis = true;
}
#line 5960 "built/tmp/cppBison.yxx.c"
    break;

  case 202: /* function_parameter_list: function_parameters ELLIPSIS  */
#line 1952 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.param_list) = (yyvsp[-1].u.param_list);
  (yyval.u.param_list)->_includes_ellipsis = true;
}
#line 5969 "built/tmp/cppBison.yxx.c"
    break;

  case 203: /* function_parameters: function_parameter  */
#line 1960 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.param_list) = new CPPParameterList;
  (yyval.u.param_list)->_parameters.push_back((yyvsp[0].u.instance));
}
#line 5978 "built/tmp/cppBison.yxx.c"
    break;

  case 204: /* function_parameters: function_parameters ',' function_parameter  */
#line 1965 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.param_list) = (yyvsp[-2].u.param_list);
  (yyval.u.param_list)->_parameters.push_back((yyvsp[0].u.instance));
}
#line 5987 "built/tmp/cppBison.yxx.c"
    break;

  case 205: /* formal_parameter_list: empty  */
#line 1973 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.param_list) = new CPPParameterList;
}
#line 5995 "built/tmp/cppBison.yxx.c"
    break;

  case 206: /* formal_parameter_list: ELLIPSIS  */
#line 1977 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.param_list) = new CPPParameterList;
  (yyval.u.param_list)->_includes_ellipsis = true;
}
#line 6004 "built/tmp/cppBison.yxx.c"
    break;

  case 207: /* formal_parameter_list: formal_parameters  */
#line 1982 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.param_list) = (yyvsp[0].u.param_list);
}
#line 6012 "built/tmp/cppBison.yxx.c"
    break;

  case 208: /* formal_parameter_list: formal_parameters ',' ELLIPSIS  */
#line 1986 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.param_list) = (yyvsp[-2].u.param_list);
  (yyval.u.param_list)->_includes_ellipsis = true;
}
#line 6021 "built/tmp/cppBison.yxx.c"
    break;

  case 209: /* formal_parameter_list: formal_parameters ELLIPSIS  */
#line 1991 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.param_list) = (yyvsp[-1].u.param_list);
  (yyval.u.param_list)->_includes_ellipsis = true;
}
#line 6030 "built/tmp/cppBison.yxx.c"
    break;

  case 210: /* formal_parameters: formal_parameter  */
#line 1999 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.param_list) = new CPPParameterList;
  (yyval.u.param_list)->_parameters.push_back((yyvsp[0].u.instance));
}
#line 6039 "built/tmp/cppBison.yxx.c"
    break;

  case 211: /* formal_parameters: formal_parameters ',' formal_parameter  */
#line 2004 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.param_list) = (yyvsp[-2].u.param_list);
  (yyval.u.param_list)->_parameters.push_back((yyvsp[0].u.instance));
}
#line 6048 "built/tmp/cppBison.yxx.c"
    break;

  case 212: /* template_parameter_maybe_initialize: empty  */
#line 2012 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = nullptr;
}
#line 6056 "built/tmp/cppBison.yxx.c"
    break;

  case 213: /* template_parameter_maybe_initialize: '=' no_angle_bracket_const_expr  */
#line 2016 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = (yyvsp[0].u.expr);
}
#line 6064 "built/tmp/cppBison.yxx.c"
    break;

  case 214: /* maybe_initialize: empty  */
#line 2023 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = nullptr;
}
#line 6072 "built/tmp/cppBison.yxx.c"
    break;

  case 215: /* maybe_initialize: '=' const_expr  */
#line 2027 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = (yyvsp[0].u.expr);
}
#line 6080 "built/tmp/cppBison.yxx.c"
    break;

  case 216: /* maybe_initialize_or_constructor_body: ';'  */
#line 2034 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = nullptr;
}
#line 6088 "built/tmp/cppBison.yxx.c"
    break;

  case 217: /* maybe_initialize_or_constructor_body: '{' code '}'  */
#line 2038 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = nullptr;
}
#line 6096 "built/tmp/cppBison.yxx.c"
    break;

  case 218: /* maybe_initialize_or_constructor_body: ':' constructor_inits '{' code '}'  */
#line 2042 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = nullptr;
}
#line 6104 "built/tmp/cppBison.yxx.c"
    break;

  case 219: /* maybe_initialize_or_constructor_body: '=' KW_DEFAULT ';'  */
#line 2046 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::get_default());
}
#line 6112 "built/tmp/cppBison.yxx.c"
    break;

  case 220: /* maybe_initialize_or_constructor_body: '=' KW_DELETE ';'  */
#line 2050 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::get_delete());
}
#line 6120 "built/tmp/cppBison.yxx.c"
    break;

  case 221: /* maybe_initialize_or_function_body: ';'  */
#line 2057 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = nullptr;
}
#line 6128 "built/tmp/cppBison.yxx.c"
    break;

  case 222: /* maybe_initialize_or_function_body: '{' code '}'  */
#line 2061 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = nullptr;
}
#line 6136 "built/tmp/cppBison.yxx.c"
    break;

  case 223: /* maybe_initialize_or_function_body: '=' const_expr ';'  */
#line 2065 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = (yyvsp[-1].u.expr);
}
#line 6144 "built/tmp/cppBison.yxx.c"
    break;

  case 224: /* maybe_initialize_or_function_body: '=' KW_DEFAULT ';'  */
#line 2069 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::get_default());
}
#line 6152 "built/tmp/cppBison.yxx.c"
    break;

  case 225: /* maybe_initialize_or_function_body: '=' KW_DELETE ';'  */
#line 2073 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::get_delete());
}
#line 6160 "built/tmp/cppBison.yxx.c"
    break;

  case 226: /* maybe_initialize_or_function_body: '=' '{' structure_init '}'  */
#line 2077 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = nullptr;
}
#line 6168 "built/tmp/cppBison.yxx.c"
    break;

  case 230: /* structure_init_body: const_expr  */
#line 2090 "dtool/src/cppparser/cppBison.yxx"
{
}
#line 6175 "built/tmp/cppBison.yxx.c"
    break;

  case 234: /* function_parameter: type formal_parameter_identifier maybe_initialize  */
#line 2099 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.instance) = new CPPInstance((yyvsp[-2].u.type), (yyvsp[-1].u.inst_ident), 0, (yylsp[-1]).file);
  (yyval.u.instance)->set_initializer((yyvsp[0].u.expr));
}
#line 6184 "built/tmp/cppBison.yxx.c"
    break;

  case 235: /* function_parameter: KW_CONST type formal_parameter_identifier maybe_initialize  */
#line 2104 "dtool/src/cppparser/cppBison.yxx"
{
  (yyvsp[-1].u.inst_ident)->add_modifier(IIT_const);
  (yyval.u.instance) = new CPPInstance((yyvsp[-2].u.type), (yyvsp[-1].u.inst_ident), 0, (yylsp[-1]).file);
  (yyval.u.instance)->set_initializer((yyvsp[0].u.expr));
}
#line 6194 "built/tmp/cppBison.yxx.c"
    break;

  case 236: /* function_parameter: KW_CONST KW_REGISTER type formal_parameter_identifier maybe_initialize  */
#line 2110 "dtool/src/cppparser/cppBison.yxx"
{
  (yyvsp[-1].u.inst_ident)->add_modifier(IIT_const);
  (yyval.u.instance) = new CPPInstance((yyvsp[-2].u.type), (yyvsp[-1].u.inst_ident), 0, (yylsp[-2]).file);
  (yyval.u.instance)->set_initializer((yyvsp[0].u.expr));
}
#line 6204 "built/tmp/cppBison.yxx.c"
    break;

  case 237: /* function_parameter: type_pack parameter_pack_identifier maybe_initialize  */
#line 2116 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.instance) = new CPPInstance((yyvsp[-2].u.type), (yyvsp[-1].u.inst_ident), 0, (yylsp[-1]).file);
  (yyval.u.instance)->set_initializer((yyvsp[0].u.expr));
}
#line 6213 "built/tmp/cppBison.yxx.c"
    break;

  case 238: /* function_parameter: KW_CONST type_pack parameter_pack_identifier maybe_initialize  */
#line 2121 "dtool/src/cppparser/cppBison.yxx"
{
  (yyvsp[-1].u.inst_ident)->add_modifier(IIT_const);
  (yyval.u.instance) = new CPPInstance((yyvsp[-2].u.type), (yyvsp[-1].u.inst_ident), 0, (yylsp[-1]).file);
  (yyval.u.instance)->set_initializer((yyvsp[0].u.expr));
}
#line 6223 "built/tmp/cppBison.yxx.c"
    break;

  case 239: /* function_parameter: KW_CONST KW_REGISTER type_pack parameter_pack_identifier maybe_initialize  */
#line 2127 "dtool/src/cppparser/cppBison.yxx"
{
  (yyvsp[-1].u.inst_ident)->add_modifier(IIT_const);
  (yyval.u.instance) = new CPPInstance((yyvsp[-2].u.type), (yyvsp[-1].u.inst_ident), 0, (yylsp[-2]).file);
  (yyval.u.instance)->set_initializer((yyvsp[0].u.expr));
}
#line 6233 "built/tmp/cppBison.yxx.c"
    break;

  case 240: /* function_parameter: KW_REGISTER function_parameter  */
#line 2133 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.instance) = (yyvsp[0].u.instance);
}
#line 6241 "built/tmp/cppBison.yxx.c"
    break;

  case 241: /* function_parameter: ATTR_LEFT attribute_specifiers ATTR_RIGHT function_parameter  */
#line 2137 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.instance) = (yyvsp[0].u.instance);
}
#line 6249 "built/tmp/cppBison.yxx.c"
    break;

  case 242: /* formal_parameter: function_parameter  */
#line 2148 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.instance) = (yyvsp[0].u.instance);
}
#line 6257 "built/tmp/cppBison.yxx.c"
    break;

  case 243: /* formal_parameter: formal_const_expr  */
#line 2152 "dtool/src/cppparser/cppBison.yxx"
{
  CPPType *type =
    CPPType::new_type(new CPPSimpleType(CPPSimpleType::T_parameter));
  (yyval.u.instance) = new CPPInstance(type, "expr");
  (yyval.u.instance)->set_initializer((yyvsp[0].u.expr));
}
#line 6268 "built/tmp/cppBison.yxx.c"
    break;

  case 244: /* not_paren_formal_parameter_identifier: empty  */
#line 2162 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = new CPPInstanceIdentifier(nullptr);
}
#line 6276 "built/tmp/cppBison.yxx.c"
    break;

  case 245: /* not_paren_formal_parameter_identifier: name_no_final  */
#line 2166 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = new CPPInstanceIdentifier((yyvsp[0].u.identifier));
}
#line 6284 "built/tmp/cppBison.yxx.c"
    break;

  case 246: /* not_paren_formal_parameter_identifier: KW_CONST not_paren_formal_parameter_identifier  */
#line 2170 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_const);
}
#line 6293 "built/tmp/cppBison.yxx.c"
    break;

  case 247: /* not_paren_formal_parameter_identifier: KW_VOLATILE not_paren_formal_parameter_identifier  */
#line 2175 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_volatile);
}
#line 6302 "built/tmp/cppBison.yxx.c"
    break;

  case 248: /* not_paren_formal_parameter_identifier: '*' not_paren_formal_parameter_identifier  */
#line 2180 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_pointer);
}
#line 6311 "built/tmp/cppBison.yxx.c"
    break;

  case 249: /* not_paren_formal_parameter_identifier: '&' not_paren_formal_parameter_identifier  */
#line 2185 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_reference);
}
#line 6320 "built/tmp/cppBison.yxx.c"
    break;

  case 250: /* not_paren_formal_parameter_identifier: ANDAND not_paren_formal_parameter_identifier  */
#line 2190 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_rvalue_reference);
}
#line 6329 "built/tmp/cppBison.yxx.c"
    break;

  case 251: /* not_paren_formal_parameter_identifier: SCOPING '*' not_paren_formal_parameter_identifier  */
#line 2195 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_scoped_pointer_modifier((yyvsp[-2].u.identifier));
}
#line 6338 "built/tmp/cppBison.yxx.c"
    break;

  case 252: /* not_paren_formal_parameter_identifier: not_paren_formal_parameter_identifier '[' optional_const_expr ']'  */
#line 2200 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[-3].u.inst_ident);
  (yyval.u.inst_ident)->add_array_modifier((yyvsp[-1].u.expr));
}
#line 6347 "built/tmp/cppBison.yxx.c"
    break;

  case 253: /* formal_parameter_identifier: empty  */
#line 2208 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = new CPPInstanceIdentifier(nullptr);
}
#line 6355 "built/tmp/cppBison.yxx.c"
    break;

  case 254: /* formal_parameter_identifier: name_no_final  */
#line 2212 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = new CPPInstanceIdentifier((yyvsp[0].u.identifier));
}
#line 6363 "built/tmp/cppBison.yxx.c"
    break;

  case 255: /* formal_parameter_identifier: KW_CONST formal_parameter_identifier  */
#line 2216 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_const);
}
#line 6372 "built/tmp/cppBison.yxx.c"
    break;

  case 256: /* formal_parameter_identifier: KW_VOLATILE formal_parameter_identifier  */
#line 2221 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_volatile);
}
#line 6381 "built/tmp/cppBison.yxx.c"
    break;

  case 257: /* formal_parameter_identifier: '*' formal_parameter_identifier  */
#line 2226 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_pointer);
}
#line 6390 "built/tmp/cppBison.yxx.c"
    break;

  case 258: /* formal_parameter_identifier: '&' formal_parameter_identifier  */
#line 2231 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_reference);
}
#line 6399 "built/tmp/cppBison.yxx.c"
    break;

  case 259: /* formal_parameter_identifier: ANDAND formal_parameter_identifier  */
#line 2236 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_rvalue_reference);
}
#line 6408 "built/tmp/cppBison.yxx.c"
    break;

  case 260: /* formal_parameter_identifier: SCOPING '*' formal_parameter_identifier  */
#line 2241 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_scoped_pointer_modifier((yyvsp[-2].u.identifier));
}
#line 6417 "built/tmp/cppBison.yxx.c"
    break;

  case 261: /* formal_parameter_identifier: formal_parameter_identifier '[' optional_const_expr ']'  */
#line 2246 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[-3].u.inst_ident);
  (yyval.u.inst_ident)->add_array_modifier((yyvsp[-1].u.expr));
}
#line 6426 "built/tmp/cppBison.yxx.c"
    break;

  case 262: /* formal_parameter_identifier: '(' formal_parameter_identifier ')' '(' function_parameter_list ')' function_post  */
#line 2251 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[-5].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_paren);
  (yyval.u.inst_ident)->add_func_modifier((yyvsp[-2].u.param_list), (yyvsp[0].u.integer));
}
#line 6436 "built/tmp/cppBison.yxx.c"
    break;

  case 263: /* formal_parameter_identifier: '(' formal_parameter_identifier ')'  */
#line 2257 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[-1].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_paren);
}
#line 6445 "built/tmp/cppBison.yxx.c"
    break;

  case 264: /* parameter_pack_identifier: ELLIPSIS  */
#line 2265 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = new CPPInstanceIdentifier(nullptr);
  (yyval.u.inst_ident)->_packed = true;
}
#line 6454 "built/tmp/cppBison.yxx.c"
    break;

  case 265: /* parameter_pack_identifier: ELLIPSIS name  */
#line 2270 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = new CPPInstanceIdentifier((yyvsp[0].u.identifier));
  (yyval.u.inst_ident)->_packed = true;
}
#line 6463 "built/tmp/cppBison.yxx.c"
    break;

  case 266: /* parameter_pack_identifier: KW_CONST parameter_pack_identifier  */
#line 2275 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_const);
}
#line 6472 "built/tmp/cppBison.yxx.c"
    break;

  case 267: /* parameter_pack_identifier: KW_VOLATILE parameter_pack_identifier  */
#line 2280 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_volatile);
}
#line 6481 "built/tmp/cppBison.yxx.c"
    break;

  case 268: /* parameter_pack_identifier: '*' parameter_pack_identifier  */
#line 2285 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_pointer);
}
#line 6490 "built/tmp/cppBison.yxx.c"
    break;

  case 269: /* parameter_pack_identifier: '&' parameter_pack_identifier  */
#line 2290 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_reference);
}
#line 6499 "built/tmp/cppBison.yxx.c"
    break;

  case 270: /* parameter_pack_identifier: ANDAND parameter_pack_identifier  */
#line 2295 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_rvalue_reference);
}
#line 6508 "built/tmp/cppBison.yxx.c"
    break;

  case 271: /* parameter_pack_identifier: SCOPING '*' parameter_pack_identifier  */
#line 2300 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_scoped_pointer_modifier((yyvsp[-2].u.identifier));
}
#line 6517 "built/tmp/cppBison.yxx.c"
    break;

  case 272: /* parameter_pack_identifier: parameter_pack_identifier '[' optional_const_expr ']'  */
#line 2305 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[-3].u.inst_ident);
  (yyval.u.inst_ident)->add_array_modifier((yyvsp[-1].u.expr));
}
#line 6526 "built/tmp/cppBison.yxx.c"
    break;

  case 273: /* parameter_pack_identifier: '(' parameter_pack_identifier ')' '(' function_parameter_list ')' function_post  */
#line 2310 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[-5].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_paren);
  (yyval.u.inst_ident)->add_func_modifier((yyvsp[-2].u.param_list), (yyvsp[0].u.integer));
}
#line 6536 "built/tmp/cppBison.yxx.c"
    break;

  case 274: /* parameter_pack_identifier: '(' parameter_pack_identifier ')'  */
#line 2316 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[-1].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_paren);
}
#line 6545 "built/tmp/cppBison.yxx.c"
    break;

  case 275: /* not_paren_empty_instance_identifier: empty  */
#line 2324 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = new CPPInstanceIdentifier(nullptr);
}
#line 6553 "built/tmp/cppBison.yxx.c"
    break;

  case 276: /* not_paren_empty_instance_identifier: ELLIPSIS  */
#line 2328 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = new CPPInstanceIdentifier(nullptr);
  (yyval.u.inst_ident)->_packed = true;
}
#line 6562 "built/tmp/cppBison.yxx.c"
    break;

  case 277: /* not_paren_empty_instance_identifier: ELLIPSIS name  */
#line 2333 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = new CPPInstanceIdentifier((yyvsp[0].u.identifier));
  (yyval.u.inst_ident)->_packed = true;
}
#line 6571 "built/tmp/cppBison.yxx.c"
    break;

  case 278: /* not_paren_empty_instance_identifier: KW_CONST not_paren_empty_instance_identifier  */
#line 2338 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_const);
}
#line 6580 "built/tmp/cppBison.yxx.c"
    break;

  case 279: /* not_paren_empty_instance_identifier: KW_VOLATILE not_paren_empty_instance_identifier  */
#line 2343 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_volatile);
}
#line 6589 "built/tmp/cppBison.yxx.c"
    break;

  case 280: /* not_paren_empty_instance_identifier: '*' not_paren_empty_instance_identifier  */
#line 2348 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_pointer);
}
#line 6598 "built/tmp/cppBison.yxx.c"
    break;

  case 281: /* not_paren_empty_instance_identifier: '&' not_paren_empty_instance_identifier  */
#line 2353 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_reference);
}
#line 6607 "built/tmp/cppBison.yxx.c"
    break;

  case 282: /* not_paren_empty_instance_identifier: ANDAND not_paren_empty_instance_identifier  */
#line 2358 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_rvalue_reference);
}
#line 6616 "built/tmp/cppBison.yxx.c"
    break;

  case 283: /* not_paren_empty_instance_identifier: SCOPING '*' not_paren_empty_instance_identifier  */
#line 2363 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_scoped_pointer_modifier((yyvsp[-2].u.identifier));
}
#line 6625 "built/tmp/cppBison.yxx.c"
    break;

  case 284: /* not_paren_empty_instance_identifier: not_paren_empty_instance_identifier '[' optional_const_expr ']'  */
#line 2368 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[-3].u.inst_ident);
  (yyval.u.inst_ident)->add_array_modifier((yyvsp[-1].u.expr));
}
#line 6634 "built/tmp/cppBison.yxx.c"
    break;

  case 285: /* empty_instance_identifier: empty  */
#line 2376 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = new CPPInstanceIdentifier(nullptr);
}
#line 6642 "built/tmp/cppBison.yxx.c"
    break;

  case 286: /* empty_instance_identifier: ELLIPSIS  */
#line 2380 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = new CPPInstanceIdentifier(nullptr);
  (yyval.u.inst_ident)->_packed = true;
}
#line 6651 "built/tmp/cppBison.yxx.c"
    break;

  case 287: /* empty_instance_identifier: ELLIPSIS name  */
#line 2385 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = new CPPInstanceIdentifier((yyvsp[0].u.identifier));
  (yyval.u.inst_ident)->_packed = true;
}
#line 6660 "built/tmp/cppBison.yxx.c"
    break;

  case 288: /* empty_instance_identifier: KW_CONST empty_instance_identifier  */
#line 2390 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_const);
}
#line 6669 "built/tmp/cppBison.yxx.c"
    break;

  case 289: /* empty_instance_identifier: KW_VOLATILE empty_instance_identifier  */
#line 2395 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_volatile);
}
#line 6678 "built/tmp/cppBison.yxx.c"
    break;

  case 290: /* empty_instance_identifier: '*' not_paren_empty_instance_identifier  */
#line 2400 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_pointer);
}
#line 6687 "built/tmp/cppBison.yxx.c"
    break;

  case 291: /* empty_instance_identifier: '&' not_paren_empty_instance_identifier  */
#line 2405 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_reference);
}
#line 6696 "built/tmp/cppBison.yxx.c"
    break;

  case 292: /* empty_instance_identifier: ANDAND not_paren_empty_instance_identifier  */
#line 2410 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_rvalue_reference);
}
#line 6705 "built/tmp/cppBison.yxx.c"
    break;

  case 293: /* empty_instance_identifier: SCOPING '*' not_paren_empty_instance_identifier  */
#line 2415 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[0].u.inst_ident);
  (yyval.u.inst_ident)->add_scoped_pointer_modifier((yyvsp[-2].u.identifier));
}
#line 6714 "built/tmp/cppBison.yxx.c"
    break;

  case 294: /* empty_instance_identifier: not_paren_empty_instance_identifier '[' optional_const_expr ']'  */
#line 2420 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[-3].u.inst_ident);
  (yyval.u.inst_ident)->add_array_modifier((yyvsp[-1].u.expr));
}
#line 6723 "built/tmp/cppBison.yxx.c"
    break;

  case 295: /* empty_instance_identifier: '(' function_parameter_list ')' function_post maybe_trailing_return_type  */
#line 2425 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = new CPPInstanceIdentifier(nullptr);
  (yyval.u.inst_ident)->add_modifier(IIT_paren);
  (yyval.u.inst_ident)->add_func_modifier((yyvsp[-3].u.param_list), (yyvsp[-1].u.integer), (yyvsp[0].u.type));
}
#line 6733 "built/tmp/cppBison.yxx.c"
    break;

  case 296: /* empty_instance_identifier: '(' '*' not_paren_empty_instance_identifier ')' '(' function_parameter_list ')' function_post maybe_trailing_return_type  */
#line 2431 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[-6].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_pointer);
  (yyval.u.inst_ident)->add_modifier(IIT_paren);
  (yyval.u.inst_ident)->add_func_modifier((yyvsp[-3].u.param_list), (yyvsp[-1].u.integer), (yyvsp[0].u.type));
}
#line 6744 "built/tmp/cppBison.yxx.c"
    break;

  case 297: /* empty_instance_identifier: '(' '&' not_paren_empty_instance_identifier ')' '(' function_parameter_list ')' function_post maybe_trailing_return_type  */
#line 2438 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[-6].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_reference);
  (yyval.u.inst_ident)->add_modifier(IIT_paren);
  (yyval.u.inst_ident)->add_func_modifier((yyvsp[-3].u.param_list), (yyvsp[-1].u.integer), (yyvsp[0].u.type));
}
#line 6755 "built/tmp/cppBison.yxx.c"
    break;

  case 298: /* empty_instance_identifier: '(' ANDAND not_paren_empty_instance_identifier ')' '(' function_parameter_list ')' function_post maybe_trailing_return_type  */
#line 2445 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.inst_ident) = (yyvsp[-6].u.inst_ident);
  (yyval.u.inst_ident)->add_modifier(IIT_rvalue_reference);
  (yyval.u.inst_ident)->add_modifier(IIT_paren);
  (yyval.u.inst_ident)->add_func_modifier((yyvsp[-3].u.param_list), (yyvsp[-1].u.integer), (yyvsp[0].u.type));
}
#line 6766 "built/tmp/cppBison.yxx.c"
    break;

  case 299: /* type: simple_type  */
#line 2455 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.type) = CPPType::new_type((yyvsp[0].u.simple_type));
}
#line 6774 "built/tmp/cppBison.yxx.c"
    break;

  case 300: /* type: TYPENAME_IDENTIFIER  */
#line 2459 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.type) = (yyvsp[0].u.identifier)->find_type(current_scope, global_scope, false, current_lexer);
  if ((yyval.u.type) == nullptr) {
    yyerror(string("internal error resolving type ") + (yyvsp[0].u.identifier)->get_fully_scoped_name(), (yylsp[0]));
  }
  assert((yyval.u.type) != nullptr);
}
#line 6786 "built/tmp/cppBison.yxx.c"
    break;

  case 301: /* type: KW_TYPENAME name  */
#line 2467 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.type) = CPPType::new_type(new CPPTBDType((yyvsp[0].u.identifier)));
}
#line 6794 "built/tmp/cppBison.yxx.c"
    break;

  case 302: /* type: anonymous_struct  */
#line 2471 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.type) = CPPType::new_type((yyvsp[0].u.struct_type));
}
#line 6802 "built/tmp/cppBison.yxx.c"
    break;

  case 303: /* type: named_struct  */
#line 2475 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.type) = CPPType::new_type((yyvsp[0].u.struct_type));
}
#line 6810 "built/tmp/cppBison.yxx.c"
    break;

  case 304: /* type: enum  */
#line 2479 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.type) = CPPType::new_type((yyvsp[0].u.enum_type));
}
#line 6818 "built/tmp/cppBison.yxx.c"
    break;

  case 305: /* type: struct_keyword struct_attributes name  */
#line 2483 "dtool/src/cppparser/cppBison.yxx"
{
  CPPType *type = (yyvsp[0].u.identifier)->find_type(current_scope, global_scope, false, current_lexer);
  if (type != nullptr) {
    (yyval.u.type) = type;
  } else {
    CPPExtensionType *et =
      CPPType::new_type(new CPPExtensionType((yyvsp[-2].u.extension_enum), (yyvsp[0].u.identifier), current_scope, (yylsp[-2]).file))
      ->as_extension_type();
    CPPScope *scope = (yyvsp[0].u.identifier)->get_scope(current_scope, global_scope);
    if (scope != nullptr) {
      scope->define_extension_type(et);
    }
    (yyval.u.type) = et;
  }
}
#line 6838 "built/tmp/cppBison.yxx.c"
    break;

  case 306: /* type: enum_keyword name_no_final ':' enum_element_type  */
#line 2499 "dtool/src/cppparser/cppBison.yxx"
{
  CPPType *type = (yyvsp[-2].u.identifier)->find_type(current_scope, global_scope, false, current_lexer);
  if (type != nullptr) {
    (yyval.u.type) = type;
  } else {
    CPPExtensionType *et =
      CPPType::new_type(new CPPExtensionType((yyvsp[-3].u.extension_enum), (yyvsp[-2].u.identifier), current_scope, (yylsp[-3]).file))
      ->as_extension_type();
    CPPScope *scope = (yyvsp[-2].u.identifier)->get_scope(current_scope, global_scope);
    if (scope != nullptr) {
      scope->define_extension_type(et);
    }
    (yyval.u.type) = et;
  }
}
#line 6858 "built/tmp/cppBison.yxx.c"
    break;

  case 307: /* type: KW_DECLTYPE '(' const_expr ')'  */
#line 2515 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.type) = (yyvsp[-1].u.expr)->determine_type();
  if ((yyval.u.type) == nullptr) {
    stringstream str;
    str << *(yyvsp[-1].u.expr);
    yyerror("could not determine type of " + str.str(), (yylsp[-1]));
  }
}
#line 6871 "built/tmp/cppBison.yxx.c"
    break;

  case 308: /* type: KW_DECLTYPE '(' KW_AUTO ')'  */
#line 2524 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.type) = CPPType::new_type(new CPPSimpleType(CPPSimpleType::T_auto));
}
#line 6879 "built/tmp/cppBison.yxx.c"
    break;

  case 309: /* type: KW_UNDERLYING_TYPE '(' full_type ')'  */
#line 2528 "dtool/src/cppparser/cppBison.yxx"
{
  CPPEnumType *enum_type = (yyvsp[-1].u.type)->as_enum_type();
  if (enum_type == nullptr) {
    yyerror("an enumeration type is required", (yylsp[-1]));
    (yyval.u.type) = (yyvsp[-1].u.type);
  } else {
    (yyval.u.type) = enum_type->get_underlying_type();
  }
}
#line 6893 "built/tmp/cppBison.yxx.c"
    break;

  case 310: /* type: KW_AUTO  */
#line 2538 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.type) = CPPType::new_type(new CPPSimpleType(CPPSimpleType::T_auto));
}
#line 6901 "built/tmp/cppBison.yxx.c"
    break;

  case 311: /* type_pack: TYPEPACK_IDENTIFIER  */
#line 2545 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.type) = (yyvsp[0].u.identifier)->find_type(current_scope, global_scope, false, current_lexer);
  if ((yyval.u.type) == nullptr) {
    yyerror(string("internal error resolving type ") + (yyvsp[0].u.identifier)->get_fully_scoped_name(), (yylsp[0]));
  }
  assert((yyval.u.type) != nullptr);
}
#line 6913 "built/tmp/cppBison.yxx.c"
    break;

  case 312: /* type_decl: simple_type  */
#line 2556 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.decl) = CPPType::new_type((yyvsp[0].u.simple_type));
}
#line 6921 "built/tmp/cppBison.yxx.c"
    break;

  case 313: /* type_decl: TYPENAME_IDENTIFIER  */
#line 2560 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.decl) = (yyvsp[0].u.identifier)->find_type(current_scope, global_scope, false, current_lexer);
  if ((yyval.u.decl) == nullptr) {
    yyerror(string("internal error resolving type ") + (yyvsp[0].u.identifier)->get_fully_scoped_name(), (yylsp[0]));
  }
  assert((yyval.u.decl) != nullptr);
}
#line 6933 "built/tmp/cppBison.yxx.c"
    break;

  case 314: /* type_decl: KW_TYPENAME name  */
#line 2568 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.decl) = CPPType::new_type(new CPPTBDType((yyvsp[0].u.identifier)));
}
#line 6941 "built/tmp/cppBison.yxx.c"
    break;

  case 315: /* type_decl: anonymous_struct  */
#line 2572 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.decl) = CPPType::new_type((yyvsp[0].u.struct_type));
}
#line 6949 "built/tmp/cppBison.yxx.c"
    break;

  case 316: /* type_decl: named_struct  */
#line 2576 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.decl) = new CPPTypeDeclaration(CPPType::new_type((yyvsp[0].u.struct_type)));
}
#line 6957 "built/tmp/cppBison.yxx.c"
    break;

  case 317: /* type_decl: enum  */
#line 2580 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.decl) = new CPPTypeDeclaration(CPPType::new_type((yyvsp[0].u.enum_type)));
}
#line 6965 "built/tmp/cppBison.yxx.c"
    break;

  case 318: /* type_decl: struct_keyword struct_attributes name  */
#line 2584 "dtool/src/cppparser/cppBison.yxx"
{
  CPPType *type = (yyvsp[0].u.identifier)->find_type(current_scope, global_scope, false, current_lexer);
  if (type != nullptr) {
    (yyval.u.decl) = type;
  } else {
    CPPExtensionType *et =
      CPPType::new_type(new CPPExtensionType((yyvsp[-2].u.extension_enum), (yyvsp[0].u.identifier), current_scope, (yylsp[-2]).file))
      ->as_extension_type();
    CPPScope *scope = (yyvsp[0].u.identifier)->get_scope(current_scope, global_scope);
    if (scope != nullptr) {
      scope->define_extension_type(et);
    }
    (yyval.u.decl) = et;
  }
}
#line 6985 "built/tmp/cppBison.yxx.c"
    break;

  case 319: /* type_decl: enum_keyword name_no_final ':' enum_element_type  */
#line 2600 "dtool/src/cppparser/cppBison.yxx"
{
  CPPType *type = (yyvsp[-2].u.identifier)->find_type(current_scope, global_scope, false, current_lexer);
  if (type != nullptr) {
    (yyval.u.decl) = type;
  } else {
    CPPExtensionType *et =
      CPPType::new_type(new CPPExtensionType((yyvsp[-3].u.extension_enum), (yyvsp[-2].u.identifier), current_scope, (yylsp[-3]).file))
      ->as_extension_type();
    CPPScope *scope = (yyvsp[-2].u.identifier)->get_scope(current_scope, global_scope);
    if (scope != nullptr) {
      scope->define_extension_type(et);
    }
    (yyval.u.decl) = et;
  }
}
#line 7005 "built/tmp/cppBison.yxx.c"
    break;

  case 320: /* type_decl: enum_keyword name  */
#line 2616 "dtool/src/cppparser/cppBison.yxx"
{
  yywarning(string("C++ does not permit forward declaration of untyped enum ") + (yyvsp[0].u.identifier)->get_fully_scoped_name(), (yylsp[-1]));

  CPPType *type = (yyvsp[0].u.identifier)->find_type(current_scope, global_scope, false, current_lexer);
  if (type != nullptr) {
    (yyval.u.decl) = type;
  } else {
    CPPExtensionType *et =
      CPPType::new_type(new CPPExtensionType((yyvsp[-1].u.extension_enum), (yyvsp[0].u.identifier), current_scope, (yylsp[-1]).file))
      ->as_extension_type();
    CPPScope *scope = (yyvsp[0].u.identifier)->get_scope(current_scope, global_scope);
    if (scope != nullptr) {
      scope->define_extension_type(et);
    }
    (yyval.u.decl) = et;
  }
}
#line 7027 "built/tmp/cppBison.yxx.c"
    break;

  case 321: /* type_decl: KW_DECLTYPE '(' const_expr ')'  */
#line 2634 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.decl) = (yyvsp[-1].u.expr)->determine_type();
  if ((yyval.u.decl) == nullptr) {
    stringstream str;
    str << *(yyvsp[-1].u.expr);
    yyerror("could not determine type of " + str.str(), (yylsp[-1]));
  }
}
#line 7040 "built/tmp/cppBison.yxx.c"
    break;

  case 322: /* type_decl: KW_DECLTYPE '(' KW_AUTO ')'  */
#line 2643 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.decl) = CPPType::new_type(new CPPSimpleType(CPPSimpleType::T_auto));
}
#line 7048 "built/tmp/cppBison.yxx.c"
    break;

  case 323: /* type_decl: KW_UNDERLYING_TYPE '(' full_type ')'  */
#line 2647 "dtool/src/cppparser/cppBison.yxx"
{
  CPPEnumType *enum_type = (yyvsp[-1].u.type)->as_enum_type();
  if (enum_type == nullptr) {
    yyerror("an enumeration type is required", (yylsp[-1]));
    (yyval.u.decl) = (yyvsp[-1].u.type);
  } else {
    (yyval.u.decl) = enum_type->get_underlying_type();
  }
}
#line 7062 "built/tmp/cppBison.yxx.c"
    break;

  case 324: /* type_decl: KW_AUTO  */
#line 2657 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.decl) = CPPType::new_type(new CPPSimpleType(CPPSimpleType::T_auto));
}
#line 7070 "built/tmp/cppBison.yxx.c"
    break;

  case 325: /* predefined_type: simple_type  */
#line 2664 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.type) = CPPType::new_type((yyvsp[0].u.simple_type));
}
#line 7078 "built/tmp/cppBison.yxx.c"
    break;

  case 326: /* predefined_type: TYPENAME_IDENTIFIER  */
#line 2668 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.type) = (yyvsp[0].u.identifier)->find_type(current_scope, global_scope, false, current_lexer);
  if ((yyval.u.type) == nullptr) {
    yyerror(string("internal error resolving type ") + (yyvsp[0].u.identifier)->get_fully_scoped_name(), (yylsp[0]));
  }
  assert((yyval.u.type) != nullptr);
}
#line 7090 "built/tmp/cppBison.yxx.c"
    break;

  case 327: /* predefined_type: KW_TYPENAME name  */
#line 2676 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.type) = CPPType::new_type(new CPPTBDType((yyvsp[0].u.identifier)));
}
#line 7098 "built/tmp/cppBison.yxx.c"
    break;

  case 328: /* predefined_type: struct_keyword struct_attributes name  */
#line 2680 "dtool/src/cppparser/cppBison.yxx"
{
  CPPType *type = (yyvsp[0].u.identifier)->find_type(current_scope, global_scope, false, current_lexer);
  if (type != nullptr) {
    (yyval.u.type) = type;
  } else {
    CPPExtensionType *et =
      CPPType::new_type(new CPPExtensionType((yyvsp[-2].u.extension_enum), (yyvsp[0].u.identifier), current_scope, (yylsp[-2]).file))
      ->as_extension_type();
    CPPScope *scope = (yyvsp[0].u.identifier)->get_scope(current_scope, global_scope);
    if (scope != nullptr) {
      scope->define_extension_type(et);
    }
    (yyval.u.type) = et;
  }
}
#line 7118 "built/tmp/cppBison.yxx.c"
    break;

  case 329: /* predefined_type: enum_keyword name  */
#line 2696 "dtool/src/cppparser/cppBison.yxx"
{
  CPPType *type = (yyvsp[0].u.identifier)->find_type(current_scope, global_scope, false, current_lexer);
  if (type != nullptr) {
    (yyval.u.type) = type;
  } else {
    CPPExtensionType *et =
      CPPType::new_type(new CPPExtensionType((yyvsp[-1].u.extension_enum), (yyvsp[0].u.identifier), current_scope, (yylsp[-1]).file))
      ->as_extension_type();
    CPPScope *scope = (yyvsp[0].u.identifier)->get_scope(current_scope, global_scope);
    if (scope != nullptr) {
      scope->define_extension_type(et);
    }
    (yyval.u.type) = et;
  }
}
#line 7138 "built/tmp/cppBison.yxx.c"
    break;

  case 330: /* predefined_type: KW_DECLTYPE '(' const_expr ')'  */
#line 2712 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.type) = (yyvsp[-1].u.expr)->determine_type();
  if ((yyval.u.type) == nullptr) {
    stringstream str;
    str << *(yyvsp[-1].u.expr);
    yyerror("could not determine type of " + str.str(), (yylsp[-1]));
  }
}
#line 7151 "built/tmp/cppBison.yxx.c"
    break;

  case 331: /* predefined_type: KW_UNDERLYING_TYPE '(' full_type ')'  */
#line 2721 "dtool/src/cppparser/cppBison.yxx"
{
  CPPEnumType *enum_type = (yyvsp[-1].u.type)->as_enum_type();
  if (enum_type == nullptr) {
    yyerror("an enumeration type is required", (yylsp[-1]));
    (yyval.u.type) = (yyvsp[-1].u.type);
  } else {
    (yyval.u.type) = enum_type->get_underlying_type();
  }
}
#line 7165 "built/tmp/cppBison.yxx.c"
    break;

  case 332: /* predefined_type: KW_AUTO  */
#line 2731 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.type) = CPPType::new_type(new CPPSimpleType(CPPSimpleType::T_auto));
}
#line 7173 "built/tmp/cppBison.yxx.c"
    break;

  case 333: /* var_type_decl: type_decl  */
#line 2738 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.decl) = (yyvsp[0].u.decl);
}
#line 7181 "built/tmp/cppBison.yxx.c"
    break;

  case 334: /* var_type_decl: IDENTIFIER  */
#line 2742 "dtool/src/cppparser/cppBison.yxx"
{
  yyerror(string("unknown type '") + (yyvsp[0].u.identifier)->get_fully_scoped_name() + "'", (yylsp[0]));

  (yyval.u.decl) = CPPType::new_type(new CPPSimpleType(CPPSimpleType::T_unknown));
}
#line 7191 "built/tmp/cppBison.yxx.c"
    break;

  case 335: /* full_type: type empty_instance_identifier  */
#line 2750 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.type) = (yyvsp[0].u.inst_ident)->unroll_type((yyvsp[-1].u.type));
}
#line 7199 "built/tmp/cppBison.yxx.c"
    break;

  case 336: /* full_type: KW_CONST type empty_instance_identifier  */
#line 2754 "dtool/src/cppparser/cppBison.yxx"
{
  (yyvsp[0].u.inst_ident)->add_modifier(IIT_const);
  (yyval.u.type) = (yyvsp[0].u.inst_ident)->unroll_type((yyvsp[-1].u.type));
}
#line 7208 "built/tmp/cppBison.yxx.c"
    break;

  case 337: /* full_type: type_pack empty_instance_identifier  */
#line 2759 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.type) = (yyvsp[0].u.inst_ident)->unroll_type((yyvsp[-1].u.type));
}
#line 7216 "built/tmp/cppBison.yxx.c"
    break;

  case 338: /* full_type: KW_CONST type_pack empty_instance_identifier  */
#line 2763 "dtool/src/cppparser/cppBison.yxx"
{
  (yyvsp[0].u.inst_ident)->add_modifier(IIT_const);
  (yyval.u.type) = (yyvsp[0].u.inst_ident)->unroll_type((yyvsp[-1].u.type));
}
#line 7225 "built/tmp/cppBison.yxx.c"
    break;

  case 343: /* $@16: %empty  */
#line 2778 "dtool/src/cppparser/cppBison.yxx"
{
  CPPVisibility starting_vis =
  ((yyvsp[-2].u.extension_enum) == CPPExtensionType::T_class) ? V_private : V_public;

  CPPScope *new_scope = new CPPScope(current_scope, CPPNameComponent("anon"),
                                     starting_vis);
  CPPStructType *st = new CPPStructType((yyvsp[-2].u.extension_enum), nullptr, current_scope,
                                        new_scope, (yylsp[-2]).file);
  new_scope->set_struct_type(st);

  push_scope(new_scope);
  push_struct(st);
}
#line 7243 "built/tmp/cppBison.yxx.c"
    break;

  case 344: /* anonymous_struct: struct_keyword struct_attributes '{' $@16 cpp '}'  */
#line 2792 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.struct_type) = current_struct;
  current_struct->_incomplete = false;
  pop_struct();
  pop_scope();
}
#line 7254 "built/tmp/cppBison.yxx.c"
    break;

  case 345: /* $@17: %empty  */
#line 2802 "dtool/src/cppparser/cppBison.yxx"
{
  CPPVisibility starting_vis =
  ((yyvsp[-2].u.extension_enum) == CPPExtensionType::T_class) ? V_private : V_public;

  CPPScope *scope = (yyvsp[0].u.identifier)->get_scope(current_scope, global_scope, current_lexer);
  if (scope == nullptr) {
    scope = current_scope;
  }
  CPPScope *new_scope = new CPPScope(scope, (yyvsp[0].u.identifier)->_names.back(),
                                     starting_vis);

  CPPStructType *st = new CPPStructType((yyvsp[-2].u.extension_enum), (yyvsp[0].u.identifier), current_scope,
                                        new_scope, (yylsp[-2]).file);
  new_scope->set_struct_type(st);
  current_scope->define_extension_type(st);

  push_scope(new_scope);
  push_struct(st);
}
#line 7278 "built/tmp/cppBison.yxx.c"
    break;

  case 346: /* named_struct: struct_keyword struct_attributes name_no_final $@17 maybe_final maybe_class_derivation '{' cpp '}'  */
#line 2822 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.struct_type) = current_struct;
  current_struct->_incomplete = false;
  pop_struct();
  pop_scope();
}
#line 7289 "built/tmp/cppBison.yxx.c"
    break;

  case 348: /* maybe_final: KW_FINAL  */
#line 2833 "dtool/src/cppparser/cppBison.yxx"
{
  current_struct->_final = true;
}
#line 7297 "built/tmp/cppBison.yxx.c"
    break;

  case 353: /* base_specification: class_derivation_name  */
#line 2850 "dtool/src/cppparser/cppBison.yxx"
{
  current_struct->append_derivation((yyvsp[0].u.type), V_unknown, false);
}
#line 7305 "built/tmp/cppBison.yxx.c"
    break;

  case 354: /* base_specification: KW_PUBLIC class_derivation_name  */
#line 2854 "dtool/src/cppparser/cppBison.yxx"
{
  current_struct->append_derivation((yyvsp[0].u.type), V_public, false);
}
#line 7313 "built/tmp/cppBison.yxx.c"
    break;

  case 355: /* base_specification: KW_PROTECTED class_derivation_name  */
#line 2858 "dtool/src/cppparser/cppBison.yxx"
{
  current_struct->append_derivation((yyvsp[0].u.type), V_protected, false);
}
#line 7321 "built/tmp/cppBison.yxx.c"
    break;

  case 356: /* base_specification: KW_PRIVATE class_derivation_name  */
#line 2862 "dtool/src/cppparser/cppBison.yxx"
{
  current_struct->append_derivation((yyvsp[0].u.type), V_private, false);
}
#line 7329 "built/tmp/cppBison.yxx.c"
    break;

  case 357: /* base_specification: KW_VIRTUAL KW_PUBLIC class_derivation_name  */
#line 2866 "dtool/src/cppparser/cppBison.yxx"
{
  current_struct->append_derivation((yyvsp[0].u.type), V_public, true);
}
#line 7337 "built/tmp/cppBison.yxx.c"
    break;

  case 358: /* base_specification: KW_VIRTUAL KW_PROTECTED class_derivation_name  */
#line 2870 "dtool/src/cppparser/cppBison.yxx"
{
  current_struct->append_derivation((yyvsp[0].u.type), V_protected, true);
}
#line 7345 "built/tmp/cppBison.yxx.c"
    break;

  case 359: /* base_specification: KW_VIRTUAL KW_PRIVATE class_derivation_name  */
#line 2874 "dtool/src/cppparser/cppBison.yxx"
{
  current_struct->append_derivation((yyvsp[0].u.type), V_private, true);
}
#line 7353 "built/tmp/cppBison.yxx.c"
    break;

  case 360: /* base_specification: KW_PUBLIC KW_VIRTUAL class_derivation_name  */
#line 2878 "dtool/src/cppparser/cppBison.yxx"
{
  current_struct->append_derivation((yyvsp[0].u.type), V_public, true);
}
#line 7361 "built/tmp/cppBison.yxx.c"
    break;

  case 361: /* base_specification: KW_PROTECTED KW_VIRTUAL class_derivation_name  */
#line 2882 "dtool/src/cppparser/cppBison.yxx"
{
  current_struct->append_derivation((yyvsp[0].u.type), V_protected, true);
}
#line 7369 "built/tmp/cppBison.yxx.c"
    break;

  case 362: /* base_specification: KW_PRIVATE KW_VIRTUAL class_derivation_name  */
#line 2886 "dtool/src/cppparser/cppBison.yxx"
{
  current_struct->append_derivation((yyvsp[0].u.type), V_private, true);
}
#line 7377 "built/tmp/cppBison.yxx.c"
    break;

  case 363: /* enum: enum_decl '{' enum_body '}'  */
#line 2893 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.enum_type) = current_enum;
  current_enum = nullptr;
}
#line 7386 "built/tmp/cppBison.yxx.c"
    break;

  case 364: /* enum_decl: enum_keyword ':' enum_element_type  */
#line 2901 "dtool/src/cppparser/cppBison.yxx"
{
  current_enum = new CPPEnumType((yyvsp[-2].u.extension_enum), nullptr, (yyvsp[0].u.type), current_scope, nullptr, (yylsp[-2]).file);
}
#line 7394 "built/tmp/cppBison.yxx.c"
    break;

  case 365: /* enum_decl: enum_keyword  */
#line 2905 "dtool/src/cppparser/cppBison.yxx"
{
  current_enum = new CPPEnumType((yyvsp[0].u.extension_enum), nullptr, current_scope, nullptr, (yylsp[0]).file);
}
#line 7402 "built/tmp/cppBison.yxx.c"
    break;

  case 366: /* enum_decl: enum_keyword name_no_final ':' enum_element_type  */
#line 2909 "dtool/src/cppparser/cppBison.yxx"
{
  CPPScope *new_scope = new CPPScope(current_scope, (yyvsp[-2].u.identifier)->_names.back(), V_public);
  current_enum = new CPPEnumType((yyvsp[-3].u.extension_enum), (yyvsp[-2].u.identifier), (yyvsp[0].u.type), current_scope, new_scope, (yylsp[-3]).file);
}
#line 7411 "built/tmp/cppBison.yxx.c"
    break;

  case 367: /* enum_decl: enum_keyword name_no_final  */
#line 2914 "dtool/src/cppparser/cppBison.yxx"
{
  CPPScope *new_scope = new CPPScope(current_scope, (yyvsp[0].u.identifier)->_names.back(), V_public);
  current_enum = new CPPEnumType((yyvsp[-1].u.extension_enum), (yyvsp[0].u.identifier), current_scope, new_scope, (yylsp[-1]).file);
}
#line 7420 "built/tmp/cppBison.yxx.c"
    break;

  case 368: /* enum_element_type: simple_int_type  */
#line 2922 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.type) = CPPType::new_type((yyvsp[0].u.simple_type));
}
#line 7428 "built/tmp/cppBison.yxx.c"
    break;

  case 369: /* enum_element_type: TYPENAME_IDENTIFIER  */
#line 2926 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.type) = (yyvsp[0].u.identifier)->find_type(current_scope, global_scope, false, current_lexer);
}
#line 7436 "built/tmp/cppBison.yxx.c"
    break;

  case 371: /* enum_body_trailing_comma: enum_body_trailing_comma name ','  */
#line 2934 "dtool/src/cppparser/cppBison.yxx"
{
  assert(current_enum != nullptr);
  current_enum->add_element((yyvsp[-1].u.identifier)->get_simple_name(), nullptr, current_lexer, (yylsp[-1]));
}
#line 7445 "built/tmp/cppBison.yxx.c"
    break;

  case 372: /* enum_body_trailing_comma: enum_body_trailing_comma name '=' const_expr ','  */
#line 2939 "dtool/src/cppparser/cppBison.yxx"
{
  assert(current_enum != nullptr);
  current_enum->add_element((yyvsp[-3].u.identifier)->get_simple_name(), (yyvsp[-1].u.expr), current_lexer, (yylsp[-3]));
}
#line 7454 "built/tmp/cppBison.yxx.c"
    break;

  case 374: /* enum_body: enum_body_trailing_comma name  */
#line 2947 "dtool/src/cppparser/cppBison.yxx"
{
  assert(current_enum != nullptr);
  current_enum->add_element((yyvsp[0].u.identifier)->get_simple_name(), nullptr, current_lexer, (yylsp[0]));
}
#line 7463 "built/tmp/cppBison.yxx.c"
    break;

  case 375: /* enum_body: enum_body_trailing_comma name '=' const_expr  */
#line 2952 "dtool/src/cppparser/cppBison.yxx"
{
  assert(current_enum != nullptr);
  current_enum->add_element((yyvsp[-2].u.identifier)->get_simple_name(), (yyvsp[0].u.expr), current_lexer, (yylsp[-2]));
}
#line 7472 "built/tmp/cppBison.yxx.c"
    break;

  case 376: /* enum_keyword: KW_ENUM  */
#line 2960 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.extension_enum) = CPPExtensionType::T_enum;
}
#line 7480 "built/tmp/cppBison.yxx.c"
    break;

  case 377: /* enum_keyword: KW_ENUM KW_CLASS  */
#line 2964 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.extension_enum) = CPPExtensionType::T_enum_class;
}
#line 7488 "built/tmp/cppBison.yxx.c"
    break;

  case 378: /* enum_keyword: KW_ENUM KW_STRUCT  */
#line 2968 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.extension_enum) = CPPExtensionType::T_enum_struct;
}
#line 7496 "built/tmp/cppBison.yxx.c"
    break;

  case 379: /* struct_keyword: KW_CLASS  */
#line 2975 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.extension_enum) = CPPExtensionType::T_class;
}
#line 7504 "built/tmp/cppBison.yxx.c"
    break;

  case 380: /* struct_keyword: KW_STRUCT  */
#line 2979 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.extension_enum) = CPPExtensionType::T_struct;
}
#line 7512 "built/tmp/cppBison.yxx.c"
    break;

  case 381: /* struct_keyword: KW_UNION  */
#line 2983 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.extension_enum) = CPPExtensionType::T_union;
}
#line 7520 "built/tmp/cppBison.yxx.c"
    break;

  case 382: /* $@18: %empty  */
#line 2990 "dtool/src/cppparser/cppBison.yxx"
{
  CPPScope *scope = (yyvsp[-1].u.identifier)->find_scope(current_scope, global_scope, current_lexer);
  if (scope == nullptr) {
    // This must be a new namespace declaration.
    CPPScope *parent_scope =
      (yyvsp[-1].u.identifier)->get_scope(current_scope, global_scope, current_lexer);
    if (parent_scope == nullptr) {
      parent_scope = current_scope;
    }
    scope = new CPPScope(parent_scope, (yyvsp[-1].u.identifier)->_names.back(), V_public);
  }

  CPPNamespace *nspace = new CPPNamespace((yyvsp[-1].u.identifier), scope, (yylsp[-2]).file);
  current_scope->add_declaration(nspace, global_scope, current_lexer, (yylsp[-2]));
  current_scope->define_namespace(nspace);
  push_scope(scope);
}
#line 7542 "built/tmp/cppBison.yxx.c"
    break;

  case 383: /* namespace_declaration: KW_NAMESPACE name '{' $@18 cpp '}'  */
#line 3008 "dtool/src/cppparser/cppBison.yxx"
{
  pop_scope();
}
#line 7550 "built/tmp/cppBison.yxx.c"
    break;

  case 384: /* $@19: %empty  */
#line 3012 "dtool/src/cppparser/cppBison.yxx"
{
  CPPScope *scope = (yyvsp[-1].u.identifier)->find_scope(current_scope, global_scope, current_lexer);
  if (scope == nullptr) {
    // This must be a new namespace declaration.
    CPPScope *parent_scope =
      (yyvsp[-1].u.identifier)->get_scope(current_scope, global_scope, current_lexer);
    if (parent_scope == nullptr) {
      parent_scope = current_scope;
    }
    scope = new CPPScope(parent_scope, (yyvsp[-1].u.identifier)->_names.back(), V_public);
  }

  CPPNamespace *nspace = new CPPNamespace((yyvsp[-1].u.identifier), scope, (yylsp[-2]).file);
  nspace->_is_inline = true;
  current_scope->add_declaration(nspace, global_scope, current_lexer, (yylsp[-2]));
  current_scope->define_namespace(nspace);
  push_scope(scope);
}
#line 7573 "built/tmp/cppBison.yxx.c"
    break;

  case 385: /* namespace_declaration: KW_INLINE KW_NAMESPACE name '{' $@19 cpp '}'  */
#line 3031 "dtool/src/cppparser/cppBison.yxx"
{
  pop_scope();
}
#line 7581 "built/tmp/cppBison.yxx.c"
    break;

  case 388: /* using_declaration: KW_USING name ';'  */
#line 3040 "dtool/src/cppparser/cppBison.yxx"
{
  CPPUsing *using_decl = new CPPUsing((yyvsp[-1].u.identifier), false, (yylsp[-2]).file);
  current_scope->add_declaration(using_decl, global_scope, current_lexer, (yylsp[-2]));
  current_scope->add_using(using_decl, global_scope, current_lexer);
}
#line 7591 "built/tmp/cppBison.yxx.c"
    break;

  case 389: /* using_declaration: KW_USING name '=' full_type ';'  */
#line 3046 "dtool/src/cppparser/cppBison.yxx"
{
  // This is really just an alternative way to declare a typedef.
  CPPTypedefType *typedef_type = new CPPTypedefType((yyvsp[-1].u.type), (yyvsp[-3].u.identifier), current_scope);
  typedef_type->_using = true;
  current_scope->add_declaration(CPPType::new_type(typedef_type), global_scope, current_lexer, (yylsp[-4]));
}
#line 7602 "built/tmp/cppBison.yxx.c"
    break;

  case 390: /* using_declaration: KW_USING KW_NAMESPACE name ';'  */
#line 3053 "dtool/src/cppparser/cppBison.yxx"
{
  CPPUsing *using_decl = new CPPUsing((yyvsp[-1].u.identifier), true, (yylsp[-3]).file);
  current_scope->add_declaration(using_decl, global_scope, current_lexer, (yylsp[-3]));
  current_scope->add_using(using_decl, global_scope, current_lexer);
}
#line 7612 "built/tmp/cppBison.yxx.c"
    break;

  case 394: /* simple_int_type: KW_BOOL  */
#line 3068 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.simple_type) = new CPPSimpleType(CPPSimpleType::T_bool);
}
#line 7620 "built/tmp/cppBison.yxx.c"
    break;

  case 395: /* simple_int_type: KW_CHAR  */
#line 3072 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.simple_type) = new CPPSimpleType(CPPSimpleType::T_char);
}
#line 7628 "built/tmp/cppBison.yxx.c"
    break;

  case 396: /* simple_int_type: KW_WCHAR_T  */
#line 3076 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.simple_type) = new CPPSimpleType(CPPSimpleType::T_wchar_t);
}
#line 7636 "built/tmp/cppBison.yxx.c"
    break;

  case 397: /* simple_int_type: KW_CHAR16_T  */
#line 3080 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.simple_type) = new CPPSimpleType(CPPSimpleType::T_char16_t);
}
#line 7644 "built/tmp/cppBison.yxx.c"
    break;

  case 398: /* simple_int_type: KW_CHAR32_T  */
#line 3084 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.simple_type) = new CPPSimpleType(CPPSimpleType::T_char32_t);
}
#line 7652 "built/tmp/cppBison.yxx.c"
    break;

  case 399: /* simple_int_type: KW_SHORT  */
#line 3088 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.simple_type) = new CPPSimpleType(CPPSimpleType::T_int,
                         CPPSimpleType::F_short);
}
#line 7661 "built/tmp/cppBison.yxx.c"
    break;

  case 400: /* simple_int_type: KW_LONG  */
#line 3093 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.simple_type) = new CPPSimpleType(CPPSimpleType::T_int,
                         CPPSimpleType::F_long);
}
#line 7670 "built/tmp/cppBison.yxx.c"
    break;

  case 401: /* simple_int_type: KW_UNSIGNED  */
#line 3098 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.simple_type) = new CPPSimpleType(CPPSimpleType::T_int,
                         CPPSimpleType::F_unsigned);
}
#line 7679 "built/tmp/cppBison.yxx.c"
    break;

  case 402: /* simple_int_type: KW_SIGNED  */
#line 3103 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.simple_type) = new CPPSimpleType(CPPSimpleType::T_int,
                         CPPSimpleType::F_signed);
}
#line 7688 "built/tmp/cppBison.yxx.c"
    break;

  case 403: /* simple_int_type: KW_INT  */
#line 3108 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.simple_type) = new CPPSimpleType(CPPSimpleType::T_int);
}
#line 7696 "built/tmp/cppBison.yxx.c"
    break;

  case 404: /* simple_int_type: KW_SHORT simple_int_type  */
#line 3112 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.simple_type) = (yyvsp[0].u.simple_type);
  (yyval.u.simple_type)->_flags |= CPPSimpleType::F_short;
}
#line 7705 "built/tmp/cppBison.yxx.c"
    break;

  case 405: /* simple_int_type: KW_LONG simple_int_type  */
#line 3117 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.simple_type) = (yyvsp[0].u.simple_type);
  if ((yyval.u.simple_type)->_flags & CPPSimpleType::F_long) {
    (yyval.u.simple_type)->_flags |= CPPSimpleType::F_longlong;
  } else {
    (yyval.u.simple_type)->_flags |= CPPSimpleType::F_long;
  }
}
#line 7718 "built/tmp/cppBison.yxx.c"
    break;

  case 406: /* simple_int_type: KW_UNSIGNED simple_int_type  */
#line 3126 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.simple_type) = (yyvsp[0].u.simple_type);
  (yyval.u.simple_type)->_flags |= CPPSimpleType::F_unsigned;
}
#line 7727 "built/tmp/cppBison.yxx.c"
    break;

  case 407: /* simple_int_type: KW_SIGNED simple_int_type  */
#line 3131 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.simple_type) = (yyvsp[0].u.simple_type);
  (yyval.u.simple_type)->_flags |= CPPSimpleType::F_signed;
}
#line 7736 "built/tmp/cppBison.yxx.c"
    break;

  case 408: /* simple_float_type: KW_FLOAT  */
#line 3139 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.simple_type) = new CPPSimpleType(CPPSimpleType::T_float);
}
#line 7744 "built/tmp/cppBison.yxx.c"
    break;

  case 409: /* simple_float_type: KW_DOUBLE  */
#line 3143 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.simple_type) = new CPPSimpleType(CPPSimpleType::T_double);
}
#line 7752 "built/tmp/cppBison.yxx.c"
    break;

  case 410: /* simple_float_type: KW_LONG KW_DOUBLE  */
#line 3147 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.simple_type) = new CPPSimpleType(CPPSimpleType::T_double,
                         CPPSimpleType::F_long);
}
#line 7761 "built/tmp/cppBison.yxx.c"
    break;

  case 411: /* simple_void_type: KW_VOID  */
#line 3155 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.simple_type) = new CPPSimpleType(CPPSimpleType::T_void);
}
#line 7769 "built/tmp/cppBison.yxx.c"
    break;

  case 412: /* $@20: %empty  */
#line 3164 "dtool/src/cppparser/cppBison.yxx"
{
  current_lexer->_resolve_identifiers = false;
}
#line 7777 "built/tmp/cppBison.yxx.c"
    break;

  case 413: /* code: $@20 code_block  */
#line 3168 "dtool/src/cppparser/cppBison.yxx"
{
  current_lexer->_resolve_identifiers = true;
}
#line 7785 "built/tmp/cppBison.yxx.c"
    break;

  case 521: /* element: KW_WHILE  */
#line 3212 "dtool/src/cppparser/cppBison.yxx"
{
}
#line 7792 "built/tmp/cppBison.yxx.c"
    break;

  case 545: /* optional_const_expr: empty  */
#line 3221 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = nullptr;
}
#line 7800 "built/tmp/cppBison.yxx.c"
    break;

  case 546: /* optional_const_expr: const_expr  */
#line 3225 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = (yyvsp[0].u.expr);
}
#line 7808 "built/tmp/cppBison.yxx.c"
    break;

  case 547: /* optional_const_expr_comma: empty  */
#line 3232 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = nullptr;
}
#line 7816 "built/tmp/cppBison.yxx.c"
    break;

  case 548: /* optional_const_expr_comma: const_expr_comma  */
#line 3236 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = (yyvsp[0].u.expr);
}
#line 7824 "built/tmp/cppBison.yxx.c"
    break;

  case 549: /* const_expr_comma: const_expr  */
#line 3243 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = (yyvsp[0].u.expr);
}
#line 7832 "built/tmp/cppBison.yxx.c"
    break;

  case 550: /* const_expr_comma: const_expr_comma ',' const_expr  */
#line 3247 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(',', (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 7840 "built/tmp/cppBison.yxx.c"
    break;

  case 551: /* no_angle_bracket_const_expr: const_operand  */
#line 3254 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = (yyvsp[0].u.expr);
}
#line 7848 "built/tmp/cppBison.yxx.c"
    break;

  case 552: /* no_angle_bracket_const_expr: '(' full_type ')' no_angle_bracket_const_expr  */
#line 3258 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::typecast_op((yyvsp[-2].u.type), (yyvsp[0].u.expr)));
}
#line 7856 "built/tmp/cppBison.yxx.c"
    break;

  case 553: /* no_angle_bracket_const_expr: KW_STATIC_CAST '<' full_type '>' '(' const_expr_comma ')'  */
#line 3262 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::typecast_op((yyvsp[-4].u.type), (yyvsp[-1].u.expr), CPPExpression::T_static_cast));
}
#line 7864 "built/tmp/cppBison.yxx.c"
    break;

  case 554: /* no_angle_bracket_const_expr: KW_DYNAMIC_CAST '<' full_type '>' '(' const_expr_comma ')'  */
#line 3266 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::typecast_op((yyvsp[-4].u.type), (yyvsp[-1].u.expr), CPPExpression::T_dynamic_cast));
}
#line 7872 "built/tmp/cppBison.yxx.c"
    break;

  case 555: /* no_angle_bracket_const_expr: KW_CONST_CAST '<' full_type '>' '(' const_expr_comma ')'  */
#line 3270 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::typecast_op((yyvsp[-4].u.type), (yyvsp[-1].u.expr), CPPExpression::T_const_cast));
}
#line 7880 "built/tmp/cppBison.yxx.c"
    break;

  case 556: /* no_angle_bracket_const_expr: KW_REINTERPRET_CAST '<' full_type '>' '(' const_expr_comma ')'  */
#line 3274 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::typecast_op((yyvsp[-4].u.type), (yyvsp[-1].u.expr), CPPExpression::T_reinterpret_cast));
}
#line 7888 "built/tmp/cppBison.yxx.c"
    break;

  case 557: /* no_angle_bracket_const_expr: KW_SIZEOF '(' full_type ')'  */
#line 3278 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::sizeof_func((yyvsp[-1].u.type)));
}
#line 7896 "built/tmp/cppBison.yxx.c"
    break;

  case 558: /* no_angle_bracket_const_expr: KW_SIZEOF no_angle_bracket_const_expr  */
#line 3282 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::sizeof_func((yyvsp[0].u.expr)));
}
#line 7904 "built/tmp/cppBison.yxx.c"
    break;

  case 559: /* no_angle_bracket_const_expr: KW_SIZEOF ELLIPSIS '(' name ')'  */
#line 3286 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::sizeof_ellipsis_func((yyvsp[-1].u.identifier)));
}
#line 7912 "built/tmp/cppBison.yxx.c"
    break;

  case 560: /* no_angle_bracket_const_expr: KW_ALIGNOF '(' full_type ')'  */
#line 3290 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::alignof_func((yyvsp[-1].u.type)));
}
#line 7920 "built/tmp/cppBison.yxx.c"
    break;

  case 561: /* no_angle_bracket_const_expr: '!' no_angle_bracket_const_expr  */
#line 3294 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(UNARY_NOT, (yyvsp[0].u.expr));
}
#line 7928 "built/tmp/cppBison.yxx.c"
    break;

  case 562: /* no_angle_bracket_const_expr: '~' no_angle_bracket_const_expr  */
#line 3298 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(UNARY_NEGATE, (yyvsp[0].u.expr));
}
#line 7936 "built/tmp/cppBison.yxx.c"
    break;

  case 563: /* no_angle_bracket_const_expr: '-' no_angle_bracket_const_expr  */
#line 3302 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(UNARY_MINUS, (yyvsp[0].u.expr));
}
#line 7944 "built/tmp/cppBison.yxx.c"
    break;

  case 564: /* no_angle_bracket_const_expr: '+' no_angle_bracket_const_expr  */
#line 3306 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(UNARY_PLUS, (yyvsp[0].u.expr));
}
#line 7952 "built/tmp/cppBison.yxx.c"
    break;

  case 565: /* no_angle_bracket_const_expr: '*' no_angle_bracket_const_expr  */
#line 3310 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(UNARY_STAR, (yyvsp[0].u.expr));
}
#line 7960 "built/tmp/cppBison.yxx.c"
    break;

  case 566: /* no_angle_bracket_const_expr: '&' no_angle_bracket_const_expr  */
#line 3314 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(UNARY_REF, (yyvsp[0].u.expr));
}
#line 7968 "built/tmp/cppBison.yxx.c"
    break;

  case 567: /* no_angle_bracket_const_expr: no_angle_bracket_const_expr '*' no_angle_bracket_const_expr  */
#line 3318 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('*', (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 7976 "built/tmp/cppBison.yxx.c"
    break;

  case 568: /* no_angle_bracket_const_expr: no_angle_bracket_const_expr '/' no_angle_bracket_const_expr  */
#line 3322 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('/', (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 7984 "built/tmp/cppBison.yxx.c"
    break;

  case 569: /* no_angle_bracket_const_expr: no_angle_bracket_const_expr '%' no_angle_bracket_const_expr  */
#line 3326 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('%', (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 7992 "built/tmp/cppBison.yxx.c"
    break;

  case 570: /* no_angle_bracket_const_expr: no_angle_bracket_const_expr '+' no_angle_bracket_const_expr  */
#line 3330 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('+', (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8000 "built/tmp/cppBison.yxx.c"
    break;

  case 571: /* no_angle_bracket_const_expr: no_angle_bracket_const_expr '-' no_angle_bracket_const_expr  */
#line 3334 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('-', (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8008 "built/tmp/cppBison.yxx.c"
    break;

  case 572: /* no_angle_bracket_const_expr: no_angle_bracket_const_expr '|' no_angle_bracket_const_expr  */
#line 3338 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('|', (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8016 "built/tmp/cppBison.yxx.c"
    break;

  case 573: /* no_angle_bracket_const_expr: no_angle_bracket_const_expr '^' no_angle_bracket_const_expr  */
#line 3342 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('^', (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8024 "built/tmp/cppBison.yxx.c"
    break;

  case 574: /* no_angle_bracket_const_expr: no_angle_bracket_const_expr '&' no_angle_bracket_const_expr  */
#line 3346 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('&', (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8032 "built/tmp/cppBison.yxx.c"
    break;

  case 575: /* no_angle_bracket_const_expr: no_angle_bracket_const_expr OROR no_angle_bracket_const_expr  */
#line 3350 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(OROR, (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8040 "built/tmp/cppBison.yxx.c"
    break;

  case 576: /* no_angle_bracket_const_expr: no_angle_bracket_const_expr ANDAND no_angle_bracket_const_expr  */
#line 3354 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(ANDAND, (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8048 "built/tmp/cppBison.yxx.c"
    break;

  case 577: /* no_angle_bracket_const_expr: no_angle_bracket_const_expr EQCOMPARE no_angle_bracket_const_expr  */
#line 3358 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(EQCOMPARE, (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8056 "built/tmp/cppBison.yxx.c"
    break;

  case 578: /* no_angle_bracket_const_expr: no_angle_bracket_const_expr NECOMPARE no_angle_bracket_const_expr  */
#line 3362 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(NECOMPARE, (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8064 "built/tmp/cppBison.yxx.c"
    break;

  case 579: /* no_angle_bracket_const_expr: no_angle_bracket_const_expr LECOMPARE no_angle_bracket_const_expr  */
#line 3366 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(LECOMPARE, (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8072 "built/tmp/cppBison.yxx.c"
    break;

  case 580: /* no_angle_bracket_const_expr: no_angle_bracket_const_expr GECOMPARE no_angle_bracket_const_expr  */
#line 3370 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(GECOMPARE, (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8080 "built/tmp/cppBison.yxx.c"
    break;

  case 581: /* no_angle_bracket_const_expr: no_angle_bracket_const_expr LSHIFT no_angle_bracket_const_expr  */
#line 3374 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(LSHIFT, (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8088 "built/tmp/cppBison.yxx.c"
    break;

  case 582: /* no_angle_bracket_const_expr: no_angle_bracket_const_expr RSHIFT no_angle_bracket_const_expr  */
#line 3378 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(RSHIFT, (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8096 "built/tmp/cppBison.yxx.c"
    break;

  case 583: /* no_angle_bracket_const_expr: no_angle_bracket_const_expr '?' no_angle_bracket_const_expr ':' no_angle_bracket_const_expr  */
#line 3382 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('?', (yyvsp[-4].u.expr), (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8104 "built/tmp/cppBison.yxx.c"
    break;

  case 584: /* no_angle_bracket_const_expr: no_angle_bracket_const_expr '[' const_expr ']'  */
#line 3386 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('[', (yyvsp[-3].u.expr), (yyvsp[-1].u.expr));
}
#line 8112 "built/tmp/cppBison.yxx.c"
    break;

  case 585: /* no_angle_bracket_const_expr: no_angle_bracket_const_expr '(' const_expr_comma ')'  */
#line 3390 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('f', (yyvsp[-3].u.expr), (yyvsp[-1].u.expr));
}
#line 8120 "built/tmp/cppBison.yxx.c"
    break;

  case 586: /* no_angle_bracket_const_expr: no_angle_bracket_const_expr '(' ')'  */
#line 3394 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('f', (yyvsp[-2].u.expr));
}
#line 8128 "built/tmp/cppBison.yxx.c"
    break;

  case 587: /* no_angle_bracket_const_expr: no_angle_bracket_const_expr '.' name  */
#line 3398 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('.', (yyvsp[-2].u.expr), new CPPExpression((yyvsp[0].u.identifier), current_scope, global_scope, current_lexer));
}
#line 8136 "built/tmp/cppBison.yxx.c"
    break;

  case 588: /* no_angle_bracket_const_expr: no_angle_bracket_const_expr POINTSAT no_angle_bracket_const_expr  */
#line 3402 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(POINTSAT, (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8144 "built/tmp/cppBison.yxx.c"
    break;

  case 589: /* no_angle_bracket_const_expr: '(' const_expr_comma ')'  */
#line 3406 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = (yyvsp[-1].u.expr);
}
#line 8152 "built/tmp/cppBison.yxx.c"
    break;

  case 590: /* const_expr: const_operand  */
#line 3414 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = (yyvsp[0].u.expr);
}
#line 8160 "built/tmp/cppBison.yxx.c"
    break;

  case 591: /* const_expr: '(' full_type ')' const_expr  */
#line 3418 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::typecast_op((yyvsp[-2].u.type), (yyvsp[0].u.expr)));
}
#line 8168 "built/tmp/cppBison.yxx.c"
    break;

  case 592: /* const_expr: KW_STATIC_CAST '<' full_type '>' '(' const_expr_comma ')'  */
#line 3422 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::typecast_op((yyvsp[-4].u.type), (yyvsp[-1].u.expr), CPPExpression::T_static_cast));
}
#line 8176 "built/tmp/cppBison.yxx.c"
    break;

  case 593: /* const_expr: KW_DYNAMIC_CAST '<' full_type '>' '(' const_expr_comma ')'  */
#line 3426 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::typecast_op((yyvsp[-4].u.type), (yyvsp[-1].u.expr), CPPExpression::T_dynamic_cast));
}
#line 8184 "built/tmp/cppBison.yxx.c"
    break;

  case 594: /* const_expr: KW_CONST_CAST '<' full_type '>' '(' const_expr_comma ')'  */
#line 3430 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::typecast_op((yyvsp[-4].u.type), (yyvsp[-1].u.expr), CPPExpression::T_const_cast));
}
#line 8192 "built/tmp/cppBison.yxx.c"
    break;

  case 595: /* const_expr: KW_REINTERPRET_CAST '<' full_type '>' '(' const_expr_comma ')'  */
#line 3434 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::typecast_op((yyvsp[-4].u.type), (yyvsp[-1].u.expr), CPPExpression::T_reinterpret_cast));
}
#line 8200 "built/tmp/cppBison.yxx.c"
    break;

  case 596: /* const_expr: TYPENAME_IDENTIFIER '(' optional_const_expr_comma ')'  */
#line 3438 "dtool/src/cppparser/cppBison.yxx"
{
  // A constructor call.
  CPPType *type = (yyvsp[-3].u.identifier)->find_type(current_scope, global_scope, false, current_lexer);
  if (type == nullptr) {
    yyerror(string("internal error resolving type ") + (yyvsp[-3].u.identifier)->get_fully_scoped_name(), (yylsp[-3]));
  }
  assert(type != nullptr);
  (yyval.u.expr) = new CPPExpression(CPPExpression::construct_op(type, (yyvsp[-1].u.expr)));
}
#line 8214 "built/tmp/cppBison.yxx.c"
    break;

  case 597: /* const_expr: TYPENAME_IDENTIFIER '{' optional_const_expr_comma '}'  */
#line 3448 "dtool/src/cppparser/cppBison.yxx"
{
  // Aggregate initialization.
  CPPType *type = (yyvsp[-3].u.identifier)->find_type(current_scope, global_scope, false, current_lexer);
  if (type == nullptr) {
    yyerror(string("internal error resolving type ") + (yyvsp[-3].u.identifier)->get_fully_scoped_name(), (yylsp[-3]));
  }
  assert(type != nullptr);
  (yyval.u.expr) = new CPPExpression(CPPExpression::aggregate_init_op(type, (yyvsp[-1].u.expr)));
}
#line 8228 "built/tmp/cppBison.yxx.c"
    break;

  case 598: /* const_expr: KW_INT '(' optional_const_expr_comma ')'  */
#line 3458 "dtool/src/cppparser/cppBison.yxx"
{
  CPPType *type =
    CPPType::new_type(new CPPSimpleType(CPPSimpleType::T_int));
  (yyval.u.expr) = new CPPExpression(CPPExpression::construct_op(type, (yyvsp[-1].u.expr)));
}
#line 8238 "built/tmp/cppBison.yxx.c"
    break;

  case 599: /* const_expr: KW_CHAR '(' optional_const_expr_comma ')'  */
#line 3464 "dtool/src/cppparser/cppBison.yxx"
{
  CPPType *type =
    CPPType::new_type(new CPPSimpleType(CPPSimpleType::T_char));
  (yyval.u.expr) = new CPPExpression(CPPExpression::construct_op(type, (yyvsp[-1].u.expr)));
}
#line 8248 "built/tmp/cppBison.yxx.c"
    break;

  case 600: /* const_expr: KW_WCHAR_T '(' optional_const_expr_comma ')'  */
#line 3470 "dtool/src/cppparser/cppBison.yxx"
{
  CPPType *type =
    CPPType::new_type(new CPPSimpleType(CPPSimpleType::T_wchar_t));
  (yyval.u.expr) = new CPPExpression(CPPExpression::construct_op(type, (yyvsp[-1].u.expr)));
}
#line 8258 "built/tmp/cppBison.yxx.c"
    break;

  case 601: /* const_expr: KW_CHAR16_T '(' optional_const_expr_comma ')'  */
#line 3476 "dtool/src/cppparser/cppBison.yxx"
{
  CPPType *type =
    CPPType::new_type(new CPPSimpleType(CPPSimpleType::T_char16_t));
  (yyval.u.expr) = new CPPExpression(CPPExpression::construct_op(type, (yyvsp[-1].u.expr)));
}
#line 8268 "built/tmp/cppBison.yxx.c"
    break;

  case 602: /* const_expr: KW_CHAR32_T '(' optional_const_expr_comma ')'  */
#line 3482 "dtool/src/cppparser/cppBison.yxx"
{
  CPPType *type =
    CPPType::new_type(new CPPSimpleType(CPPSimpleType::T_char32_t));
  (yyval.u.expr) = new CPPExpression(CPPExpression::construct_op(type, (yyvsp[-1].u.expr)));
}
#line 8278 "built/tmp/cppBison.yxx.c"
    break;

  case 603: /* const_expr: KW_BOOL '(' optional_const_expr_comma ')'  */
#line 3488 "dtool/src/cppparser/cppBison.yxx"
{
  CPPType *type =
    CPPType::new_type(new CPPSimpleType(CPPSimpleType::T_bool));
  (yyval.u.expr) = new CPPExpression(CPPExpression::construct_op(type, (yyvsp[-1].u.expr)));
}
#line 8288 "built/tmp/cppBison.yxx.c"
    break;

  case 604: /* const_expr: KW_SHORT '(' optional_const_expr_comma ')'  */
#line 3494 "dtool/src/cppparser/cppBison.yxx"
{
  CPPType *type =
    CPPType::new_type(new CPPSimpleType(CPPSimpleType::T_int,
                                        CPPSimpleType::F_short));
  (yyval.u.expr) = new CPPExpression(CPPExpression::construct_op(type, (yyvsp[-1].u.expr)));
}
#line 8299 "built/tmp/cppBison.yxx.c"
    break;

  case 605: /* const_expr: KW_LONG '(' optional_const_expr_comma ')'  */
#line 3501 "dtool/src/cppparser/cppBison.yxx"
{
  CPPType *type =
    CPPType::new_type(new CPPSimpleType(CPPSimpleType::T_int,
                                        CPPSimpleType::F_long));
  (yyval.u.expr) = new CPPExpression(CPPExpression::construct_op(type, (yyvsp[-1].u.expr)));
}
#line 8310 "built/tmp/cppBison.yxx.c"
    break;

  case 606: /* const_expr: KW_UNSIGNED '(' optional_const_expr_comma ')'  */
#line 3508 "dtool/src/cppparser/cppBison.yxx"
{
  CPPType *type =
    CPPType::new_type(new CPPSimpleType(CPPSimpleType::T_int,
                                        CPPSimpleType::F_unsigned));
  (yyval.u.expr) = new CPPExpression(CPPExpression::construct_op(type, (yyvsp[-1].u.expr)));
}
#line 8321 "built/tmp/cppBison.yxx.c"
    break;

  case 607: /* const_expr: KW_SIGNED '(' optional_const_expr_comma ')'  */
#line 3515 "dtool/src/cppparser/cppBison.yxx"
{
  CPPType *type =
    CPPType::new_type(new CPPSimpleType(CPPSimpleType::T_int,
                                        CPPSimpleType::F_signed));
  (yyval.u.expr) = new CPPExpression(CPPExpression::construct_op(type, (yyvsp[-1].u.expr)));
}
#line 8332 "built/tmp/cppBison.yxx.c"
    break;

  case 608: /* const_expr: KW_FLOAT '(' optional_const_expr_comma ')'  */
#line 3522 "dtool/src/cppparser/cppBison.yxx"
{
  CPPType *type =
    CPPType::new_type(new CPPSimpleType(CPPSimpleType::T_float));
  (yyval.u.expr) = new CPPExpression(CPPExpression::construct_op(type, (yyvsp[-1].u.expr)));
}
#line 8342 "built/tmp/cppBison.yxx.c"
    break;

  case 609: /* const_expr: KW_DOUBLE '(' optional_const_expr_comma ')'  */
#line 3528 "dtool/src/cppparser/cppBison.yxx"
{
  CPPType *type =
    CPPType::new_type(new CPPSimpleType(CPPSimpleType::T_double));
  (yyval.u.expr) = new CPPExpression(CPPExpression::construct_op(type, (yyvsp[-1].u.expr)));
}
#line 8352 "built/tmp/cppBison.yxx.c"
    break;

  case 610: /* const_expr: KW_SIZEOF '(' full_type ')'  */
#line 3534 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::sizeof_func((yyvsp[-1].u.type)));
}
#line 8360 "built/tmp/cppBison.yxx.c"
    break;

  case 611: /* const_expr: KW_SIZEOF const_expr  */
#line 3538 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::sizeof_func((yyvsp[0].u.expr)));
}
#line 8368 "built/tmp/cppBison.yxx.c"
    break;

  case 612: /* const_expr: KW_SIZEOF ELLIPSIS '(' name ')'  */
#line 3542 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::sizeof_ellipsis_func((yyvsp[-1].u.identifier)));
}
#line 8376 "built/tmp/cppBison.yxx.c"
    break;

  case 613: /* const_expr: KW_ALIGNOF '(' full_type ')'  */
#line 3546 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::alignof_func((yyvsp[-1].u.type)));
}
#line 8384 "built/tmp/cppBison.yxx.c"
    break;

  case 614: /* const_expr: KW_NEW predefined_type  */
#line 3550 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::new_op((yyvsp[0].u.type)));
}
#line 8392 "built/tmp/cppBison.yxx.c"
    break;

  case 615: /* const_expr: KW_NEW predefined_type '(' optional_const_expr_comma ')'  */
#line 3554 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::new_op((yyvsp[-3].u.type), (yyvsp[-1].u.expr)));
}
#line 8400 "built/tmp/cppBison.yxx.c"
    break;

  case 616: /* const_expr: KW_TYPEID '(' full_type ')'  */
#line 3558 "dtool/src/cppparser/cppBison.yxx"
{
  CPPIdentifier ident("");
  ident.add_name("std");
  ident.add_name("type_info");
  CPPType *std_type_info = ident.find_type(current_scope, global_scope, false, current_lexer);
  if (!std_type_info) {
    yywarning("cannot use typeid before including <typeinfo>", (yylsp[-3]));
  }
  (yyval.u.expr) = new CPPExpression(CPPExpression::typeid_op((yyvsp[-1].u.type), std_type_info));
}
#line 8415 "built/tmp/cppBison.yxx.c"
    break;

  case 617: /* const_expr: KW_TYPEID '(' const_expr ')'  */
#line 3569 "dtool/src/cppparser/cppBison.yxx"
{
  CPPIdentifier ident("");
  ident.add_name("std");
  ident.add_name("type_info");
  CPPType *std_type_info = ident.find_type(current_scope, global_scope, false, current_lexer);
  if (!std_type_info) {
    yywarning("cannot use typeid before including <typeinfo>", (yylsp[-3]));
  }
  (yyval.u.expr) = new CPPExpression(CPPExpression::typeid_op((yyvsp[-1].u.expr), std_type_info));
}
#line 8430 "built/tmp/cppBison.yxx.c"
    break;

  case 618: /* const_expr: '!' const_expr  */
#line 3580 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(UNARY_NOT, (yyvsp[0].u.expr));
}
#line 8438 "built/tmp/cppBison.yxx.c"
    break;

  case 619: /* const_expr: '~' const_expr  */
#line 3584 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(UNARY_NEGATE, (yyvsp[0].u.expr));
}
#line 8446 "built/tmp/cppBison.yxx.c"
    break;

  case 620: /* const_expr: '-' const_expr  */
#line 3588 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(UNARY_MINUS, (yyvsp[0].u.expr));
}
#line 8454 "built/tmp/cppBison.yxx.c"
    break;

  case 621: /* const_expr: '+' const_expr  */
#line 3592 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(UNARY_PLUS, (yyvsp[0].u.expr));
}
#line 8462 "built/tmp/cppBison.yxx.c"
    break;

  case 622: /* const_expr: '*' const_expr  */
#line 3596 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(UNARY_STAR, (yyvsp[0].u.expr));
}
#line 8470 "built/tmp/cppBison.yxx.c"
    break;

  case 623: /* const_expr: '&' const_expr  */
#line 3600 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(UNARY_REF, (yyvsp[0].u.expr));
}
#line 8478 "built/tmp/cppBison.yxx.c"
    break;

  case 624: /* const_expr: const_expr '*' const_expr  */
#line 3604 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('*', (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8486 "built/tmp/cppBison.yxx.c"
    break;

  case 625: /* const_expr: const_expr '/' const_expr  */
#line 3608 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('/', (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8494 "built/tmp/cppBison.yxx.c"
    break;

  case 626: /* const_expr: const_expr '%' const_expr  */
#line 3612 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('%', (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8502 "built/tmp/cppBison.yxx.c"
    break;

  case 627: /* const_expr: const_expr '+' const_expr  */
#line 3616 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('+', (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8510 "built/tmp/cppBison.yxx.c"
    break;

  case 628: /* const_expr: const_expr '-' const_expr  */
#line 3620 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('-', (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8518 "built/tmp/cppBison.yxx.c"
    break;

  case 629: /* const_expr: const_expr '|' const_expr  */
#line 3624 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('|', (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8526 "built/tmp/cppBison.yxx.c"
    break;

  case 630: /* const_expr: const_expr '^' const_expr  */
#line 3628 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('^', (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8534 "built/tmp/cppBison.yxx.c"
    break;

  case 631: /* const_expr: const_expr '&' const_expr  */
#line 3632 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('&', (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8542 "built/tmp/cppBison.yxx.c"
    break;

  case 632: /* const_expr: const_expr OROR const_expr  */
#line 3636 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(OROR, (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8550 "built/tmp/cppBison.yxx.c"
    break;

  case 633: /* const_expr: const_expr ANDAND const_expr  */
#line 3640 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(ANDAND, (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8558 "built/tmp/cppBison.yxx.c"
    break;

  case 634: /* const_expr: const_expr EQCOMPARE const_expr  */
#line 3644 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(EQCOMPARE, (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8566 "built/tmp/cppBison.yxx.c"
    break;

  case 635: /* const_expr: const_expr NECOMPARE const_expr  */
#line 3648 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(NECOMPARE, (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8574 "built/tmp/cppBison.yxx.c"
    break;

  case 636: /* const_expr: const_expr LECOMPARE const_expr  */
#line 3652 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(LECOMPARE, (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8582 "built/tmp/cppBison.yxx.c"
    break;

  case 637: /* const_expr: const_expr GECOMPARE const_expr  */
#line 3656 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(GECOMPARE, (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8590 "built/tmp/cppBison.yxx.c"
    break;

  case 638: /* const_expr: const_expr '<' const_expr  */
#line 3660 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('<', (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8598 "built/tmp/cppBison.yxx.c"
    break;

  case 639: /* const_expr: const_expr '>' const_expr  */
#line 3664 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('>', (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8606 "built/tmp/cppBison.yxx.c"
    break;

  case 640: /* const_expr: const_expr LSHIFT const_expr  */
#line 3668 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(LSHIFT, (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8614 "built/tmp/cppBison.yxx.c"
    break;

  case 641: /* const_expr: const_expr RSHIFT const_expr  */
#line 3672 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(RSHIFT, (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8622 "built/tmp/cppBison.yxx.c"
    break;

  case 642: /* const_expr: const_expr '?' const_expr ':' const_expr  */
#line 3676 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('?', (yyvsp[-4].u.expr), (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8630 "built/tmp/cppBison.yxx.c"
    break;

  case 643: /* const_expr: const_expr '[' const_expr ']'  */
#line 3680 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('[', (yyvsp[-3].u.expr), (yyvsp[-1].u.expr));
}
#line 8638 "built/tmp/cppBison.yxx.c"
    break;

  case 644: /* const_expr: const_expr '(' const_expr_comma ')'  */
#line 3684 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('f', (yyvsp[-3].u.expr), (yyvsp[-1].u.expr));
}
#line 8646 "built/tmp/cppBison.yxx.c"
    break;

  case 645: /* const_expr: const_expr '(' ')'  */
#line 3688 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('f', (yyvsp[-2].u.expr));
}
#line 8654 "built/tmp/cppBison.yxx.c"
    break;

  case 646: /* const_expr: const_expr '.' name  */
#line 3692 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('.', (yyvsp[-2].u.expr), new CPPExpression((yyvsp[0].u.identifier), current_scope, global_scope, current_lexer));
}
#line 8662 "built/tmp/cppBison.yxx.c"
    break;

  case 647: /* const_expr: const_expr POINTSAT const_expr  */
#line 3696 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(POINTSAT, (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 8670 "built/tmp/cppBison.yxx.c"
    break;

  case 648: /* const_expr: '(' const_expr_comma ')'  */
#line 3700 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = (yyvsp[-1].u.expr);
}
#line 8678 "built/tmp/cppBison.yxx.c"
    break;

  case 649: /* const_operand: INTEGER  */
#line 3707 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression((yyvsp[0].u.integer));
}
#line 8686 "built/tmp/cppBison.yxx.c"
    break;

  case 650: /* const_operand: KW_TRUE  */
#line 3711 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(true);
}
#line 8694 "built/tmp/cppBison.yxx.c"
    break;

  case 651: /* const_operand: KW_FALSE  */
#line 3715 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(false);
}
#line 8702 "built/tmp/cppBison.yxx.c"
    break;

  case 652: /* const_operand: CHAR_TOK  */
#line 3719 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression((yyvsp[0].u.integer));
}
#line 8710 "built/tmp/cppBison.yxx.c"
    break;

  case 653: /* const_operand: REAL  */
#line 3723 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression((yyvsp[0].u.real));
}
#line 8718 "built/tmp/cppBison.yxx.c"
    break;

  case 654: /* const_operand: string_literal  */
#line 3727 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = (yyvsp[0].u.expr);
}
#line 8726 "built/tmp/cppBison.yxx.c"
    break;

  case 655: /* const_operand: CUSTOM_LITERAL  */
#line 3731 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = (yyvsp[0].u.expr);
}
#line 8734 "built/tmp/cppBison.yxx.c"
    break;

  case 656: /* const_operand: IDENTIFIER  */
#line 3735 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression((yyvsp[0].u.identifier), current_scope, global_scope, current_lexer);
}
#line 8742 "built/tmp/cppBison.yxx.c"
    break;

  case 657: /* const_operand: KW_FINAL  */
#line 3739 "dtool/src/cppparser/cppBison.yxx"
{
  // A variable named "final".  C++11 explicitly permits this.
  CPPIdentifier *ident = new CPPIdentifier("final", (yylsp[0]));
  (yyval.u.expr) = new CPPExpression(ident, current_scope, global_scope, current_lexer);
}
#line 8752 "built/tmp/cppBison.yxx.c"
    break;

  case 658: /* const_operand: KW_OVERRIDE  */
#line 3745 "dtool/src/cppparser/cppBison.yxx"
{
  // A variable named "override".  C++11 explicitly permits this.
  CPPIdentifier *ident = new CPPIdentifier("override", (yylsp[0]));
  (yyval.u.expr) = new CPPExpression(ident, current_scope, global_scope, current_lexer);
}
#line 8762 "built/tmp/cppBison.yxx.c"
    break;

  case 659: /* const_operand: KW_NULLPTR  */
#line 3751 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::get_nullptr());
}
#line 8770 "built/tmp/cppBison.yxx.c"
    break;

  case 660: /* const_operand: '[' capture_list ']' function_post maybe_trailing_return_type '{' code '}'  */
#line 3755 "dtool/src/cppparser/cppBison.yxx"
{
  (yyvsp[-6].u.closure_type)->_flags = (yyvsp[-4].u.integer);
  (yyvsp[-6].u.closure_type)->_return_type = (yyvsp[-3].u.type);
  (yyval.u.expr) = new CPPExpression(CPPExpression::lambda((yyvsp[-6].u.closure_type)));
}
#line 8780 "built/tmp/cppBison.yxx.c"
    break;

  case 661: /* const_operand: '[' capture_list ']' '(' function_parameter_list ')' function_post maybe_trailing_return_type '{' code '}'  */
#line 3761 "dtool/src/cppparser/cppBison.yxx"
{
  (yyvsp[-9].u.closure_type)->_parameters = (yyvsp[-6].u.param_list);
  (yyvsp[-9].u.closure_type)->_flags = (yyvsp[-4].u.integer);
  (yyvsp[-9].u.closure_type)->_return_type = (yyvsp[-3].u.type);
  (yyval.u.expr) = new CPPExpression(CPPExpression::lambda((yyvsp[-9].u.closure_type)));
}
#line 8791 "built/tmp/cppBison.yxx.c"
    break;

  case 662: /* const_operand: KW_HAS_VIRTUAL_DESTRUCTOR '(' full_type ')'  */
#line 3768 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::type_trait(KW_HAS_VIRTUAL_DESTRUCTOR, (yyvsp[-1].u.type)));
}
#line 8799 "built/tmp/cppBison.yxx.c"
    break;

  case 663: /* const_operand: KW_IS_ABSTRACT '(' full_type ')'  */
#line 3772 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::type_trait(KW_IS_ABSTRACT, (yyvsp[-1].u.type)));
}
#line 8807 "built/tmp/cppBison.yxx.c"
    break;

  case 664: /* const_operand: KW_IS_BASE_OF '(' full_type ',' full_type ')'  */
#line 3776 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::type_trait(KW_IS_CLASS, (yyvsp[-3].u.type), (yyvsp[-1].u.type)));
}
#line 8815 "built/tmp/cppBison.yxx.c"
    break;

  case 665: /* const_operand: KW_IS_CLASS '(' full_type ')'  */
#line 3780 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::type_trait(KW_IS_CLASS, (yyvsp[-1].u.type)));
}
#line 8823 "built/tmp/cppBison.yxx.c"
    break;

  case 666: /* const_operand: KW_IS_CONSTRUCTIBLE '(' full_type ')'  */
#line 3784 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::type_trait(KW_IS_CONSTRUCTIBLE, (yyvsp[-1].u.type)));
}
#line 8831 "built/tmp/cppBison.yxx.c"
    break;

  case 667: /* const_operand: KW_IS_CONSTRUCTIBLE '(' full_type ',' full_type ')'  */
#line 3788 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::type_trait(KW_IS_CONSTRUCTIBLE, (yyvsp[-3].u.type), (yyvsp[-1].u.type)));
}
#line 8839 "built/tmp/cppBison.yxx.c"
    break;

  case 668: /* const_operand: KW_IS_CONVERTIBLE_TO '(' full_type ',' full_type ')'  */
#line 3792 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::type_trait(KW_IS_CONVERTIBLE_TO, (yyvsp[-3].u.type), (yyvsp[-1].u.type)));
}
#line 8847 "built/tmp/cppBison.yxx.c"
    break;

  case 669: /* const_operand: KW_IS_DESTRUCTIBLE '(' full_type ')'  */
#line 3796 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::type_trait(KW_IS_DESTRUCTIBLE, (yyvsp[-1].u.type)));
}
#line 8855 "built/tmp/cppBison.yxx.c"
    break;

  case 670: /* const_operand: KW_IS_EMPTY '(' full_type ')'  */
#line 3800 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::type_trait(KW_IS_EMPTY, (yyvsp[-1].u.type)));
}
#line 8863 "built/tmp/cppBison.yxx.c"
    break;

  case 671: /* const_operand: KW_IS_ENUM '(' full_type ')'  */
#line 3804 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::type_trait(KW_IS_ENUM, (yyvsp[-1].u.type)));
}
#line 8871 "built/tmp/cppBison.yxx.c"
    break;

  case 672: /* const_operand: KW_IS_FINAL '(' full_type ')'  */
#line 3808 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::type_trait(KW_IS_FINAL, (yyvsp[-1].u.type)));
}
#line 8879 "built/tmp/cppBison.yxx.c"
    break;

  case 673: /* const_operand: KW_IS_FUNDAMENTAL '(' full_type ')'  */
#line 3812 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::type_trait(KW_IS_FUNDAMENTAL, (yyvsp[-1].u.type)));
}
#line 8887 "built/tmp/cppBison.yxx.c"
    break;

  case 674: /* const_operand: KW_IS_POD '(' full_type ')'  */
#line 3816 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::type_trait(KW_IS_POD, (yyvsp[-1].u.type)));
}
#line 8895 "built/tmp/cppBison.yxx.c"
    break;

  case 675: /* const_operand: KW_IS_POLYMORPHIC '(' full_type ')'  */
#line 3820 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::type_trait(KW_IS_POLYMORPHIC, (yyvsp[-1].u.type)));
}
#line 8903 "built/tmp/cppBison.yxx.c"
    break;

  case 676: /* const_operand: KW_IS_STANDARD_LAYOUT '(' full_type ')'  */
#line 3824 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::type_trait(KW_IS_STANDARD_LAYOUT, (yyvsp[-1].u.type)));
}
#line 8911 "built/tmp/cppBison.yxx.c"
    break;

  case 677: /* const_operand: KW_IS_TRIVIAL '(' full_type ')'  */
#line 3828 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::type_trait(KW_IS_TRIVIAL, (yyvsp[-1].u.type)));
}
#line 8919 "built/tmp/cppBison.yxx.c"
    break;

  case 678: /* const_operand: KW_IS_UNION '(' full_type ')'  */
#line 3832 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::type_trait(KW_IS_UNION, (yyvsp[-1].u.type)));
}
#line 8927 "built/tmp/cppBison.yxx.c"
    break;

  case 679: /* formal_const_expr: formal_const_operand  */
#line 3846 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = (yyvsp[0].u.expr);
}
#line 8935 "built/tmp/cppBison.yxx.c"
    break;

  case 680: /* formal_const_expr: '(' full_type ')' const_expr  */
#line 3850 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::typecast_op((yyvsp[-2].u.type), (yyvsp[0].u.expr)));
}
#line 8943 "built/tmp/cppBison.yxx.c"
    break;

  case 681: /* formal_const_expr: KW_STATIC_CAST '<' full_type '>' '(' const_expr_comma ')'  */
#line 3854 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::typecast_op((yyvsp[-4].u.type), (yyvsp[-1].u.expr), CPPExpression::T_static_cast));
}
#line 8951 "built/tmp/cppBison.yxx.c"
    break;

  case 682: /* formal_const_expr: KW_DYNAMIC_CAST '<' full_type '>' '(' const_expr_comma ')'  */
#line 3858 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::typecast_op((yyvsp[-4].u.type), (yyvsp[-1].u.expr), CPPExpression::T_dynamic_cast));
}
#line 8959 "built/tmp/cppBison.yxx.c"
    break;

  case 683: /* formal_const_expr: KW_CONST_CAST '<' full_type '>' '(' const_expr_comma ')'  */
#line 3862 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::typecast_op((yyvsp[-4].u.type), (yyvsp[-1].u.expr), CPPExpression::T_const_cast));
}
#line 8967 "built/tmp/cppBison.yxx.c"
    break;

  case 684: /* formal_const_expr: KW_REINTERPRET_CAST '<' full_type '>' '(' const_expr_comma ')'  */
#line 3866 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::typecast_op((yyvsp[-4].u.type), (yyvsp[-1].u.expr), CPPExpression::T_reinterpret_cast));
}
#line 8975 "built/tmp/cppBison.yxx.c"
    break;

  case 685: /* formal_const_expr: KW_SIZEOF '(' full_type ')'  */
#line 3870 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::sizeof_func((yyvsp[-1].u.type)));
}
#line 8983 "built/tmp/cppBison.yxx.c"
    break;

  case 686: /* formal_const_expr: KW_SIZEOF formal_const_expr  */
#line 3874 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::sizeof_func((yyvsp[0].u.expr)));
}
#line 8991 "built/tmp/cppBison.yxx.c"
    break;

  case 687: /* formal_const_expr: KW_SIZEOF ELLIPSIS '(' name ')'  */
#line 3878 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::sizeof_ellipsis_func((yyvsp[-1].u.identifier)));
}
#line 8999 "built/tmp/cppBison.yxx.c"
    break;

  case 688: /* formal_const_expr: KW_ALIGNOF '(' full_type ')'  */
#line 3882 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::alignof_func((yyvsp[-1].u.type)));
}
#line 9007 "built/tmp/cppBison.yxx.c"
    break;

  case 689: /* formal_const_expr: KW_NEW predefined_type  */
#line 3886 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::new_op((yyvsp[0].u.type)));
}
#line 9015 "built/tmp/cppBison.yxx.c"
    break;

  case 690: /* formal_const_expr: KW_NEW predefined_type '(' optional_const_expr_comma ')'  */
#line 3890 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::new_op((yyvsp[-3].u.type), (yyvsp[-1].u.expr)));
}
#line 9023 "built/tmp/cppBison.yxx.c"
    break;

  case 691: /* formal_const_expr: KW_TYPEID '(' full_type ')'  */
#line 3894 "dtool/src/cppparser/cppBison.yxx"
{
  CPPIdentifier ident("");
  ident.add_name("std");
  ident.add_name("type_info");
  CPPType *std_type_info = ident.find_type(current_scope, global_scope, false, current_lexer);
  if (!std_type_info) {
    yywarning("cannot use typeid before including <typeinfo>", (yylsp[-3]));
  }
  (yyval.u.expr) = new CPPExpression(CPPExpression::typeid_op((yyvsp[-1].u.type), std_type_info));
}
#line 9038 "built/tmp/cppBison.yxx.c"
    break;

  case 692: /* formal_const_expr: KW_TYPEID '(' const_expr ')'  */
#line 3905 "dtool/src/cppparser/cppBison.yxx"
{
  CPPIdentifier ident("");
  ident.add_name("std");
  ident.add_name("type_info");
  CPPType *std_type_info = ident.find_type(current_scope, global_scope, false, current_lexer);
  if (!std_type_info) {
    yywarning("cannot use typeid before including <typeinfo>", (yylsp[-3]));
  }
  (yyval.u.expr) = new CPPExpression(CPPExpression::typeid_op((yyvsp[-1].u.expr), std_type_info));
}
#line 9053 "built/tmp/cppBison.yxx.c"
    break;

  case 693: /* formal_const_expr: '!' const_expr  */
#line 3916 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(UNARY_NOT, (yyvsp[0].u.expr));
}
#line 9061 "built/tmp/cppBison.yxx.c"
    break;

  case 694: /* formal_const_expr: '~' const_expr  */
#line 3920 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(UNARY_NEGATE, (yyvsp[0].u.expr));
}
#line 9069 "built/tmp/cppBison.yxx.c"
    break;

  case 695: /* formal_const_expr: '-' const_expr  */
#line 3924 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(UNARY_MINUS, (yyvsp[0].u.expr));
}
#line 9077 "built/tmp/cppBison.yxx.c"
    break;

  case 696: /* formal_const_expr: '+' const_expr  */
#line 3928 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(UNARY_PLUS, (yyvsp[0].u.expr));
}
#line 9085 "built/tmp/cppBison.yxx.c"
    break;

  case 697: /* formal_const_expr: '&' const_expr  */
#line 3932 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(UNARY_REF, (yyvsp[0].u.expr));
}
#line 9093 "built/tmp/cppBison.yxx.c"
    break;

  case 698: /* formal_const_expr: formal_const_expr '*' const_expr  */
#line 3936 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('*', (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 9101 "built/tmp/cppBison.yxx.c"
    break;

  case 699: /* formal_const_expr: formal_const_expr '/' const_expr  */
#line 3940 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('/', (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 9109 "built/tmp/cppBison.yxx.c"
    break;

  case 700: /* formal_const_expr: formal_const_expr '%' const_expr  */
#line 3944 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('%', (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 9117 "built/tmp/cppBison.yxx.c"
    break;

  case 701: /* formal_const_expr: formal_const_expr '+' const_expr  */
#line 3948 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('+', (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 9125 "built/tmp/cppBison.yxx.c"
    break;

  case 702: /* formal_const_expr: formal_const_expr '-' const_expr  */
#line 3952 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('-', (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 9133 "built/tmp/cppBison.yxx.c"
    break;

  case 703: /* formal_const_expr: formal_const_expr '|' const_expr  */
#line 3956 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('|', (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 9141 "built/tmp/cppBison.yxx.c"
    break;

  case 704: /* formal_const_expr: formal_const_expr '^' const_expr  */
#line 3960 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('^', (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 9149 "built/tmp/cppBison.yxx.c"
    break;

  case 705: /* formal_const_expr: formal_const_expr '&' const_expr  */
#line 3964 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('&', (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 9157 "built/tmp/cppBison.yxx.c"
    break;

  case 706: /* formal_const_expr: formal_const_expr OROR const_expr  */
#line 3968 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(OROR, (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 9165 "built/tmp/cppBison.yxx.c"
    break;

  case 707: /* formal_const_expr: formal_const_expr ANDAND const_expr  */
#line 3972 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(ANDAND, (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 9173 "built/tmp/cppBison.yxx.c"
    break;

  case 708: /* formal_const_expr: formal_const_expr EQCOMPARE const_expr  */
#line 3976 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(EQCOMPARE, (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 9181 "built/tmp/cppBison.yxx.c"
    break;

  case 709: /* formal_const_expr: formal_const_expr NECOMPARE const_expr  */
#line 3980 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(NECOMPARE, (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 9189 "built/tmp/cppBison.yxx.c"
    break;

  case 710: /* formal_const_expr: formal_const_expr LECOMPARE const_expr  */
#line 3984 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(LECOMPARE, (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 9197 "built/tmp/cppBison.yxx.c"
    break;

  case 711: /* formal_const_expr: formal_const_expr GECOMPARE const_expr  */
#line 3988 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(GECOMPARE, (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 9205 "built/tmp/cppBison.yxx.c"
    break;

  case 712: /* formal_const_expr: formal_const_expr '<' const_expr  */
#line 3992 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('<', (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 9213 "built/tmp/cppBison.yxx.c"
    break;

  case 713: /* formal_const_expr: formal_const_expr '>' const_expr  */
#line 3996 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('>', (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 9221 "built/tmp/cppBison.yxx.c"
    break;

  case 714: /* formal_const_expr: formal_const_expr LSHIFT const_expr  */
#line 4000 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(LSHIFT, (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 9229 "built/tmp/cppBison.yxx.c"
    break;

  case 715: /* formal_const_expr: formal_const_expr RSHIFT const_expr  */
#line 4004 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(RSHIFT, (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 9237 "built/tmp/cppBison.yxx.c"
    break;

  case 716: /* formal_const_expr: formal_const_expr '?' const_expr ':' const_expr  */
#line 4008 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('?', (yyvsp[-4].u.expr), (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 9245 "built/tmp/cppBison.yxx.c"
    break;

  case 717: /* formal_const_expr: formal_const_expr '[' const_expr ']'  */
#line 4012 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('[', (yyvsp[-3].u.expr), (yyvsp[-1].u.expr));
}
#line 9253 "built/tmp/cppBison.yxx.c"
    break;

  case 718: /* formal_const_expr: formal_const_expr '(' const_expr_comma ')'  */
#line 4016 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('f', (yyvsp[-3].u.expr), (yyvsp[-1].u.expr));
}
#line 9261 "built/tmp/cppBison.yxx.c"
    break;

  case 719: /* formal_const_expr: formal_const_expr '(' ')'  */
#line 4020 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('f', (yyvsp[-2].u.expr));
}
#line 9269 "built/tmp/cppBison.yxx.c"
    break;

  case 720: /* formal_const_expr: formal_const_expr '.' name  */
#line 4024 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression('.', (yyvsp[-2].u.expr), new CPPExpression((yyvsp[0].u.identifier), current_scope, global_scope, current_lexer));
}
#line 9277 "built/tmp/cppBison.yxx.c"
    break;

  case 721: /* formal_const_expr: formal_const_expr POINTSAT const_expr  */
#line 4028 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(POINTSAT, (yyvsp[-2].u.expr), (yyvsp[0].u.expr));
}
#line 9285 "built/tmp/cppBison.yxx.c"
    break;

  case 722: /* formal_const_expr: '(' const_expr_comma ')'  */
#line 4032 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = (yyvsp[-1].u.expr);
}
#line 9293 "built/tmp/cppBison.yxx.c"
    break;

  case 723: /* formal_const_operand: INTEGER  */
#line 4039 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression((yyvsp[0].u.integer));
}
#line 9301 "built/tmp/cppBison.yxx.c"
    break;

  case 724: /* formal_const_operand: KW_TRUE  */
#line 4043 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(true);
}
#line 9309 "built/tmp/cppBison.yxx.c"
    break;

  case 725: /* formal_const_operand: KW_FALSE  */
#line 4047 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(false);
}
#line 9317 "built/tmp/cppBison.yxx.c"
    break;

  case 726: /* formal_const_operand: CHAR_TOK  */
#line 4051 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression((yyvsp[0].u.integer));
}
#line 9325 "built/tmp/cppBison.yxx.c"
    break;

  case 727: /* formal_const_operand: REAL  */
#line 4055 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression((yyvsp[0].u.real));
}
#line 9333 "built/tmp/cppBison.yxx.c"
    break;

  case 728: /* formal_const_operand: string_literal  */
#line 4059 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = (yyvsp[0].u.expr);
}
#line 9341 "built/tmp/cppBison.yxx.c"
    break;

  case 729: /* formal_const_operand: CUSTOM_LITERAL  */
#line 4063 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = (yyvsp[0].u.expr);
}
#line 9349 "built/tmp/cppBison.yxx.c"
    break;

  case 730: /* formal_const_operand: IDENTIFIER  */
#line 4067 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression((yyvsp[0].u.identifier), current_scope, global_scope, current_lexer);
}
#line 9357 "built/tmp/cppBison.yxx.c"
    break;

  case 731: /* formal_const_operand: KW_FINAL  */
#line 4071 "dtool/src/cppparser/cppBison.yxx"
{
  // A variable named "final".  C++11 explicitly permits this.
  CPPIdentifier *ident = new CPPIdentifier("final", (yylsp[0]));
  (yyval.u.expr) = new CPPExpression(ident, current_scope, global_scope, current_lexer);
}
#line 9367 "built/tmp/cppBison.yxx.c"
    break;

  case 732: /* formal_const_operand: KW_OVERRIDE  */
#line 4077 "dtool/src/cppparser/cppBison.yxx"
{
  // A variable named "override".  C++11 explicitly permits this.
  CPPIdentifier *ident = new CPPIdentifier("override", (yylsp[0]));
  (yyval.u.expr) = new CPPExpression(ident, current_scope, global_scope, current_lexer);
}
#line 9377 "built/tmp/cppBison.yxx.c"
    break;

  case 733: /* formal_const_operand: KW_NULLPTR  */
#line 4083 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression(CPPExpression::get_nullptr());
}
#line 9385 "built/tmp/cppBison.yxx.c"
    break;

  case 734: /* capture_list: empty  */
#line 4091 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.closure_type) = new CPPClosureType();
}
#line 9393 "built/tmp/cppBison.yxx.c"
    break;

  case 735: /* capture_list: '='  */
#line 4095 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.closure_type) = new CPPClosureType(CPPClosureType::CT_by_value);
}
#line 9401 "built/tmp/cppBison.yxx.c"
    break;

  case 736: /* capture_list: '&'  */
#line 4099 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.closure_type) = new CPPClosureType(CPPClosureType::CT_by_reference);
}
#line 9409 "built/tmp/cppBison.yxx.c"
    break;

  case 737: /* capture_list: capture maybe_initialize  */
#line 4103 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.closure_type) = new CPPClosureType();
  (yyvsp[-1].u.capture)->_initializer = (yyvsp[0].u.expr);
  (yyval.u.closure_type)->_captures.push_back(*(yyvsp[-1].u.capture));
  delete (yyvsp[-1].u.capture);
}
#line 9420 "built/tmp/cppBison.yxx.c"
    break;

  case 738: /* capture_list: capture_list ',' capture maybe_initialize  */
#line 4110 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.closure_type) = (yyvsp[-3].u.closure_type);
  (yyvsp[-1].u.capture)->_initializer = (yyvsp[0].u.expr);
  (yyval.u.closure_type)->_captures.push_back(*(yyvsp[-1].u.capture));
  delete (yyvsp[-1].u.capture);
}
#line 9431 "built/tmp/cppBison.yxx.c"
    break;

  case 739: /* capture: '&' name  */
#line 4120 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.capture) = new CPPClosureType::Capture;
  (yyval.u.capture)->_name = (yyvsp[0].u.identifier)->get_simple_name();
  (yyval.u.capture)->_type = CPPClosureType::CT_by_reference;
}
#line 9441 "built/tmp/cppBison.yxx.c"
    break;

  case 740: /* capture: '&' name ELLIPSIS  */
#line 4126 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.capture) = new CPPClosureType::Capture;
  (yyval.u.capture)->_name = (yyvsp[-1].u.identifier)->get_simple_name();
  (yyval.u.capture)->_type = CPPClosureType::CT_by_reference;
}
#line 9451 "built/tmp/cppBison.yxx.c"
    break;

  case 741: /* capture: name  */
#line 4132 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.capture) = new CPPClosureType::Capture;
  (yyval.u.capture)->_name = (yyvsp[0].u.identifier)->get_simple_name();
  if ((yyval.u.capture)->_name == "this") {
    (yyval.u.capture)->_type = CPPClosureType::CT_by_reference;
  } else {
    (yyval.u.capture)->_type = CPPClosureType::CT_by_value;
  }
}
#line 9465 "built/tmp/cppBison.yxx.c"
    break;

  case 742: /* capture: '*' name  */
#line 4142 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.capture) = new CPPClosureType::Capture;
  (yyval.u.capture)->_name = (yyvsp[0].u.identifier)->get_simple_name();
  (yyval.u.capture)->_type = CPPClosureType::CT_by_value;
  if ((yyval.u.capture)->_name != "this") {
    yywarning("only capture name 'this' may be preceded by an asterisk", (yylsp[0]));
  }
}
#line 9478 "built/tmp/cppBison.yxx.c"
    break;

  case 743: /* class_derivation_name: name  */
#line 4154 "dtool/src/cppparser/cppBison.yxx"
{
  CPPType *type = (yyvsp[0].u.identifier)->find_type(current_scope, global_scope, true);
  if (type == nullptr) {
    type = CPPType::new_type(new CPPTBDType((yyvsp[0].u.identifier)));
  }
  (yyval.u.type) = type;
}
#line 9490 "built/tmp/cppBison.yxx.c"
    break;

  case 744: /* class_derivation_name: KW_TYPENAME name  */
#line 4162 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.type) = CPPType::new_type(new CPPTBDType((yyvsp[0].u.identifier)));
}
#line 9498 "built/tmp/cppBison.yxx.c"
    break;

  case 745: /* class_derivation_name: name ELLIPSIS  */
#line 4166 "dtool/src/cppparser/cppBison.yxx"
{
  CPPClassTemplateParameter *ctp = new CPPClassTemplateParameter((yyvsp[-1].u.identifier));
  ctp->_packed = true;
  (yyval.u.type) = CPPType::new_type(ctp);
}
#line 9508 "built/tmp/cppBison.yxx.c"
    break;

  case 746: /* name: IDENTIFIER  */
#line 4196 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.identifier) = (yyvsp[0].u.identifier);
}
#line 9516 "built/tmp/cppBison.yxx.c"
    break;

  case 747: /* name: TYPENAME_IDENTIFIER  */
#line 4200 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.identifier) = (yyvsp[0].u.identifier);
}
#line 9524 "built/tmp/cppBison.yxx.c"
    break;

  case 748: /* name: TYPEPACK_IDENTIFIER  */
#line 4204 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.identifier) = (yyvsp[0].u.identifier);
}
#line 9532 "built/tmp/cppBison.yxx.c"
    break;

  case 749: /* name: KW_FINAL  */
#line 4208 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.identifier) = new CPPIdentifier("final", (yylsp[0]));
}
#line 9540 "built/tmp/cppBison.yxx.c"
    break;

  case 750: /* name: KW_OVERRIDE  */
#line 4212 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.identifier) = new CPPIdentifier("override", (yylsp[0]));
}
#line 9548 "built/tmp/cppBison.yxx.c"
    break;

  case 751: /* name: KW_SIGNED  */
#line 4216 "dtool/src/cppparser/cppBison.yxx"
{
  // This is not a keyword in Python, so it is useful to be able to use this
  // in MAKE_PROPERTY definitions, etc.
  (yyval.u.identifier) = new CPPIdentifier("signed", (yylsp[0]));
}
#line 9558 "built/tmp/cppBison.yxx.c"
    break;

  case 752: /* name: KW_FLOAT  */
#line 4222 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.identifier) = new CPPIdentifier("float", (yylsp[0]));
}
#line 9566 "built/tmp/cppBison.yxx.c"
    break;

  case 753: /* name: KW_PUBLIC  */
#line 4226 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.identifier) = new CPPIdentifier("public", (yylsp[0]));
}
#line 9574 "built/tmp/cppBison.yxx.c"
    break;

  case 754: /* name: KW_PRIVATE  */
#line 4230 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.identifier) = new CPPIdentifier("private", (yylsp[0]));
}
#line 9582 "built/tmp/cppBison.yxx.c"
    break;

  case 755: /* name: KW_STATIC  */
#line 4234 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.identifier) = new CPPIdentifier("static", (yylsp[0]));
}
#line 9590 "built/tmp/cppBison.yxx.c"
    break;

  case 756: /* name: KW_DEFAULT  */
#line 4238 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.identifier) = new CPPIdentifier("default", (yylsp[0]));
}
#line 9598 "built/tmp/cppBison.yxx.c"
    break;

  case 757: /* name_no_final: IDENTIFIER  */
#line 4249 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.identifier) = (yyvsp[0].u.identifier);
}
#line 9606 "built/tmp/cppBison.yxx.c"
    break;

  case 758: /* name_no_final: TYPENAME_IDENTIFIER  */
#line 4253 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.identifier) = (yyvsp[0].u.identifier);
}
#line 9614 "built/tmp/cppBison.yxx.c"
    break;

  case 759: /* name_no_final: TYPEPACK_IDENTIFIER  */
#line 4257 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.identifier) = (yyvsp[0].u.identifier);
}
#line 9622 "built/tmp/cppBison.yxx.c"
    break;

  case 760: /* name_no_final: KW_OVERRIDE  */
#line 4261 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.identifier) = new CPPIdentifier("override", (yylsp[0]));
}
#line 9630 "built/tmp/cppBison.yxx.c"
    break;

  case 761: /* string_literal: SIMPLE_STRING  */
#line 4269 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = new CPPExpression((yyvsp[0].str));
}
#line 9638 "built/tmp/cppBison.yxx.c"
    break;

  case 762: /* string_literal: STRING_LITERAL  */
#line 4273 "dtool/src/cppparser/cppBison.yxx"
{
  (yyval.u.expr) = (yyvsp[0].u.expr);
}
#line 9646 "built/tmp/cppBison.yxx.c"
    break;

  case 763: /* string_literal: string_literal SIMPLE_STRING  */
#line 4277 "dtool/src/cppparser/cppBison.yxx"
{
  // The right string takes on the literal type of the left.
  (yyval.u.expr) = (yyvsp[-1].u.expr);
  (yyval.u.expr)->_str += (yyvsp[0].str);
}
#line 9656 "built/tmp/cppBison.yxx.c"
    break;

  case 764: /* string_literal: string_literal STRING_LITERAL  */
#line 4283 "dtool/src/cppparser/cppBison.yxx"
{
  // We have to check that the two literal types match up.
  (yyval.u.expr) = (yyvsp[-1].u.expr);
  if ((yyvsp[0].u.expr)->_type != CPPExpression::T_string && (yyvsp[0].u.expr)->_type != (yyvsp[-1].u.expr)->_type) {
    yywarning("cannot concatenate two string literals of different types", (yyloc));
  }
  (yyval.u.expr)->_str += (yyvsp[0].u.expr)->_str;
}
#line 9669 "built/tmp/cppBison.yxx.c"
    break;


#line 9673 "built/tmp/cppBison.yxx.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

